protoplug
=========
Create audio plugins on-the-fly with LuaJIT.

- **Official website**: http://www.osar.fr/protoplug
- **Downloads**: http://www.osar.fr/protoplug/downloads
- **Forums**: http://forums.osar.fr

Protoplug is a VST/AU plugin that lets you load and edit Lua scripts as audio effects and instruments. The scripts can process audio and MIDI, display their own interface, and use external libraries. Transform any music software into a live coding environment! 

**Cross-platform :** builds for Windows, Mac OS X and Linux. This means that all protoplug scripts are compatible with these platforms and can be loaded into a huge amount of audio software (glory to [JUCE](http://juce.com/)) 

**Fast :** Use the speed of [LuaJIT] [1], and perform DSP tasks as efficiently as old school C implementations. 

**Free and open source :** Want a new feature? Add it yourself. The source is MIT-licensed.

  [1]: http://luajit.org/


Compiling from Source
---------------------
The source is C++ and only requires system headers. Project files and Makefiles are found in the `Builds` folder. (These are generated by the [Introjucer] [3], which can generate Makefiles, Visual Studio, Code::Blocks, and XCode projects.) 

  [3]: http://www.juce.com/documentation/introjucer
  
After compiling, you'll also need the [LuaJIT] [1] shared library installed on your system or in the `ProtoplugFiles/lib` folder. The same goes for [FFTW] [4] if you want to load scripts that use that library. 

  [4]: http://fftw.org/

**Linux :** 

	tar zxf protoplug-1.3.0.tar.gz
	cd protoplug-1.3.0/Builds/multi/Linux
	make

You might get some missing includes. The required headers should be easy to obtain, for example on Debian 7 :

	sudo apt-get install libfreetype6-dev libx11-dev \
	 libasound2-dev libxinerama-dev libxcursor-dev
