/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  24 Feb 2013 3:20:37pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...

/* Copyright 2013 Kjetil S. Matheussen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */


#if _MSC_VER
#define snprintf _snprintf
#endif

#include "Radium_Compressor.h"

static Colour das_colors[16];
static Colour *g_colors = &das_colors[0];

static void init_colors(){
  das_colors[0] = Colour(0x82,0x80,0x70).brighter(0.2);
  das_colors[1] = Colour(0x00,0x00,0x1d);
  das_colors[2] = Colour(0xf1,0xec,0xe6);
  das_colors[3] = Colour(0x98,0x00,0x6d);
  das_colors[4] = Colour(0x64,0x37,0xa7);
  das_colors[5] = Colour(0x35,0x43,0x53);
  das_colors[6] = Colour(0x8b,0x67,0x35);
  das_colors[7] = Colour(0x23,0x40,0x5d);
  das_colors[8] = Colour(0x31,0x00,0x62);
  das_colors[9] = Colour(0x8a,0x88,0x77);
  das_colors[10] = Colour(0x7a,0x7a,0x7a);
  das_colors[11] = Colour(0x69,0x6c,0x5f).brighter(0.8);
  das_colors[12] = Colour(0xa1,0xb0,0x9b);
  das_colors[13] = Colour(0x13,0x51,0x1f);
  das_colors[14] = Colour(0x8a,0x00,0x00);
  das_colors[15] = Colour(0x7a,0x79,0x67);
}

#define R_MAX(a,b) (((a)>(b))?(a):(b))
#define R_MIN(a,b) (((a)<(b))?(a):(b))
#define R_ABS(a) ((a)<0?(-(a)):(a))
#define R_BOUNDARIES(a,b,c) (R_MIN(R_MAX((a),(b)),(c)))


//namespace horizontal_sliders{
//#include "Juce_MyWidget.h"
//}

//#include "Vertical_Sliders.cpp"

namespace custom_gui{

#include "Juce_MyWidget.h"
#include "MySliderPainterPainter.h"
#include "compressor_vertical_sliders.cpp"

}

//[/Headers]

#include "Radium_Compressor.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...

namespace su{
  struct SliderUpdater : public Timer{
    Radium_Compressor *radium_compressor;

    SliderUpdater(Radium_Compressor *radium_compressor)
      : radium_compressor(radium_compressor)
    {
      startTimer(50);
    }

    void timerCallback(){
      radium_compressor->check_sliders_and_checkbox_updates();
      //printf("oh yeah %p\n",editor);
    }
  };
}

void MySlider::paint(Graphics& g){
  //Slider::paint(g);
  custom_gui::cvs::MyPainter mp(&g);

  //mp.fillRect(0,0,getWidth(),getHeight(),custom_gui::cvs::MyColor(0,0,0));

  char temp[512];
  snprintf(temp,512,"%s: %.1f ms",slider_name.c_str(),value);

  SLIDERPAINTERPAINTER_paint(&mp,
                             0, 0,
                             getWidth(),
                             getHeight(),
                             true,
                             get_slider_from_attack_release(value),
                             temp,
                             false);
}


//[/MiscUserDefs]

//==============================================================================
Radium_Compressor::Radium_Compressor (Patch *patch)
    : patch (patch),
      attack_slider (0),
      release_slider (0),
      bypass_button (0),
      hyperlinkButton (0)
{
    addAndMakeVisible (attack_slider = new MySlider ("new slider"));
    attack_slider->setRange (0, 500, 0);
    attack_slider->setSliderStyle (Slider::LinearBar);
    attack_slider->setTextBoxStyle (Slider::TextBoxLeft, true, 80, 20);
    attack_slider->setColour (Slider::thumbColourId, Colour (0x6a151525));
    attack_slider->setColour (Slider::trackColourId, Colour (0x1affffff));
    attack_slider->setColour (Slider::rotarySliderOutlineColourId, Colour (0xff614141));
    attack_slider->setColour (Slider::textBoxTextColourId, Colour (0xff030611));
    attack_slider->setColour (Slider::textBoxBackgroundColourId, Colour (0x73462828));
    attack_slider->addListener (this);
    attack_slider->setSkewFactor (0.5);

    addAndMakeVisible (release_slider = new MySlider ("new slider"));
    release_slider->setRange (0, 500, 0);
    release_slider->setSliderStyle (Slider::LinearBar);
    release_slider->setTextBoxStyle (Slider::TextBoxLeft, true, 80, 20);
    release_slider->setColour (Slider::thumbColourId, Colour (0x25bbbbff));
    release_slider->setColour (Slider::trackColourId, Colour (0x1affffff));
    release_slider->setColour (Slider::textBoxTextColourId, Colour (0xec000000));
    release_slider->setColour (Slider::textBoxBackgroundColourId, Colour (0x73ffffff));
    release_slider->addListener (this);
    release_slider->setSkewFactor (0.5);

    addAndMakeVisible (bypass_button = new ToggleButton ("new toggle button"));
    bypass_button->setButtonText ("Bypass");
    bypass_button->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight | Button::ConnectedOnTop | Button::ConnectedOnBottom);
    bypass_button->addListener (this);
    bypass_button->setColour (ToggleButton::textColourId, Colour (0xff042961));

    addAndMakeVisible (hyperlinkButton = new HyperlinkButton ("Radium",
                                                              URL ("http://users.notam02.no/~kjetism/radium/")));
    hyperlinkButton->setTooltip ("http://users.notam02.no/~kjetism/radium/");
    hyperlinkButton->setButtonText ("Radium");


    //[UserPreSize]

    attack_slider->patch = patch;
    attack_slider->effect_num = COMP_EFF_ATTACK;
    attack_slider->slider_name = "Attack";

    release_slider->patch = patch;
    release_slider->effect_num = COMP_EFF_RELEASE;
    release_slider->slider_name = "Release";

    init_colors();

    comp = new custom_gui::cvs::Comp(patch,NULL);
    //printf("making visible %p\n",&comp->w);
    addAndMakeVisible(&comp->w);

    //printf("making visible %p\n",&comp->w);
    //addAndMakeVisible(new vertical_sliders::Vertical_Sliders());
    //[/UserPreSize]

    setSize (500, 500);


    //[Constructor] You can add your own custom stuff here..
    slider_updater = new su::SliderUpdater(this);
    //[/Constructor]
}

Radium_Compressor::~Radium_Compressor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..

  delete slider_updater;

    //[/Destructor_pre]

    deleteAndZero (attack_slider);
    deleteAndZero (release_slider);
    deleteAndZero (bypass_button);
    deleteAndZero (hyperlinkButton);


    //[Destructor]. You can add your own custom destruction code here..

  delete comp;

    //[/Destructor]
}

//==============================================================================
void Radium_Compressor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
  g.fillAll (das_colors[11]);
    //[/UserPaint]
}

void Radium_Compressor::resized()
{
    attack_slider->setBounds (8, 350, 408, 24);
    release_slider->setBounds (8, 382, 408, 24);
    bypass_button->setBounds (8, 8, 72, 24);
    hyperlinkButton->setBounds (352, 8, 72, 24);
    //[UserResized] Add your own custom resize handling here..

    int y = bypass_button->getY() + bypass_button->getHeight() + 4;
    comp->w.setBounds (attack_slider->getX(),y,
                       attack_slider->getWidth() + 4,attack_slider->getY()-y-6);

    //[/UserResized]
}

void Radium_Compressor::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == bypass_button)
    {
        //[UserButtonCode_bypass_button] -- add your button handler code here..
      patch->is_bypassing=bypass_button->getToggleState();
      //printf("setting is_bypassing to %d\n",patch->is_bypassing);
        //[/UserButtonCode_bypass_button]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="Radium_Compressor" componentName=""
                 parentClasses="public Component" constructorParams="Patch *patch"
                 variableInitialisers="patch (patch)&#10;&#10;" snapPixels="8"
                 snapActive="1" snapShown="1" overlayOpacity="0" fixedSize="1"
                 initialWidth="500" initialHeight="500">
  <BACKGROUND backgroundColour="ff808277">
    <TEXT pos="32 2 368 38" fill=" radial: 50 50, 100 100, 0=ff1d6ac0, 1=ff16371a"
          hasStroke="0" text="Demo limitation: 5 seconds of silence every 30 seconds."
          fontname="Default font" fontsize="11.8" bold="0" italic="0" justification="36"/>
  </BACKGROUND>
  <SLIDER name="new slider" id="5b14c2c52494e6c4" memberName="attack_slider"
          virtualName="MySlider" explicitFocusOrder="0" pos="8 350 408 24"
          thumbcol="6a151525" trackcol="1affffff" rotaryslideroutline="ff614141"
          textboxtext="ff030611" textboxbkgd="73462828" min="0" max="500"
          int="0" style="LinearBar" textBoxPos="TextBoxLeft" textBoxEditable="0"
          textBoxWidth="80" textBoxHeight="20" skewFactor="0.5"/>
  <SLIDER name="new slider" id="3af8c10dbb225295" memberName="release_slider"
          virtualName="MySlider" explicitFocusOrder="0" pos="8 382 408 24"
          thumbcol="25bbbbff" trackcol="1affffff" textboxtext="ec000000"
          textboxbkgd="73ffffff" min="0" max="500" int="0" style="LinearBar"
          textBoxPos="TextBoxLeft" textBoxEditable="0" textBoxWidth="80"
          textBoxHeight="20" skewFactor="0.5"/>
  <TOGGLEBUTTON name="new toggle button" id="7f8b5e92f8cc3216" memberName="bypass_button"
                virtualName="" explicitFocusOrder="0" pos="8 8 72 24" txtcol="ff042961"
                buttonText="Bypass" connectedEdges="15" needsCallback="1" radioGroupId="0"
                state="0"/>
  <HYPERLINKBUTTON name="RadiumURL" id="7185a16e2ccf604e" memberName="hyperlinkButton"
                   virtualName="" explicitFocusOrder="0" pos="352 8 72 24" tooltip="http://users.notam02.no/~kjetism/radium/"
                   buttonText="Radium" connectedEdges="0" needsCallback="0" radioGroupId="0"
                   url="http://users.notam02.no/~kjetism/radium/"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif

//==============================================================================
// Binary resources - be careful not to edit any of these sections!

// JUCER_RESOURCE: radium_256x256x32_transparent_png, 42555, "../../radium-qt4/bin/radium_256x256x32_transparent.png"
static const unsigned char resource_Radium_Compressor_radium_256x256x32_transparent_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,1,0,0,0,1,0,8,4,0,0,0,246,123,96,237,0,0,0,2,98,75,71,68,
0,153,35,94,8,210,0,0,0,9,112,72,89,115,0,0,11,19,0,0,11,19,1,0,154,156,24,0,0,0,7,116,73,77,69,7,221,2,17,13,11,12,18,139,192,120,0,0,32,0,73,68,65,84,120,218,236,189,119,152,84,85,18,54,94,231,220,216,
97,114,96,8,67,24,114,146,156,4,102,137,74,50,33,40,136,184,40,6,150,32,176,40,138,162,162,192,130,96,34,26,64,17,84,68,17,5,73,74,14,146,115,142,67,154,33,205,144,6,38,116,247,13,231,247,199,251,157,
167,123,240,219,223,167,174,105,87,250,121,68,152,233,112,251,158,58,85,111,189,245,86,29,166,40,116,235,241,23,126,240,91,183,224,150,1,220,122,220,50,128,91,143,91,6,112,235,113,203,0,110,61,110,25,
192,173,199,45,3,184,245,184,101,0,183,30,183,12,224,214,227,150,1,220,122,220,50,128,91,143,91,6,240,63,250,16,66,8,252,31,255,69,254,237,175,244,80,255,154,139,79,196,152,252,191,16,140,133,255,70,132,
63,111,121,128,255,225,7,99,140,193,4,52,13,11,47,247,63,99,174,251,87,90,254,191,168,1,192,253,51,38,132,109,51,230,56,156,43,138,252,41,231,127,173,48,240,23,245,0,138,162,170,150,133,253,206,152,109,
219,54,140,192,113,254,90,251,159,72,225,252,175,232,1,28,135,136,115,69,49,205,64,64,85,117,157,200,117,93,87,81,132,16,226,175,117,71,254,146,6,64,196,24,231,134,81,178,164,215,91,172,152,16,121,121,
174,171,40,174,171,170,18,8,222,10,1,255,117,201,28,64,28,30,225,148,78,254,62,50,205,19,130,49,198,18,19,71,142,220,179,231,228,201,195,135,191,250,234,129,7,52,205,117,85,21,161,32,252,14,69,63,35,242,
115,228,251,253,15,108,133,255,102,77,160,16,156,11,225,186,68,156,3,204,1,225,59,14,99,66,40,138,109,171,170,227,200,228,78,211,108,155,49,215,213,52,199,241,249,222,125,247,161,135,224,248,85,53,55,
183,119,239,249,243,133,16,66,81,240,108,199,209,52,203,130,177,224,189,101,246,160,40,182,205,216,255,78,168,248,175,14,1,88,8,85,117,93,215,229,28,198,192,152,16,112,232,66,48,102,24,88,80,93,23,2,139,
141,244,175,93,187,81,163,136,108,155,243,96,80,85,77,51,37,101,209,34,203,178,109,152,10,150,156,49,77,211,117,34,199,33,194,54,1,104,116,28,69,65,182,240,191,16,44,254,171,137,32,120,0,203,226,92,81,
92,151,72,81,176,240,170,202,185,109,19,17,21,20,48,166,235,161,80,32,64,68,100,24,193,32,22,180,125,123,34,34,85,181,44,211,180,109,77,75,74,82,85,249,59,34,215,213,52,215,53,205,80,40,20,34,82,85,206,
45,75,8,93,183,44,34,233,109,132,248,223,208,83,179,255,238,175,129,61,143,189,175,170,112,217,66,56,14,99,186,110,89,170,170,235,133,133,68,62,95,137,18,201,201,37,75,150,45,203,121,173,90,49,49,62,95,
185,114,41,41,48,28,206,93,215,113,52,109,235,214,220,220,168,168,61,123,206,159,183,237,140,140,179,103,183,110,21,130,49,77,115,156,96,208,117,85,85,81,66,33,206,17,30,16,24,254,55,60,192,127,57,6,96,
140,115,34,24,129,101,1,150,121,189,126,191,97,120,189,229,203,199,199,55,108,88,190,124,114,114,82,146,174,239,217,147,151,119,249,242,129,3,142,115,236,88,118,118,247,238,207,61,103,219,138,226,186,
140,185,174,170,102,100,244,237,123,237,90,217,178,137,137,9,9,169,169,209,209,183,221,22,27,107,89,135,15,31,61,122,229,74,102,230,222,189,217,217,133,133,5,5,55,110,16,113,206,185,227,112,14,30,225,
150,1,252,225,33,192,117,93,23,128,141,177,146,37,203,150,173,84,169,76,153,216,216,184,184,178,101,11,11,15,28,56,113,226,200,145,19,39,46,94,204,203,43,250,202,138,21,87,175,46,89,210,113,2,1,143,135,
136,243,151,95,30,57,82,81,16,0,228,35,33,161,108,217,180,180,42,85,106,212,240,251,131,193,220,220,171,87,143,28,185,112,225,240,225,179,103,241,110,183,66,192,111,186,180,145,101,26,0,176,200,159,134,
147,48,215,37,82,213,250,245,91,182,172,84,137,49,162,107,215,78,158,204,204,60,122,244,220,185,43,87,194,96,17,251,220,113,20,197,182,117,221,182,21,165,115,231,119,222,73,73,193,239,63,253,244,197,23,
207,156,145,64,15,102,133,236,66,190,190,116,233,202,149,75,149,170,80,193,239,247,251,99,98,206,156,217,184,113,251,246,147,39,37,34,184,249,202,34,175,90,22,158,110,25,192,207,90,126,93,15,133,136,52,
205,178,16,107,93,215,117,81,186,177,109,69,177,109,184,96,33,136,218,182,237,217,179,118,237,83,167,182,110,221,190,253,236,217,220,220,75,151,10,10,112,203,57,7,72,140,52,38,185,188,174,107,154,165,
75,183,104,209,188,249,217,179,235,214,109,220,152,151,7,236,111,219,138,18,73,7,203,37,149,92,64,108,108,82,82,137,18,21,43,54,106,84,163,70,48,184,104,209,87,95,157,58,69,68,164,235,174,107,219,154,
102,219,66,104,154,101,41,10,94,231,186,156,255,185,235,139,127,82,15,224,56,154,38,4,99,182,141,69,83,85,206,137,128,201,133,80,213,80,72,136,42,85,254,249,207,246,237,79,159,254,242,203,239,191,207,
204,180,109,192,179,176,175,136,220,127,225,229,199,207,224,15,56,87,20,143,39,55,87,211,92,23,238,95,26,77,100,162,25,246,64,224,10,109,91,8,175,215,231,171,85,171,115,231,238,221,51,50,222,125,119,209,
162,11,23,24,243,120,10,11,57,87,213,80,136,115,153,60,202,212,244,150,7,248,153,15,215,53,140,64,128,115,198,56,87,85,199,177,109,215,213,52,34,203,50,12,162,168,168,174,93,135,12,137,138,26,63,254,131,
15,174,95,199,14,212,180,252,124,64,194,159,242,208,180,64,128,40,38,166,176,48,20,82,85,228,252,68,193,32,99,248,215,191,187,42,89,74,118,28,248,39,77,107,209,98,244,232,234,213,23,45,122,243,205,221,
187,53,141,168,176,80,81,44,11,30,138,115,195,176,44,219,254,51,115,45,127,90,12,32,4,99,170,106,219,174,203,185,16,138,130,98,77,201,146,229,202,245,234,149,158,190,107,215,216,177,219,183,3,147,203,
157,175,105,63,117,183,9,225,186,186,206,121,32,64,164,170,182,173,105,174,235,186,66,24,70,48,168,170,255,238,61,132,208,117,215,117,28,48,13,240,66,140,185,46,81,185,114,247,220,243,248,227,215,175,
207,155,183,124,121,70,70,32,224,186,170,106,89,154,6,67,225,252,207,236,3,254,180,30,128,72,211,112,251,28,71,81,44,75,85,235,213,107,211,166,65,3,175,119,249,242,25,51,46,93,98,12,241,220,113,56,7,53,
227,186,0,100,63,141,67,180,237,228,228,214,173,99,98,10,10,142,29,219,190,221,182,163,162,174,95,215,245,80,232,223,27,0,138,197,40,24,33,180,56,14,145,170,58,14,194,71,155,54,15,61,84,169,210,177,99,
75,151,110,216,112,246,172,170,10,225,56,134,225,56,183,66,192,47,202,239,17,139,25,179,109,206,93,183,91,183,206,157,227,226,246,239,95,188,120,211,166,252,252,31,147,191,112,184,63,181,150,39,4,99,141,
27,191,244,82,179,102,62,31,209,137,19,243,230,189,249,102,118,54,231,68,240,39,255,206,3,192,15,33,8,184,174,162,0,50,114,142,232,111,219,68,53,107,182,105,211,168,81,241,226,75,151,206,156,121,254,60,
184,199,159,110,150,127,105,3,144,88,93,2,46,220,112,203,210,180,238,221,95,122,169,160,96,198,140,197,139,207,158,45,40,0,233,11,48,136,93,136,2,79,40,4,85,207,143,19,177,240,191,195,127,150,44,57,119,
110,163,70,8,43,140,17,13,29,58,113,162,16,192,3,0,129,145,169,102,36,140,12,95,163,227,0,47,160,12,229,56,48,75,162,226,197,171,85,235,217,179,77,155,79,62,25,54,12,30,66,190,234,255,118,45,127,248,141,
87,254,20,15,206,53,77,81,136,20,69,85,85,149,49,160,126,162,6,13,118,237,58,121,178,107,215,148,20,60,207,48,24,83,20,206,57,151,175,227,156,49,198,84,149,136,115,195,208,117,34,198,12,131,49,85,85,85,
77,131,230,79,215,137,52,205,48,136,20,69,215,137,84,181,75,23,33,108,219,117,11,10,144,226,109,223,94,166,140,97,16,121,60,138,162,40,154,166,170,184,55,170,170,170,186,206,57,231,248,147,49,69,49,12,
85,229,28,239,163,40,138,194,24,222,89,94,23,231,138,162,170,181,106,45,92,120,241,98,159,62,48,86,34,206,85,149,49,206,21,133,49,85,85,20,188,90,126,143,63,240,206,255,73,28,17,179,109,33,116,221,113,
28,199,182,85,85,211,56,175,89,115,209,162,21,43,62,248,160,92,57,164,89,66,56,14,202,49,112,194,120,112,174,170,168,255,17,5,131,150,165,235,156,7,131,216,95,150,229,56,62,31,231,161,16,231,182,109,219,
62,159,105,170,106,116,180,223,223,182,45,17,145,109,123,60,66,4,131,68,181,107,39,38,170,106,82,146,227,232,186,170,218,182,227,168,42,231,142,227,56,174,27,10,17,225,61,20,133,115,199,9,6,29,135,200,
113,20,37,204,44,24,6,246,179,188,46,33,246,237,187,235,174,182,109,123,245,58,112,160,115,103,191,159,8,158,134,49,84,17,56,215,180,63,71,96,248,147,132,0,208,48,156,219,182,166,5,131,68,21,42,244,234,
213,169,211,154,53,163,71,103,103,203,101,134,235,183,237,240,21,75,82,71,81,80,170,81,20,16,49,182,205,57,0,164,215,235,245,38,36,36,39,11,81,189,186,16,37,74,68,69,197,198,22,47,238,186,229,203,87,170,
100,89,0,106,154,38,4,209,150,45,231,206,217,246,233,211,193,224,185,115,87,174,92,185,146,151,119,227,70,126,254,245,235,87,174,64,42,170,40,150,133,172,35,146,37,0,18,144,53,137,72,140,225,186,154,198,
121,32,112,239,189,35,71,158,58,245,206,59,63,252,128,32,133,42,37,66,0,194,216,45,3,248,63,8,27,128,201,117,75,149,234,222,253,254,251,15,31,158,56,113,231,78,89,232,149,196,138,148,123,132,111,52,254,
14,21,0,4,158,68,68,37,75,86,169,82,182,108,137,18,37,74,16,41,74,108,172,16,249,249,153,153,151,46,229,228,92,190,124,253,250,249,243,109,218,124,248,33,158,169,170,174,203,249,225,195,61,122,92,190,
92,173,154,16,177,177,37,74,164,164,196,199,171,106,48,24,8,4,131,174,123,229,202,201,147,135,14,29,58,36,169,34,136,76,84,21,126,128,115,40,9,195,240,19,127,131,199,226,220,117,125,190,62,125,58,118,
60,125,122,230,204,53,107,24,35,194,243,33,65,253,227,81,192,159,198,3,96,39,233,250,29,119,12,27,118,250,244,236,217,75,150,184,46,244,55,154,102,219,170,202,152,235,218,54,110,95,209,91,13,116,142,229,
241,249,154,52,105,214,172,94,61,85,189,116,41,43,235,226,197,243,231,207,159,207,201,185,116,41,39,167,232,231,165,164,124,251,109,131,6,142,195,88,40,100,154,68,175,188,242,198,27,5,5,69,169,162,98,
197,146,146,18,19,75,149,42,95,222,231,139,143,47,81,226,226,197,181,107,55,109,218,191,95,50,134,160,155,37,205,19,73,31,35,151,144,85,2,199,33,170,80,225,254,251,239,191,127,215,174,23,94,184,124,153,
72,211,96,168,97,3,190,229,1,136,200,113,162,163,223,122,171,69,139,231,159,95,179,230,210,37,34,85,213,180,194,66,211,12,4,36,98,86,20,33,160,199,137,36,140,20,197,182,137,146,147,239,190,187,87,175,
226,197,143,29,219,176,97,231,206,19,39,174,92,201,207,207,207,23,2,240,44,20,2,168,67,14,207,24,81,237,218,211,167,215,174,13,206,225,141,55,198,142,189,122,213,235,45,44,212,52,100,21,97,29,160,162,
16,249,253,241,241,126,127,237,218,13,27,54,106,84,178,228,202,149,147,39,111,221,74,228,243,229,231,3,130,74,255,83,52,160,161,74,233,186,8,71,177,177,73,73,125,251,182,105,51,120,240,138,21,68,144,167,
253,25,122,16,126,71,3,144,137,84,120,231,70,114,237,174,219,168,209,236,217,123,247,246,233,115,233,18,152,122,85,13,133,60,158,64,192,48,44,11,248,64,81,24,11,133,20,37,156,44,186,174,16,197,138,181,
109,251,196,19,117,235,110,218,52,117,234,15,63,92,187,166,40,0,113,66,200,212,76,81,80,162,193,13,87,20,203,82,20,219,246,249,154,54,109,218,244,218,181,101,203,14,28,208,117,219,118,93,143,167,176,16,
78,26,239,44,132,97,160,40,21,10,169,42,22,186,116,233,30,61,122,245,226,124,211,166,15,62,216,176,1,113,157,8,124,101,56,193,115,93,137,26,20,197,117,117,29,87,164,105,109,218,76,159,62,107,214,216,177,
151,47,51,166,105,82,81,16,174,83,252,143,167,129,50,189,51,12,206,145,100,49,166,105,134,161,170,241,241,99,198,92,185,210,167,15,202,171,154,38,211,41,249,31,99,64,205,208,244,169,170,170,170,42,231,
209,209,205,154,125,246,89,110,238,206,157,221,186,153,38,92,179,76,173,194,41,89,228,59,225,33,255,133,197,70,155,8,145,207,167,170,145,233,156,124,101,248,245,210,35,16,221,118,219,216,177,103,207,158,
60,57,108,88,181,106,81,81,138,162,170,156,155,38,99,134,161,170,72,84,53,77,85,229,251,200,207,228,156,200,52,191,255,254,224,193,134,13,241,91,249,12,93,103,204,52,255,136,164,240,119,245,0,216,129,
156,131,182,229,28,201,155,109,55,107,246,236,179,249,249,47,191,124,236,152,162,56,142,97,64,222,17,105,164,104,226,66,169,150,49,219,246,249,26,53,170,93,187,89,179,138,21,23,44,120,239,189,172,44,36,
88,63,125,23,49,134,66,45,231,161,144,166,129,215,11,133,52,13,176,237,223,49,129,170,106,89,160,118,0,76,91,183,238,211,167,78,157,29,59,22,44,216,181,235,248,113,203,210,245,80,200,48,136,108,155,49,
219,198,21,133,81,66,56,212,61,246,216,208,161,159,124,50,115,230,217,179,240,75,170,26,10,153,102,48,248,71,120,128,223,57,4,72,216,164,105,193,160,170,18,89,150,162,12,25,210,185,243,23,95,76,153,2,
30,30,178,141,72,109,14,202,183,112,203,68,66,120,60,29,58,116,239,94,166,204,222,189,95,125,181,122,117,32,0,157,128,172,218,255,84,3,96,12,156,2,254,197,185,227,248,124,133,133,156,163,226,247,239,42,
20,248,189,162,8,225,186,8,68,9,9,93,187,182,106,21,29,125,240,224,226,197,43,87,18,65,110,130,192,99,154,5,5,8,64,97,216,10,192,90,179,230,107,175,197,197,61,255,252,230,205,166,137,48,194,152,101,253,
17,85,195,223,217,0,56,183,44,69,65,244,99,204,178,98,99,103,206,244,249,94,126,121,227,70,36,88,150,133,138,123,81,84,141,189,47,132,235,38,38,246,234,117,255,253,57,57,11,23,254,240,195,241,227,150,
37,205,66,42,3,127,234,30,82,213,96,48,45,237,193,7,235,214,37,218,190,253,253,247,175,93,227,92,154,221,191,127,15,20,158,36,69,172,40,178,12,228,243,85,171,150,158,222,161,131,235,78,154,244,237,183,
68,104,51,65,101,49,172,20,146,223,69,215,131,65,215,141,137,249,199,63,122,247,30,53,106,230,76,93,23,130,200,113,116,61,20,250,3,124,192,239,139,1,80,187,103,12,244,108,189,122,153,153,227,199,251,124,
160,90,65,174,170,42,145,174,23,165,137,37,153,58,106,212,217,179,11,23,182,110,157,146,162,170,160,101,241,59,211,212,117,206,13,3,216,225,167,16,207,138,210,185,243,161,67,55,110,8,33,68,48,184,110,
29,242,1,195,240,120,254,61,61,43,81,128,36,163,25,243,120,84,21,180,174,174,115,158,154,250,244,211,231,206,253,240,67,235,214,184,94,159,15,120,134,177,162,239,34,127,70,148,158,126,224,192,172,89,248,
100,93,255,99,136,97,250,61,249,126,93,7,252,51,12,69,33,234,221,251,252,249,167,158,34,82,85,93,7,71,111,24,170,74,228,241,128,51,15,63,116,157,177,78,157,246,238,221,180,233,142,59,160,179,129,211,4,
39,15,222,94,154,196,79,187,146,226,197,23,47,70,200,8,133,132,16,98,246,236,98,197,124,190,255,127,126,158,115,206,53,77,215,53,13,207,130,169,50,166,235,62,31,36,41,156,155,230,184,113,87,174,44,92,
88,161,130,244,172,0,136,17,55,156,60,30,64,201,232,104,69,137,139,91,179,102,205,154,196,68,56,255,63,162,22,64,191,199,194,115,206,185,170,194,3,224,150,121,60,207,63,127,224,64,155,54,136,223,18,39,
171,42,99,134,17,137,192,129,155,171,86,253,252,243,125,251,30,124,16,251,79,215,101,41,5,109,91,120,111,249,103,228,126,13,99,126,249,0,10,33,106,209,66,136,252,124,203,178,109,68,115,33,42,87,6,40,196,
187,134,241,123,248,79,124,42,242,16,69,33,210,52,249,44,34,175,151,115,89,228,73,76,156,60,57,35,99,212,168,114,229,160,51,146,87,16,246,103,156,163,96,5,95,248,225,135,155,55,215,171,7,115,190,57,255,
248,93,246,229,111,29,98,16,49,53,77,8,33,52,205,117,57,247,251,135,15,191,231,158,191,255,125,227,70,41,192,2,56,66,215,62,178,3,217,218,89,175,222,147,79,190,244,210,234,213,79,60,177,107,151,97,64,
193,35,199,56,200,74,187,227,104,154,207,231,241,132,66,178,141,11,101,93,44,173,124,152,102,98,98,74,74,74,202,109,183,165,166,118,238,220,168,17,82,82,215,69,108,223,189,219,231,43,95,94,81,18,19,133,
112,28,219,150,175,98,44,12,252,192,240,105,90,84,148,105,6,131,142,227,247,219,182,16,96,39,160,70,32,226,60,63,127,201,146,197,139,187,116,233,221,219,178,206,157,203,203,147,160,81,182,165,129,60,194,
245,17,105,218,55,223,148,42,53,112,224,217,179,25,25,200,76,64,87,253,94,141,39,191,49,8,68,127,94,40,132,110,61,44,86,153,50,147,38,217,246,208,161,199,143,107,90,88,199,131,36,14,149,117,168,237,44,
43,58,122,232,208,191,253,109,195,134,247,223,63,121,18,210,42,93,143,196,202,80,4,9,241,183,191,117,235,230,247,107,218,213,171,211,166,237,218,197,185,97,20,20,224,246,18,37,38,86,172,88,185,114,241,
226,169,169,30,143,227,56,142,227,68,71,95,185,82,190,124,135,14,72,44,209,234,169,170,179,102,93,186,148,154,122,225,2,231,30,15,231,121,121,89,89,199,143,159,58,117,244,232,141,27,225,188,65,85,67,161,
14,29,238,187,207,227,81,213,236,236,121,243,214,174,245,122,109,59,20,186,89,140,6,30,177,99,199,39,159,84,213,119,223,93,184,144,200,52,131,65,52,172,69,46,171,16,208,49,184,238,163,143,190,252,242,
179,207,126,249,165,105,6,131,88,250,223,107,88,205,111,110,0,72,252,76,211,178,132,208,180,96,48,45,109,201,146,213,171,95,126,57,39,71,211,80,142,145,11,10,1,8,246,46,231,150,213,172,217,248,241,7,15,
78,159,190,105,19,146,43,236,87,85,69,11,103,24,153,15,25,50,112,96,106,42,254,117,234,212,19,79,172,88,65,68,20,19,211,174,93,221,186,13,26,120,60,167,79,159,60,89,80,112,240,96,97,225,229,203,121,121,
150,69,116,225,194,109,183,173,95,47,4,99,193,160,97,216,182,170,102,102,118,236,120,250,116,114,50,231,134,17,19,19,31,159,152,152,146,82,170,84,76,76,197,138,5,5,155,54,173,92,185,105,83,126,62,17,81,
191,126,195,135,167,164,96,17,143,30,29,62,124,238,92,206,85,149,243,96,48,210,44,25,131,48,52,58,186,83,167,126,253,14,30,236,215,15,148,182,174,11,17,105,42,168,102,194,115,220,126,251,212,169,171,86,
13,26,164,170,138,98,219,216,48,191,75,78,240,123,196,127,211,52,77,34,175,151,168,85,171,147,39,7,15,246,249,84,21,82,13,25,153,81,78,245,249,20,69,81,60,30,34,162,127,253,235,252,249,135,30,138,139,
211,52,188,18,220,31,4,33,145,144,170,81,163,211,167,133,200,207,23,194,113,28,71,136,51,103,234,214,253,215,191,14,29,202,206,254,234,171,23,94,72,79,47,81,34,49,49,62,222,239,71,24,66,54,65,228,243,
189,254,186,16,185,185,142,19,8,8,33,196,240,225,166,169,105,68,209,209,50,17,52,140,216,216,164,164,210,165,111,191,125,216,176,205,155,47,93,90,179,230,159,255,124,224,129,139,23,133,8,4,132,112,93,
203,18,98,219,182,228,100,164,175,69,239,35,99,128,166,156,171,106,133,10,83,167,238,223,223,176,33,145,223,207,121,209,60,5,178,18,195,64,86,80,190,252,153,51,111,188,17,201,133,254,15,128,64,85,53,77,
104,125,76,147,232,246,219,79,157,234,219,55,42,74,211,228,130,74,66,22,40,154,72,215,13,131,168,84,169,109,219,54,111,46,94,156,200,48,136,98,98,160,212,145,180,109,36,208,35,234,215,239,250,117,33,66,
33,219,182,109,40,118,51,51,223,123,175,121,243,72,72,197,24,62,63,172,241,81,213,228,228,47,190,176,172,252,124,199,185,114,229,217,103,77,83,10,54,144,222,193,47,114,78,228,241,120,189,68,166,121,223,
125,211,167,231,231,11,81,88,40,68,32,96,219,66,88,214,217,179,119,222,9,224,247,99,92,165,170,48,100,34,162,46,93,10,11,71,141,34,98,12,4,113,164,1,71,69,113,142,107,34,170,80,225,196,137,23,95,68,249,
233,247,202,9,232,215,223,243,145,232,91,81,128,205,189,94,162,250,245,247,238,125,238,57,36,79,166,137,158,60,220,44,198,194,122,25,143,167,127,255,140,140,225,195,195,88,27,102,0,200,134,189,18,102,
209,137,166,78,149,251,63,20,114,221,27,55,132,24,52,8,55,15,249,1,30,72,27,37,81,4,20,78,84,165,74,159,62,173,91,23,43,134,148,18,243,0,20,69,211,144,170,122,60,242,239,236,255,4,202,55,223,20,194,117,
67,33,33,92,55,24,180,237,188,188,254,253,137,20,5,146,176,200,234,3,62,17,102,173,235,68,201,201,203,151,175,88,81,189,122,216,235,225,249,166,9,63,129,244,151,168,86,173,181,107,7,14,244,122,193,44,
220,92,143,248,47,241,0,72,135,224,8,225,220,13,131,168,121,243,125,251,70,140,192,237,215,117,34,69,209,52,164,62,128,87,186,206,24,231,169,169,147,38,109,219,214,182,45,81,184,168,194,24,99,166,41,203,
64,40,221,132,111,241,27,111,192,249,203,253,47,196,67,15,133,63,67,38,118,88,148,240,30,212,52,73,32,227,57,156,227,10,144,78,34,53,197,39,65,5,8,3,29,50,196,113,92,215,182,109,219,178,92,215,117,207,
159,239,210,5,33,67,238,107,121,133,64,243,146,177,208,117,34,206,95,123,109,211,166,158,61,195,155,2,234,67,44,53,94,175,105,68,149,42,173,93,251,207,127,18,105,154,164,155,12,35,156,28,254,23,164,129,
24,179,130,146,143,170,2,186,217,118,147,38,179,102,205,156,57,122,52,231,16,96,169,42,106,123,142,35,4,216,115,199,17,162,81,163,119,223,13,4,250,245,219,177,67,182,104,161,104,131,132,76,94,41,99,40,
238,10,81,165,202,227,143,183,106,149,148,164,40,80,232,17,49,118,227,70,255,254,146,82,197,50,56,142,97,200,4,139,115,84,233,145,122,26,134,76,204,80,34,6,32,227,220,113,12,3,170,63,73,15,227,90,174,
94,237,223,95,170,121,80,140,46,94,188,84,169,43,87,114,114,64,67,35,147,209,117,153,140,66,241,35,83,191,149,43,115,114,158,122,170,78,157,149,43,45,75,81,116,93,118,16,162,206,129,100,217,48,46,94,60,
112,96,244,232,184,184,213,171,225,195,144,19,69,214,19,254,244,32,80,218,50,246,161,170,18,149,47,127,252,248,227,143,195,37,170,170,4,61,170,10,80,166,40,136,185,143,60,146,145,49,120,48,224,218,143,
45,222,52,17,6,36,116,74,74,154,53,235,248,241,9,19,234,212,121,237,53,24,136,235,10,145,151,215,161,131,220,231,18,46,162,112,140,216,142,221,100,154,242,10,165,73,73,157,47,120,62,201,88,202,248,14,
53,177,170,18,61,247,28,200,99,124,226,224,193,45,90,76,156,120,252,248,180,105,229,202,33,80,200,200,30,198,30,184,22,0,88,69,73,75,155,61,123,213,170,196,68,34,77,51,77,69,65,120,3,13,110,154,240,108,
68,53,107,2,14,98,38,17,145,223,255,83,57,206,63,69,8,144,145,26,18,109,69,41,83,230,240,225,190,125,21,133,49,175,87,81,12,195,52,137,52,205,235,149,14,24,162,238,87,95,205,200,104,218,20,255,50,205,
155,217,115,153,69,24,6,82,188,9,19,114,115,95,127,61,57,217,239,215,117,198,30,120,224,192,1,136,187,235,214,245,120,100,214,0,8,39,227,55,242,12,206,97,2,186,78,212,186,245,87,95,157,59,119,254,252,
59,239,20,47,78,100,154,184,98,112,139,114,183,1,148,154,38,100,225,154,102,24,29,59,158,56,33,68,48,184,96,65,157,58,170,170,170,49,49,213,170,125,246,89,110,238,160,65,18,97,24,6,222,3,10,70,249,62,
248,147,115,143,103,248,240,179,103,155,52,1,39,10,47,5,227,196,253,128,132,189,116,233,51,103,70,142,4,84,150,97,229,191,6,4,130,204,133,60,66,215,253,254,207,62,123,235,45,175,23,214,141,248,26,21,197,
152,215,219,177,227,235,175,63,255,124,235,214,186,174,105,227,199,31,62,156,148,4,223,32,233,211,240,3,69,23,164,91,126,127,239,222,151,47,207,152,225,247,19,69,69,17,121,189,30,79,184,130,199,24,178,
6,44,113,76,12,145,223,255,183,191,141,24,49,113,98,227,198,209,209,156,123,60,140,121,60,154,198,249,144,33,232,12,16,66,136,125,251,110,191,93,166,137,138,98,24,37,74,220,125,247,184,113,253,251,151,
41,3,97,135,166,105,26,168,102,100,19,128,163,30,15,156,52,17,99,21,42,172,90,149,145,209,180,105,108,44,12,6,123,63,124,71,136,96,248,192,33,143,61,118,249,242,125,247,17,37,39,255,227,31,35,70,188,240,
2,122,18,188,94,41,125,33,242,120,202,149,219,191,255,254,251,137,194,230,252,95,227,1,192,223,3,68,121,189,111,189,245,213,87,177,177,216,141,176,122,77,99,172,98,197,53,107,36,217,186,116,233,140,25,
43,86,160,194,7,40,120,115,53,80,238,38,191,191,69,139,101,203,246,237,67,189,77,230,6,192,210,248,123,84,20,170,5,82,171,87,181,234,222,189,66,8,225,56,66,204,159,95,182,44,145,215,203,24,99,53,107,102,
103,11,225,186,129,0,80,253,212,169,81,81,8,71,68,15,60,144,153,41,175,237,245,215,99,98,80,230,209,117,40,145,160,220,65,0,241,122,85,149,115,159,15,232,164,91,183,83,167,62,254,184,106,213,216,88,233,
127,0,248,96,46,240,65,128,154,68,119,222,153,145,49,113,162,252,28,215,125,237,181,232,104,93,55,77,69,241,120,160,125,210,245,7,31,220,183,175,109,91,228,38,255,101,33,0,133,17,93,39,26,58,116,221,186,
202,149,225,202,16,121,161,213,95,189,90,198,108,33,132,56,113,162,74,21,34,69,49,77,84,220,110,46,196,200,226,241,172,89,219,182,245,239,239,241,72,55,11,68,31,206,174,1,234,116,221,48,240,74,175,119,
219,54,33,66,33,203,194,141,254,240,67,245,255,76,69,27,48,64,8,96,121,176,254,23,47,150,44,137,223,212,169,115,228,8,200,30,100,251,3,7,202,248,15,76,14,20,35,27,59,164,7,64,188,247,249,70,142,220,188,
121,212,168,202,149,165,132,61,82,128,102,24,154,6,127,194,57,209,83,79,97,233,131,65,199,17,66,136,191,255,93,81,20,5,21,73,248,59,162,65,131,214,173,43,83,6,134,19,249,78,191,102,82,248,155,120,0,195,
192,98,244,236,121,244,104,157,58,210,101,162,126,102,154,68,29,59,98,87,58,142,16,182,45,68,86,86,243,230,216,125,136,180,170,26,238,251,193,142,49,205,231,159,223,182,237,213,87,1,182,176,191,241,105,
225,132,46,82,237,131,166,176,187,238,194,50,203,4,241,236,217,167,159,110,223,254,241,199,71,140,216,185,211,117,93,215,182,113,243,45,75,136,9,19,158,123,238,193,7,219,181,251,240,67,152,166,109,163,
36,116,234,148,105,50,166,235,184,142,72,240,140,133,148,33,2,166,72,84,189,250,132,9,107,214,60,249,36,74,82,50,7,128,121,35,150,19,113,174,105,35,71,226,51,92,55,24,116,93,33,126,248,1,1,16,239,131,
79,211,180,105,211,22,44,128,55,149,9,229,175,141,8,126,131,90,160,235,134,66,142,19,12,214,172,57,105,82,255,254,187,118,97,214,135,227,112,142,249,60,68,13,27,66,94,197,121,32,192,185,235,150,44,153,
150,38,53,131,178,123,166,118,237,59,239,140,137,1,229,90,170,212,119,223,165,167,15,28,56,126,60,138,66,216,89,168,213,57,78,116,180,227,16,61,246,216,218,181,219,183,175,92,217,179,39,90,197,24,35,106,
212,136,8,66,51,34,219,118,156,164,164,238,221,211,211,155,53,59,123,246,232,81,52,119,203,17,50,185,185,153,153,30,207,223,254,214,185,243,221,119,219,182,156,14,196,24,81,153,50,129,128,162,192,139,
148,42,245,205,55,91,183,254,240,195,187,239,86,169,2,149,50,196,95,142,99,89,216,217,138,114,240,224,115,207,189,253,246,35,143,44,88,144,156,108,219,186,46,68,114,114,221,186,13,27,58,78,32,128,41,165,
186,206,88,98,98,149,42,114,170,41,74,73,77,155,154,166,84,36,114,14,69,33,231,3,6,120,189,111,190,41,127,142,90,233,175,156,16,254,250,251,223,239,231,92,85,61,158,51,103,30,125,84,10,53,164,203,66,140,
71,226,38,247,152,235,10,209,171,23,16,62,232,161,71,30,57,121,50,63,191,176,48,55,119,212,40,77,235,218,245,250,245,145,35,125,62,143,231,102,142,92,114,104,68,107,214,20,22,10,33,68,97,97,48,56,103,
142,204,46,222,125,23,41,155,109,219,182,235,186,110,78,206,223,255,238,241,24,134,105,214,173,139,160,16,12,186,110,32,32,196,55,223,148,41,163,170,134,145,144,240,209,71,50,209,179,109,203,10,6,133,
168,88,81,6,135,243,231,243,242,66,33,33,28,231,242,101,100,44,18,243,32,85,4,250,65,13,242,227,143,111,220,72,79,87,148,207,62,187,122,181,176,240,218,181,45,91,154,53,99,12,72,136,243,132,132,175,191,
22,34,16,112,28,215,197,112,10,203,66,224,10,63,224,215,18,19,119,239,30,62,156,200,48,224,77,188,222,95,183,82,240,155,96,0,195,240,122,215,174,125,243,77,89,177,151,244,167,170,114,238,241,168,106,163,
70,112,187,184,253,150,117,252,120,211,166,112,255,156,19,61,250,232,213,171,82,166,17,12,94,185,146,157,125,239,189,112,163,40,213,20,101,29,57,103,236,177,199,132,192,64,71,219,118,221,96,112,212,168,
54,109,150,45,179,172,61,123,132,176,109,80,183,66,8,145,149,213,178,37,150,32,38,102,198,12,33,10,10,176,212,23,47,62,248,32,231,64,235,195,135,227,218,92,23,208,49,51,51,39,231,220,185,183,223,174,93,
123,235,214,96,16,84,48,140,160,100,73,41,81,215,52,195,64,240,146,133,32,93,39,122,232,33,203,202,204,68,9,26,56,163,105,83,153,232,25,198,168,81,66,96,249,241,126,243,230,221,44,11,55,77,240,3,149,42,
101,103,119,232,128,84,50,76,59,255,137,211,64,77,99,108,248,240,181,107,125,62,208,49,145,37,31,136,190,56,159,63,31,183,24,181,184,9,19,164,24,140,40,37,101,219,54,33,92,23,69,23,203,18,34,61,157,8,
134,67,228,245,22,45,6,161,208,116,244,40,252,137,140,231,66,172,90,213,179,103,82,18,209,87,95,193,215,184,174,16,249,249,111,191,13,102,64,211,20,37,46,110,252,248,189,123,207,158,61,118,108,195,134,
7,30,8,155,95,205,154,91,182,96,105,80,240,233,209,131,168,126,253,215,95,63,121,18,38,235,56,174,11,207,213,179,167,196,40,72,238,64,124,3,247,51,22,29,77,244,226,139,48,24,203,130,25,46,94,236,243,33,
73,52,140,170,85,119,239,134,111,130,40,173,83,167,162,6,0,44,132,180,181,91,183,61,123,42,86,132,129,22,45,135,253,73,139,65,205,155,239,222,221,176,33,180,127,145,156,24,231,154,102,154,68,186,62,125,
122,70,198,177,99,66,216,118,70,198,123,239,197,197,133,179,230,14,29,206,157,195,13,150,139,48,118,172,76,161,144,135,23,189,77,156,19,5,131,216,73,142,131,93,187,109,91,116,52,112,120,114,242,244,233,
57,57,66,132,66,25,25,227,199,151,42,133,60,219,48,192,184,69,69,165,167,215,168,33,225,169,97,128,155,187,227,142,69,139,10,10,132,184,113,99,207,158,33,67,80,133,32,234,209,35,55,215,117,131,65,33,66,
161,80,200,117,133,120,225,5,105,0,72,19,193,222,75,254,83,81,136,86,172,128,97,6,2,129,64,40,36,196,225,195,117,234,72,224,72,212,178,229,119,223,193,255,236,223,191,99,199,223,255,126,115,56,214,52,
48,39,134,161,40,83,166,188,251,46,164,175,50,216,252,106,245,218,95,191,233,43,42,106,228,200,217,179,183,110,197,208,148,48,100,129,23,112,93,162,209,163,171,86,237,208,33,54,54,45,205,113,206,157,219,
179,231,198,13,176,238,170,26,12,198,198,250,253,114,72,28,248,113,36,104,156,187,46,231,170,138,177,207,225,190,61,198,136,206,156,169,80,1,213,0,12,138,215,52,164,103,138,146,147,51,112,224,231,159,
167,166,94,191,158,149,181,125,59,64,152,170,6,131,192,232,55,110,172,91,135,33,47,142,131,78,5,198,56,95,182,108,239,222,6,13,226,227,243,242,14,28,56,124,24,110,55,24,4,46,215,245,240,92,128,203,151,
229,117,88,22,70,216,133,135,86,129,197,87,85,124,95,93,183,44,72,197,13,195,117,53,13,240,113,245,234,140,140,58,117,98,98,46,92,200,202,170,94,125,220,184,163,71,55,109,146,83,78,194,29,198,140,5,131,
138,242,230,155,239,190,219,190,253,183,223,194,219,160,178,241,167,1,129,96,221,124,62,89,117,31,59,246,203,47,193,125,193,134,241,83,68,62,206,137,134,15,63,115,70,206,232,148,36,173,148,75,19,253,237,
111,167,78,97,247,35,151,16,98,196,8,169,173,197,98,188,240,194,71,31,205,152,49,110,92,249,242,88,254,71,31,69,207,0,118,91,40,100,219,31,126,40,27,185,37,101,35,113,8,42,143,112,210,240,79,97,114,7,
76,29,76,35,210,196,112,213,21,43,30,61,10,234,72,8,248,154,109,219,42,84,192,21,116,233,178,104,209,246,237,51,103,118,233,2,222,30,239,73,244,245,215,66,132,66,200,19,92,215,182,183,110,77,77,197,119,
145,148,121,152,195,124,224,129,203,151,171,86,149,243,76,188,94,185,207,101,217,251,238,187,247,238,173,81,67,78,37,249,83,97,0,206,21,37,42,74,14,97,105,218,244,202,149,138,21,37,25,43,153,110,201,124,
19,61,242,200,181,107,73,73,62,159,28,186,34,233,30,176,252,138,226,241,204,157,11,112,100,89,174,43,68,97,97,74,10,145,166,233,186,215,107,24,213,170,29,59,230,186,193,96,32,224,56,199,143,183,109,91,
191,254,134,13,187,118,13,24,112,244,40,32,157,227,82,8,7,140,0,0,32,0,73,68,65,84,8,113,226,68,169,82,178,92,12,56,6,98,26,38,33,111,107,152,59,0,55,105,154,136,206,82,119,36,183,134,105,18,49,230,243,
17,13,29,90,88,40,4,202,193,66,188,250,234,152,49,217,217,99,198,36,36,76,153,18,8,88,22,180,69,35,70,200,101,53,12,198,42,86,132,78,1,234,99,199,153,58,85,82,187,134,193,152,223,15,33,8,40,35,85,125,
236,177,172,172,184,56,140,181,40,170,37,198,213,190,255,254,188,121,224,73,127,77,30,128,126,29,220,111,154,146,195,62,113,162,79,31,121,227,225,3,192,254,99,95,53,110,124,244,232,29,119,16,113,238,243,
69,126,13,44,141,174,171,170,166,125,244,81,78,14,20,62,5,5,87,174,116,232,128,61,136,125,184,121,51,8,164,80,8,105,223,209,163,253,251,155,38,81,106,234,134,13,185,185,23,46,92,190,60,127,126,153,50,
136,233,184,50,217,86,138,159,232,58,132,31,154,150,146,242,226,139,23,46,8,145,153,57,124,120,108,44,150,13,55,28,203,175,170,232,1,32,130,160,77,215,137,158,124,114,223,190,235,215,243,242,142,29,123,
230,25,34,162,50,101,102,207,14,4,144,73,0,135,8,209,177,35,145,166,129,136,242,122,31,123,204,113,0,104,111,220,200,206,158,58,21,13,168,170,10,186,26,40,223,48,32,26,33,250,232,163,5,11,194,229,175,
200,93,206,152,199,195,216,233,211,143,63,30,214,82,253,137,60,0,110,144,170,114,254,209,71,243,231,195,121,193,17,98,217,81,8,50,140,146,37,151,47,31,50,4,101,143,200,242,41,222,131,49,162,232,232,41,
83,102,205,42,83,230,95,255,90,191,126,237,218,57,115,170,87,151,5,83,34,162,150,45,225,82,129,234,67,161,171,87,123,247,150,191,35,74,77,173,86,45,49,17,85,183,176,36,195,52,97,94,160,148,113,109,154,
86,188,248,250,245,192,224,182,45,196,186,117,169,169,170,10,233,137,84,242,72,13,17,94,5,150,142,136,168,122,245,244,116,92,61,231,170,234,243,125,243,141,16,5,5,142,227,186,150,21,10,9,177,115,167,60,
143,12,198,223,188,249,39,159,108,216,176,122,245,192,129,53,107,110,216,48,101,74,84,148,236,60,144,194,17,120,74,132,192,229,203,71,141,10,171,139,34,125,44,224,233,133,11,160,153,255,100,30,64,74,172,
58,118,60,114,36,57,25,95,10,72,23,172,185,36,120,167,76,153,62,61,42,74,202,157,138,90,49,138,180,111,191,61,123,118,92,92,36,211,133,58,28,66,196,224,193,208,236,35,231,119,221,188,188,65,131,136,76,
83,211,164,75,151,183,138,72,85,147,147,229,59,192,141,107,154,196,25,140,61,254,56,76,41,24,180,44,203,18,226,165,151,56,247,249,138,234,148,144,98,18,197,199,199,198,194,40,80,28,134,119,0,169,21,31,
191,100,9,250,139,44,203,113,16,6,100,93,209,52,111,30,93,91,169,210,250,245,163,70,25,6,170,30,168,154,74,33,26,52,64,149,42,109,222,124,239,189,63,238,80,146,149,142,177,99,215,172,249,117,233,187,95,
197,3,224,182,196,198,46,94,220,173,155,199,3,120,165,235,68,30,143,204,212,125,62,162,94,189,54,109,42,86,76,246,6,222,156,207,50,70,52,109,218,55,223,68,71,195,53,66,74,134,27,35,69,147,157,59,35,0,
0,84,57,78,65,193,208,161,16,82,96,73,208,171,163,170,201,201,163,70,45,90,244,195,15,179,103,223,117,151,12,2,232,220,151,75,177,126,189,16,150,229,56,82,220,177,118,45,72,38,153,172,194,239,104,218,
221,119,127,250,233,170,85,75,150,140,28,89,172,24,188,153,212,13,98,153,19,19,151,45,67,61,195,178,28,199,178,44,235,252,121,89,247,8,39,114,16,136,154,38,4,95,131,7,131,14,130,217,34,60,201,106,161,
166,61,252,240,234,213,101,202,132,69,102,69,187,171,146,146,150,45,123,244,209,63,133,1,68,238,97,64,168,126,253,62,251,44,33,1,213,60,68,56,44,50,106,105,37,74,28,62,220,168,17,196,34,82,220,29,233,
232,136,190,252,242,208,161,152,24,169,132,83,20,68,125,236,75,48,237,62,31,16,184,36,125,46,93,186,243,78,41,170,4,58,54,12,85,45,93,122,235,86,252,94,136,171,87,223,121,39,188,3,125,190,38,77,30,121,
228,165,151,230,204,201,203,3,146,64,73,200,117,11,11,23,45,122,237,181,222,189,235,213,139,138,10,23,123,94,120,225,242,101,80,75,142,179,98,69,201,146,114,103,162,28,3,211,158,58,213,182,145,177,160,
94,128,12,4,165,109,201,48,224,14,33,188,20,47,126,226,196,240,225,8,50,208,56,64,133,128,176,197,24,209,123,239,125,249,101,184,241,44,114,184,5,99,186,222,186,245,142,29,149,42,133,115,132,255,52,39,
160,255,4,250,73,185,162,170,18,165,166,126,251,109,219,182,55,207,246,64,22,192,57,209,222,189,207,60,19,22,74,74,231,39,139,199,68,163,71,111,219,22,23,199,152,97,72,64,137,27,136,88,12,39,121,251,237,
87,175,202,234,126,32,224,186,159,124,34,75,177,120,96,143,79,152,128,253,136,28,226,194,133,86,173,202,149,123,234,169,249,243,207,159,47,44,220,177,227,147,79,134,15,239,209,99,201,18,36,142,32,144,
132,88,190,188,95,191,97,195,230,204,217,181,43,20,186,112,97,246,236,193,131,43,86,172,85,235,226,69,84,235,96,76,19,38,200,50,48,82,53,198,188,94,162,90,181,14,29,130,15,112,93,199,17,226,163,143,98,
98,100,125,18,9,110,216,144,145,153,84,172,40,103,161,200,52,25,30,5,37,95,162,232,232,163,71,123,247,14,211,190,200,253,81,123,4,74,122,245,85,153,37,0,63,252,1,30,128,49,191,31,121,180,44,83,246,237,
59,123,118,76,204,143,227,147,199,195,24,209,216,177,223,126,123,51,131,5,246,29,59,174,95,191,221,187,75,149,130,144,4,160,50,38,134,40,58,186,124,249,246,237,31,121,164,66,5,175,87,85,187,117,187,116,
105,240,224,190,125,179,178,242,242,46,92,184,114,229,253,247,33,223,102,76,42,6,209,166,121,249,50,250,4,44,203,113,108,59,63,95,136,43,87,230,204,233,219,183,102,205,176,47,232,217,83,8,128,54,80,199,
3,7,98,137,136,136,138,23,239,211,231,211,79,207,157,11,4,132,64,42,138,165,205,205,77,74,130,73,66,193,135,37,37,106,221,122,245,234,235,215,179,179,111,220,216,187,247,222,123,151,44,217,178,165,120,
113,162,164,164,86,173,122,244,104,214,44,49,145,115,191,31,4,52,12,219,239,175,82,229,232,209,187,238,130,153,232,58,224,179,166,233,58,132,44,68,213,170,229,231,87,170,68,132,59,129,240,0,201,60,231,
68,119,220,241,245,215,56,29,229,215,152,55,250,139,13,0,216,91,114,248,165,74,109,219,214,162,133,20,117,220,76,213,54,107,118,242,100,217,178,69,13,0,246,15,227,73,79,223,188,185,85,43,89,83,67,138,
68,84,162,196,140,25,82,153,51,101,202,216,177,135,14,213,175,143,5,186,239,190,123,239,5,9,131,93,15,188,0,196,16,31,47,68,40,132,58,91,65,129,101,9,241,213,87,146,216,225,28,149,123,93,143,139,251,234,
43,25,38,44,235,235,175,203,149,147,65,73,170,17,52,237,179,207,0,239,16,219,29,71,136,228,100,233,181,100,179,137,156,14,208,169,83,143,30,173,90,249,253,68,166,249,226,139,123,247,246,235,183,109,27,
222,61,51,243,137,39,176,196,242,219,50,166,40,189,122,109,220,88,163,134,244,95,170,10,252,34,255,35,26,62,124,251,118,128,103,249,58,248,10,228,12,51,102,60,255,60,62,27,215,243,187,27,128,92,60,89,
252,32,154,58,117,250,244,176,110,191,104,111,80,84,212,15,63,244,232,241,227,134,39,169,198,47,81,98,221,186,62,125,48,169,23,123,68,85,57,79,72,24,55,14,59,25,187,244,242,229,244,116,184,66,217,205,
8,214,0,159,15,12,96,24,48,0,148,127,100,135,239,164,73,112,221,50,127,6,90,72,73,25,52,104,214,172,141,27,191,254,122,224,192,82,165,208,139,35,5,107,64,21,175,189,38,132,101,89,150,60,35,192,117,145,
100,202,201,193,184,82,36,136,128,151,40,126,105,218,235,175,203,82,179,109,11,81,88,120,199,29,16,125,130,133,0,229,52,108,216,210,165,201,201,224,12,35,249,20,217,70,179,113,227,75,47,97,67,133,51,127,
201,170,214,174,189,99,71,233,210,24,168,241,159,234,131,126,177,7,0,2,128,59,108,216,48,59,187,88,49,220,228,155,47,135,232,197,23,63,251,44,41,9,9,86,81,2,25,201,227,130,5,19,39,2,226,33,163,0,107,80,
186,116,40,36,41,212,64,64,136,188,188,134,13,165,134,95,182,110,120,189,40,226,132,235,240,109,218,204,157,139,10,28,212,70,182,29,8,244,238,45,123,123,194,93,63,136,167,62,95,229,202,9,9,146,52,150,
114,118,211,68,67,91,187,118,133,133,66,4,131,5,5,178,50,184,98,197,109,183,201,36,144,49,244,17,107,154,97,64,104,46,191,175,215,59,122,180,44,101,161,20,60,109,154,215,171,235,192,253,114,201,252,254,
57,115,166,76,129,65,48,38,161,160,212,12,69,71,215,174,189,127,63,64,51,104,53,124,158,204,81,166,77,251,244,83,92,201,127,218,52,66,191,52,3,0,134,69,32,216,190,125,220,184,112,59,86,81,67,169,86,109,
195,134,214,173,165,174,173,168,23,33,34,122,229,149,29,59,116,93,170,136,195,170,224,251,239,7,76,195,14,116,28,33,6,12,192,222,69,234,132,197,199,44,111,198,252,126,162,74,149,22,46,188,112,97,216,176,
154,53,115,114,132,8,4,2,1,215,21,226,203,47,101,2,40,169,30,192,51,105,4,24,229,18,110,231,146,5,109,175,55,58,250,211,79,101,142,47,196,201,147,205,155,247,233,115,230,204,226,197,165,74,97,231,73,225,
167,12,48,32,117,253,254,152,152,35,71,80,151,112,28,144,192,39,78,148,42,5,179,147,132,184,166,113,94,182,236,129,3,61,123,74,13,32,240,0,8,117,93,231,220,52,95,120,225,243,207,33,107,135,17,224,238,
98,34,186,207,119,226,68,157,58,191,6,43,72,191,52,9,68,93,95,81,56,111,217,242,234,85,196,86,32,246,162,228,197,168,81,211,167,135,203,31,145,191,99,76,81,234,212,9,133,208,1,44,155,193,100,43,85,143,
30,178,223,15,53,120,33,122,246,244,120,100,90,37,91,170,144,29,152,166,170,14,28,120,254,252,212,169,49,49,134,193,88,211,166,43,86,192,121,143,25,35,77,15,236,3,60,20,18,83,192,46,217,154,130,157,103,
24,8,38,72,224,188,222,193,131,175,92,113,93,219,222,190,253,246,219,17,34,222,121,231,242,229,127,254,211,227,1,242,0,151,7,93,32,76,140,40,46,110,195,6,96,11,89,164,58,126,28,164,20,150,202,48,176,144,
140,181,108,153,157,93,174,156,100,254,208,138,34,27,197,24,171,80,97,197,138,182,109,225,219,16,42,12,3,138,0,198,136,134,13,91,182,76,10,217,255,144,16,128,108,159,136,104,203,22,180,51,162,135,78,234,
255,81,111,175,92,121,247,110,184,77,208,69,145,39,3,16,197,199,95,187,118,207,61,146,165,195,237,147,52,76,249,242,80,205,6,2,146,253,107,222,28,53,7,69,241,251,155,52,233,210,165,79,159,244,244,132,
4,69,209,245,22,45,214,174,221,184,177,90,53,217,90,13,90,170,106,85,89,207,147,67,101,176,200,114,154,144,223,95,186,116,175,94,53,107,150,42,37,23,79,58,89,249,29,225,55,42,87,70,65,90,214,9,111,187,
109,247,238,21,43,210,211,77,147,168,100,201,59,238,120,231,157,62,125,106,214,244,251,17,140,76,211,52,39,79,150,211,135,160,105,156,53,43,42,74,154,31,104,115,195,64,161,236,173,183,14,29,10,131,95,
112,11,156,155,38,238,197,211,79,207,157,27,19,19,198,9,225,110,103,195,224,60,51,179,73,19,153,106,254,1,33,128,115,40,236,219,181,219,181,171,88,49,73,92,200,134,74,148,87,25,155,61,251,173,183,176,
163,99,98,100,190,107,24,149,42,165,167,215,172,153,144,48,127,254,148,41,48,28,80,199,120,13,190,144,223,255,222,123,82,52,229,186,66,204,153,147,144,128,91,88,172,216,196,137,50,59,216,187,247,254,251,
39,77,218,189,123,240,96,236,228,112,219,40,10,44,192,40,225,101,7,139,175,170,186,94,165,10,28,188,16,39,79,246,237,139,102,17,175,87,242,113,192,4,48,99,132,10,20,112,164,166,175,119,239,99,199,198,
140,233,220,121,197,10,121,37,239,188,147,144,32,21,203,141,26,229,228,200,0,38,68,126,126,155,54,48,235,240,20,36,153,233,16,237,222,61,101,74,92,92,147,38,141,27,87,169,18,110,43,71,179,75,98,226,218,
181,157,58,253,88,2,2,32,249,196,19,223,126,251,7,165,129,82,157,227,245,18,77,155,214,175,31,220,166,164,47,65,225,106,26,99,119,222,153,157,29,31,47,91,197,16,43,235,212,153,52,105,199,142,156,156,237,
219,215,174,93,183,46,54,22,173,79,138,2,166,61,146,94,30,61,250,242,229,220,92,220,222,175,190,170,85,11,55,209,52,7,15,70,102,14,41,149,16,159,126,90,161,130,76,147,100,84,150,149,127,220,108,25,128,
228,32,42,85,77,78,94,178,4,132,82,48,40,68,97,97,255,254,166,137,202,156,156,239,41,247,157,36,173,35,75,215,170,74,84,185,242,156,57,216,225,8,54,66,188,250,42,40,108,198,76,179,103,207,227,199,113,
117,89,89,123,247,182,106,37,133,96,72,68,101,31,177,170,42,74,165,74,39,78,172,90,149,153,121,230,204,142,29,111,191,45,217,70,77,3,210,185,255,254,29,59,164,17,71,222,125,206,21,37,57,121,223,190,250,
245,255,32,34,8,42,61,162,154,53,231,207,175,92,25,187,14,209,75,150,64,188,94,162,195,135,123,245,10,207,4,54,77,162,26,53,86,172,8,55,87,94,191,158,150,198,24,90,162,80,25,15,83,53,93,186,28,58,212,
162,69,221,186,253,251,15,28,216,164,73,106,170,20,73,149,43,151,149,37,85,126,96,241,134,12,145,163,215,34,151,30,70,23,110,170,64,194,40,175,189,117,107,33,160,32,0,84,220,177,163,88,49,8,185,128,213,
195,160,21,230,128,253,171,105,140,233,58,80,59,74,83,96,18,161,57,222,190,189,106,85,169,223,55,140,170,85,219,181,235,223,191,115,231,202,149,71,140,88,177,162,68,137,112,29,66,215,209,236,5,31,117,
215,93,210,144,133,16,226,155,111,146,147,35,225,52,209,250,245,82,91,125,115,250,204,249,160,65,211,167,255,167,109,99,244,203,33,160,199,195,216,200,145,175,191,238,241,192,169,34,138,201,146,9,209,
227,143,239,218,37,33,140,172,202,255,235,95,40,158,218,54,240,241,103,159,17,161,251,31,32,168,101,203,103,158,233,213,171,116,233,70,141,110,220,104,215,14,181,56,121,206,15,110,88,237,218,178,19,88,
230,231,31,125,20,29,45,59,254,36,31,24,30,234,8,172,142,107,146,170,34,162,247,222,67,126,17,8,64,175,35,68,227,198,18,196,65,47,32,211,66,236,85,84,255,228,112,56,191,159,115,198,62,254,56,156,167,132,
66,174,155,157,221,170,21,92,184,44,132,131,47,32,250,226,139,37,75,136,186,116,25,60,184,87,47,104,137,77,83,142,157,206,202,194,177,152,215,174,185,174,16,55,110,244,238,141,187,231,243,193,204,110,
191,253,220,185,155,103,144,72,42,186,90,181,229,203,171,86,253,207,74,67,255,1,17,68,84,162,196,135,31,166,167,75,29,172,164,53,85,21,249,241,145,35,173,90,201,84,17,95,54,54,118,222,60,236,154,64,0,
203,151,151,39,181,174,68,37,74,72,244,44,196,213,171,221,186,17,121,60,178,239,7,66,78,195,32,170,90,85,22,132,228,16,184,89,179,208,39,40,253,7,82,52,64,82,92,167,164,96,57,143,137,169,95,127,240,224,
81,163,142,28,129,25,97,247,57,142,16,159,126,250,218,107,237,218,85,171,134,188,94,178,134,50,125,148,187,215,239,135,49,121,189,152,23,146,159,31,190,146,139,23,91,180,144,121,187,97,168,170,166,97,
128,36,231,68,7,14,220,184,33,125,214,144,33,192,38,186,174,40,21,43,74,47,226,186,129,128,227,8,49,99,6,124,171,212,25,19,173,90,133,87,20,157,61,206,152,174,251,253,99,198,244,235,23,25,4,126,62,43,
240,139,196,133,140,97,74,111,213,170,21,42,236,223,239,56,152,166,199,152,109,135,66,170,106,219,193,160,235,254,253,239,161,208,170,85,56,244,145,49,199,49,77,206,147,147,83,83,49,211,23,5,100,34,159,
207,117,209,237,146,156,188,98,197,237,183,227,248,39,33,98,99,235,214,37,10,6,113,52,139,60,219,39,20,82,148,194,194,61,123,224,164,229,80,133,165,75,101,201,201,235,149,163,22,132,64,47,144,109,59,14,
231,73,73,165,75,223,119,223,232,209,235,214,237,221,59,121,114,253,250,57,57,235,215,227,58,240,206,156,159,59,183,111,159,223,223,187,247,210,165,7,15,126,252,241,179,207,182,107,151,154,138,73,95,156,
219,182,227,32,192,105,90,94,30,50,149,130,2,198,118,236,128,180,197,117,33,253,204,202,186,116,73,246,45,97,164,67,126,190,174,135,66,66,164,164,152,166,223,143,241,210,154,246,198,27,207,60,227,56,161,
16,70,214,133,135,106,24,134,235,18,153,102,66,66,97,33,42,28,150,165,40,156,63,251,108,255,254,126,63,70,80,160,27,74,142,148,200,203,219,181,43,61,61,57,89,14,202,254,69,39,144,252,82,12,160,235,138,
50,109,218,208,161,184,245,69,39,92,50,22,21,181,109,91,231,206,145,165,74,16,168,51,103,74,138,4,216,254,228,73,217,73,251,226,139,178,202,143,62,158,171,87,83,83,37,233,42,245,61,184,45,207,62,11,162,
21,92,254,194,133,41,41,178,214,6,252,14,208,39,185,191,250,245,7,14,156,62,125,229,202,197,139,159,126,186,65,3,185,151,147,147,49,81,0,241,91,136,87,94,145,55,174,116,233,187,239,158,48,97,213,170,185,
115,199,143,239,214,13,9,32,232,22,4,190,176,170,48,58,122,211,38,33,44,43,63,31,164,243,91,111,73,152,89,116,74,18,209,107,175,229,231,219,182,101,65,80,238,56,5,5,240,106,140,69,69,57,14,138,82,146,
53,124,235,45,198,160,94,144,233,54,209,220,185,207,60,35,19,213,240,108,98,195,96,172,100,201,165,75,27,55,6,125,246,203,56,193,255,32,11,72,73,217,177,163,76,153,31,215,248,20,133,168,91,183,117,235,
138,23,47,154,163,162,235,167,176,16,203,143,42,220,224,193,210,201,79,155,102,89,174,107,89,182,141,210,75,110,110,167,78,97,218,71,46,45,231,181,106,45,93,58,115,38,154,190,3,129,233,211,43,85,66,116,
150,173,151,97,162,135,232,206,59,103,207,94,177,98,202,148,135,30,74,75,11,35,2,36,116,45,90,28,60,40,247,205,135,31,130,142,65,229,18,64,173,94,189,97,195,230,204,89,181,106,196,136,196,196,162,7,81,
224,243,84,149,243,180,180,15,63,132,54,241,216,177,233,211,87,173,194,184,89,240,249,145,223,122,254,124,40,143,100,145,186,160,160,83,39,25,152,176,37,44,11,228,117,118,118,155,54,97,138,75,34,151,182,
109,87,173,2,245,4,44,37,17,152,105,18,77,153,242,242,203,24,110,33,155,235,127,39,30,128,232,137,39,22,45,10,207,216,137,244,14,9,9,179,102,13,25,130,3,22,111,6,47,99,199,162,27,8,201,93,124,60,138,52,
68,211,167,219,54,140,3,49,249,202,149,110,221,164,46,7,175,245,122,137,188,222,221,187,199,140,241,122,107,213,186,253,246,102,205,106,215,142,141,69,21,1,13,89,96,32,176,248,77,155,174,91,183,116,105,
255,254,149,43,35,187,151,216,90,82,194,138,146,154,218,187,247,83,79,13,30,156,158,158,144,16,174,215,203,86,112,198,24,43,94,60,61,253,173,183,142,29,123,251,109,16,93,216,131,248,44,64,203,232,232,
198,141,155,54,109,210,164,102,77,175,247,205,55,119,237,74,74,10,15,136,9,27,192,178,101,96,51,224,181,10,10,66,161,134,13,165,4,53,45,109,206,28,121,63,174,93,27,48,0,253,0,114,200,4,152,135,248,248,
229,203,31,124,16,223,64,182,149,0,24,19,53,108,184,107,23,210,79,77,67,123,253,239,150,5,96,130,5,128,86,209,101,174,91,119,253,250,186,117,97,169,69,205,70,85,61,158,188,188,15,62,152,55,111,242,228,
86,173,162,162,160,214,99,140,232,229,151,29,7,187,9,21,180,220,220,6,13,136,228,236,112,180,134,153,230,170,85,159,127,46,37,36,80,237,162,102,142,179,66,241,124,162,184,184,111,190,57,126,252,161,135,
74,150,140,212,249,71,102,9,186,142,170,95,116,52,190,13,198,68,74,22,81,242,26,120,191,178,101,223,127,255,242,229,30,61,36,153,43,71,62,64,211,75,196,185,223,15,212,254,193,7,155,55,163,98,87,116,22,
224,132,9,182,125,227,6,194,94,48,232,56,193,32,24,13,192,214,146,37,187,116,89,180,104,205,154,207,63,63,117,74,42,24,37,97,4,61,128,170,62,245,212,180,105,81,81,140,105,26,0,54,231,80,90,115,78,180,
99,71,155,54,146,7,249,29,121,128,90,181,50,51,65,96,254,216,234,250,245,251,248,99,196,238,200,2,48,18,189,17,35,214,174,13,163,117,12,74,212,52,162,196,196,61,123,36,190,183,109,215,253,224,3,57,42,
77,206,251,32,90,186,116,221,58,89,109,64,238,128,189,140,93,143,66,137,170,222,125,247,153,51,211,166,129,121,36,82,85,244,211,202,35,96,13,3,48,78,26,4,228,153,216,169,30,79,88,135,8,20,174,170,232,
121,168,85,235,196,137,133,11,203,150,149,199,212,250,253,48,16,233,191,80,226,37,154,55,111,233,210,155,245,206,68,197,139,159,58,133,180,21,245,129,151,95,150,114,85,69,137,143,15,207,16,218,189,27,
227,240,49,134,6,223,217,52,57,87,213,42,85,150,44,169,87,15,134,1,177,45,148,132,216,58,11,23,74,22,244,231,163,0,250,57,110,63,178,83,101,198,140,241,227,101,37,171,232,115,226,227,151,46,189,239,62,
236,187,155,15,96,242,122,183,111,111,217,82,146,194,81,81,216,147,120,199,166,77,131,193,171,87,11,10,2,129,139,23,103,204,0,163,135,120,138,27,52,102,12,118,72,184,110,166,235,68,177,177,149,43,255,
227,31,79,61,213,182,109,98,34,81,153,50,159,125,118,250,244,125,247,69,142,116,15,239,53,57,165,40,76,196,134,79,8,241,122,101,116,13,119,15,200,234,29,152,201,119,223,61,112,224,241,199,163,162,76,179,
76,153,187,239,30,52,168,83,167,178,101,129,75,100,176,35,74,76,60,112,224,153,103,164,123,15,123,203,219,111,63,122,244,218,181,235,215,11,10,192,125,72,134,64,38,207,208,73,246,236,185,97,67,88,81,8,
226,9,62,82,81,166,78,237,219,23,70,140,129,251,184,63,152,171,122,225,66,124,188,244,91,191,161,7,128,220,67,182,61,101,101,165,165,201,158,95,57,237,23,88,185,78,157,45,91,98,98,194,170,63,41,104,212,
52,8,71,189,94,57,151,19,37,82,20,120,56,175,90,245,244,233,190,125,7,13,122,246,217,230,205,229,46,10,103,43,93,187,110,218,148,150,134,47,14,122,198,52,137,18,19,71,141,146,3,96,190,253,182,127,255,
109,219,62,250,40,57,57,92,254,65,54,32,247,173,140,220,48,212,180,180,30,61,122,245,234,211,167,99,199,216,88,169,240,145,67,37,165,25,200,170,37,188,201,93,119,109,216,48,107,214,211,79,31,61,42,43,
17,61,122,200,126,35,180,113,18,149,47,127,236,24,134,59,73,63,7,69,115,114,114,175,94,207,61,215,191,255,244,233,11,22,200,115,7,128,71,36,12,86,213,168,168,45,91,58,116,32,194,190,7,3,9,204,65,116,223,
125,11,23,70,71,203,49,151,140,1,19,97,123,108,220,216,187,119,152,255,248,205,12,64,178,212,138,66,212,178,229,214,173,242,104,151,112,169,23,151,59,110,220,228,201,225,17,202,8,17,112,91,177,177,95,
127,221,165,139,20,102,201,142,34,25,28,214,172,25,54,44,156,156,98,201,202,150,237,209,227,233,167,219,181,107,221,122,197,10,244,240,35,176,0,237,122,60,47,188,128,94,125,160,107,203,234,215,79,26,100,
216,91,73,249,100,100,138,166,105,237,219,111,218,4,2,231,198,141,73,147,18,19,101,215,29,60,132,84,16,221,44,112,77,77,253,238,59,12,162,64,234,119,225,66,227,198,210,253,202,250,104,167,78,199,143,183,
107,215,190,253,192,129,221,187,87,174,140,208,20,166,169,20,229,216,177,118,237,128,124,12,3,3,178,229,217,35,134,49,100,200,164,73,178,56,29,38,118,56,39,138,139,219,185,179,86,173,176,162,41,242,170,
254,241,143,181,107,165,127,251,141,12,32,124,122,7,44,119,198,140,231,159,151,5,86,169,87,145,238,238,200,145,26,53,194,21,56,153,194,65,175,243,205,55,169,169,178,218,46,247,62,16,120,219,182,251,246,
73,157,43,156,156,170,246,235,183,127,127,118,118,65,193,133,11,167,79,79,152,0,53,128,228,29,21,133,168,114,229,19,39,144,68,73,122,184,113,99,12,96,252,241,168,57,41,87,195,94,43,93,250,212,41,215,117,
221,171,87,193,71,188,253,54,138,86,114,52,108,184,168,20,137,97,12,131,177,239,191,151,227,165,192,35,190,245,150,215,43,187,5,48,93,216,52,159,123,174,160,32,59,187,176,240,210,165,140,140,193,131,101,
144,129,151,100,172,125,251,253,251,53,77,54,137,113,30,21,165,40,40,68,107,90,131,6,223,127,95,165,138,84,92,23,205,186,38,79,30,61,58,92,241,136,220,152,113,113,87,175,70,71,75,93,241,111,102,0,0,42,
128,93,7,15,214,174,141,248,39,75,37,168,97,171,106,122,250,177,99,178,55,80,54,61,33,106,155,230,240,225,163,71,99,63,68,69,201,3,86,30,125,244,200,145,64,224,226,69,33,250,244,145,0,7,10,186,123,239,
197,46,195,110,219,186,181,92,57,36,116,50,128,168,106,157,58,88,120,217,44,38,196,43,175,200,182,173,155,181,114,68,24,49,129,239,208,187,55,168,36,204,252,16,226,216,177,114,229,160,185,69,199,15,14,
132,250,241,123,152,102,102,166,20,138,194,235,172,88,145,156,44,21,71,64,29,81,81,25,25,120,215,96,208,113,110,220,120,236,49,108,21,41,95,225,252,248,241,83,167,10,10,66,161,197,139,171,86,197,216,24,
140,158,83,85,211,252,228,147,254,253,229,209,84,69,213,83,117,235,30,57,82,116,224,78,24,99,44,91,214,189,59,238,220,111,70,5,135,79,237,21,162,78,157,115,231,142,29,147,32,11,95,74,8,140,98,26,56,112,
218,52,140,138,194,156,93,73,78,10,145,144,208,164,201,138,21,56,81,47,63,95,85,137,28,103,229,202,143,62,170,88,81,215,147,147,137,198,141,43,91,214,117,117,61,20,34,178,237,146,37,251,246,85,148,130,
2,215,53,12,162,64,160,65,131,244,244,80,8,44,124,228,57,132,56,98,14,220,129,204,142,49,75,160,232,213,27,70,97,161,227,232,186,166,121,60,30,143,28,71,141,99,101,108,187,66,133,18,37,132,96,204,235,
101,204,182,57,231,188,176,16,231,21,70,158,239,129,67,33,113,252,77,152,116,198,113,177,82,204,234,186,207,60,147,150,102,219,174,107,89,168,64,60,240,64,177,98,66,104,26,52,66,68,207,60,83,190,124,153,
50,170,74,212,161,195,193,131,237,219,51,102,219,193,160,166,65,193,184,108,89,195,134,201,201,56,147,60,12,83,29,71,81,118,238,20,162,97,67,215,213,180,240,129,187,210,179,124,250,105,143,30,152,77,252,
115,31,252,167,243,255,114,170,22,81,122,250,134,13,56,118,17,228,173,101,49,22,12,18,217,182,174,167,167,191,255,190,162,216,182,109,227,236,31,156,151,195,185,101,221,118,155,199,179,126,189,162,88,
150,97,96,215,246,234,213,162,133,227,16,97,24,83,84,212,204,153,174,107,219,156,51,102,89,66,52,107,230,186,166,73,84,88,136,221,215,169,147,105,106,90,126,62,14,159,113,93,199,201,203,59,113,66,85,93,
87,8,192,59,162,101,203,112,8,12,142,146,9,47,30,142,137,140,138,170,84,169,125,251,161,67,39,77,170,87,143,136,177,194,66,92,29,81,40,244,202,43,31,124,240,212,83,213,170,21,47,174,40,142,163,235,242,
8,232,200,59,16,12,114,190,127,191,52,11,220,145,125,251,242,243,113,134,137,109,7,131,138,226,56,177,177,48,78,85,197,216,136,154,53,203,149,195,213,8,65,212,178,229,240,225,66,216,182,166,225,123,76,
152,0,252,20,12,66,19,181,108,89,90,90,177,98,242,251,68,154,58,209,220,185,189,122,17,89,86,209,111,230,56,140,109,219,86,161,130,215,139,83,214,127,35,3,32,194,193,170,142,163,40,53,106,236,220,9,11,
199,145,79,154,230,56,154,166,40,66,116,234,116,232,80,110,46,38,123,99,103,224,230,112,174,40,157,58,45,93,138,221,37,143,92,126,228,17,204,12,81,85,69,17,34,16,168,93,59,45,77,142,87,68,24,0,218,197,
251,105,26,99,174,171,170,114,247,41,202,153,51,211,166,193,47,97,177,22,46,60,120,16,199,176,0,8,202,51,192,29,199,113,42,86,236,219,119,226,196,177,99,31,127,92,211,230,205,123,229,21,34,199,241,120,
176,223,85,117,219,182,9,19,86,175,174,87,239,197,23,199,141,27,61,186,83,39,12,138,195,162,225,129,79,116,156,201,147,131,65,156,253,35,132,166,157,58,245,249,231,5,5,138,226,186,182,173,40,56,19,92,
114,116,68,48,96,121,128,21,188,82,247,238,166,137,226,15,14,153,46,91,246,238,187,45,11,80,216,113,92,247,226,197,140,140,14,29,108,27,119,182,168,17,124,252,113,151,46,114,19,22,89,68,126,254,124,70,
70,131,6,178,60,246,27,24,0,46,22,131,221,75,150,244,122,51,51,17,115,165,126,70,178,115,61,123,206,153,35,207,8,197,87,196,64,21,215,245,120,218,181,251,228,19,140,79,145,187,51,54,22,96,14,139,104,154,
150,85,191,190,164,130,29,103,231,78,196,115,4,18,162,131,7,133,192,8,24,33,84,85,8,93,15,4,50,50,178,179,101,152,249,240,195,129,3,47,93,114,28,69,193,13,118,28,156,6,234,56,37,74,76,156,56,99,70,237,
218,235,214,13,27,118,223,125,195,135,127,251,237,210,165,171,87,227,36,96,195,224,220,117,63,251,236,251,239,103,204,232,221,187,79,159,143,62,186,116,233,209,71,191,255,254,225,135,161,19,144,208,13,
167,139,5,131,171,87,247,233,179,127,63,72,165,211,167,143,31,63,123,22,38,28,238,40,220,187,23,223,82,158,5,124,230,76,126,126,24,177,87,171,38,123,134,113,16,174,109,39,38,18,89,22,231,56,23,153,232,
235,175,31,124,16,159,23,121,255,137,56,207,200,184,124,185,94,189,155,77,195,117,117,61,47,111,239,94,48,167,191,217,136,24,185,7,57,111,220,120,214,172,114,229,34,211,35,73,157,26,198,137,19,101,203,
202,190,95,57,248,5,200,187,67,135,205,155,101,229,80,190,223,23,95,96,120,130,148,85,92,191,94,182,44,114,0,206,21,229,209,71,133,16,34,47,15,56,61,43,171,94,61,121,148,138,60,131,60,53,117,251,246,254,
253,203,148,233,218,245,177,199,170,87,143,141,149,218,3,176,122,160,106,21,229,197,23,207,156,25,51,230,182,219,240,90,57,101,180,122,245,69,139,176,183,47,95,254,199,63,18,18,160,198,199,29,41,81,162,
109,219,181,107,119,238,196,45,13,15,190,85,85,195,48,77,85,77,77,109,220,184,107,215,106,213,42,87,158,60,249,181,215,144,1,200,10,2,81,141,26,103,206,160,39,1,218,134,215,94,131,4,20,56,97,218,52,57,
184,14,97,48,16,0,49,6,190,66,81,24,139,142,62,117,170,114,229,162,26,32,57,90,127,252,248,209,163,111,174,53,96,124,68,183,110,51,102,252,18,137,232,207,48,0,52,131,16,61,244,208,212,169,81,81,69,147,
20,16,168,245,235,111,222,124,115,38,42,167,124,127,243,205,128,1,69,205,141,232,161,135,242,243,93,55,47,15,101,82,215,93,186,84,102,13,156,51,150,148,52,126,188,148,75,229,228,116,235,22,62,92,86,211,
116,221,227,81,213,217,179,63,254,24,213,2,85,53,77,201,157,71,206,249,79,77,93,181,106,203,150,186,117,49,192,25,56,223,48,228,161,141,165,74,181,107,119,231,157,152,208,27,166,93,49,223,200,227,25,52,
232,226,197,103,159,149,45,170,210,104,35,41,100,77,171,86,109,215,174,22,45,228,100,31,41,140,235,218,181,160,0,146,151,80,232,205,55,49,43,68,14,203,104,209,34,63,63,220,107,36,196,174,93,178,161,14,
83,213,116,157,232,139,47,134,15,47,186,204,114,178,81,131,6,251,246,221,156,33,192,244,26,53,250,230,155,98,197,126,190,66,144,126,58,15,8,74,150,243,231,158,123,229,149,155,47,15,201,221,128,1,227,199,
123,60,69,47,65,118,209,228,230,22,47,94,180,52,196,185,199,51,123,118,126,62,150,216,182,51,51,49,61,0,248,220,235,37,186,247,222,13,27,198,143,255,230,155,1,3,138,23,151,101,90,41,175,38,186,251,238,
211,167,83,82,96,148,50,249,147,3,93,112,139,58,116,56,113,98,244,104,20,120,96,162,50,39,193,192,233,176,15,148,66,108,80,178,200,236,137,106,212,216,179,103,249,242,184,56,121,195,101,139,9,216,59,224,
152,1,3,54,110,132,255,128,169,224,192,139,248,248,231,158,251,242,203,55,223,220,188,249,254,251,37,211,47,181,8,47,189,116,253,58,22,63,20,202,205,197,121,168,232,72,192,252,115,156,173,86,116,179,128,
253,243,120,116,253,248,241,196,196,200,125,30,62,106,102,198,140,95,34,17,253,25,6,0,14,48,46,238,205,55,31,126,248,230,203,3,149,58,127,126,231,206,55,247,255,1,13,167,167,99,202,239,205,185,173,162,
60,251,172,235,110,219,182,99,199,212,169,165,74,193,91,200,202,183,223,63,117,42,114,98,233,34,81,36,129,48,36,33,225,244,233,187,239,150,237,227,114,20,3,188,132,207,167,170,170,250,210,75,135,14,225,
76,31,244,221,162,182,128,0,35,199,205,155,38,206,8,147,103,150,73,113,155,60,159,76,215,167,76,57,114,164,118,109,217,247,40,79,55,146,188,167,97,16,173,88,49,122,180,164,140,177,79,195,131,165,159,124,
114,201,18,24,159,108,1,195,169,201,223,127,191,109,219,137,19,0,110,32,158,160,95,134,151,85,148,96,48,33,33,178,141,70,206,24,215,245,47,190,184,255,254,162,34,48,80,234,49,49,211,166,221,115,207,111,
108,0,156,19,149,41,243,201,39,117,235,22,221,203,168,74,37,37,173,88,81,165,202,205,23,128,175,60,113,226,232,209,145,39,97,133,191,84,195,134,123,246,152,38,246,141,100,219,64,244,212,170,181,114,101,
221,186,128,137,178,173,82,190,39,209,215,95,79,159,14,71,28,121,60,156,172,19,22,47,62,117,234,138,21,181,106,201,158,26,204,40,146,210,177,199,106,153,199,0,0,32,0,73,68,65,84,162,211,197,35,71,194,
201,214,208,200,137,34,195,134,109,217,210,186,181,100,238,193,183,67,212,9,88,151,150,118,229,74,195,134,184,70,89,125,128,110,87,81,138,21,91,185,178,89,51,236,111,57,44,19,128,49,41,233,142,59,150,
47,71,87,161,156,155,32,165,181,68,223,126,11,61,117,228,70,66,233,171,127,255,183,222,186,121,251,193,32,199,143,31,48,224,231,87,3,213,159,206,3,8,225,186,134,161,235,241,241,153,153,69,127,99,219,156,
59,78,185,114,23,47,98,70,78,152,168,0,226,39,186,235,174,206,157,161,14,140,28,29,41,132,235,62,246,216,236,217,129,0,166,127,99,78,54,231,138,98,219,68,205,155,31,63,190,127,63,220,185,109,11,33,207,
12,117,93,199,105,218,180,106,213,166,77,57,7,122,198,24,73,236,108,199,33,138,138,122,253,117,195,120,244,209,172,44,34,69,9,133,112,61,142,67,4,154,201,117,27,54,172,94,189,76,153,18,37,18,18,56,63,
117,234,252,249,172,172,3,7,246,236,33,130,10,15,36,150,235,34,129,27,51,230,224,193,151,95,38,90,185,18,239,193,185,101,65,161,7,181,226,137,19,175,188,50,113,98,227,198,72,113,45,43,156,136,90,86,65,
193,218,181,119,221,245,195,15,56,35,21,105,34,174,52,39,103,217,178,55,222,168,90,245,208,33,140,159,68,10,7,78,195,178,150,46,109,223,254,227,143,49,112,18,119,12,247,44,47,111,239,222,123,239,149,9,
106,248,8,45,219,118,156,163,71,211,210,60,158,194,194,159,201,4,252,116,9,8,118,80,253,250,11,22,220,44,3,67,45,252,193,7,199,141,139,141,85,20,84,251,100,191,92,177,98,143,60,50,108,24,56,42,56,104,
233,66,241,249,215,174,37,36,96,87,34,6,75,23,91,162,196,231,159,63,252,176,156,181,31,62,105,15,117,180,245,235,187,119,151,51,0,195,103,131,203,42,195,152,49,27,55,150,45,11,45,49,231,0,121,82,155,92,
181,234,196,137,39,79,230,228,220,184,129,57,253,66,88,86,94,222,245,235,217,217,155,55,143,28,89,186,52,62,17,45,42,82,255,203,216,3,15,28,62,92,189,58,170,22,144,123,200,118,78,204,244,216,185,19,195,
241,36,26,146,189,135,68,237,219,207,157,155,154,138,59,132,64,133,241,18,68,68,227,198,13,29,138,69,244,120,32,100,147,126,54,45,45,63,191,87,175,30,61,64,166,203,114,51,99,186,94,161,194,188,121,165,
74,193,156,32,95,7,57,79,212,170,213,148,41,9,9,191,97,8,64,220,236,218,245,195,15,127,28,105,208,174,248,210,75,114,248,153,212,229,13,29,234,186,96,220,183,111,79,75,147,53,66,85,213,117,211,236,218,
245,149,87,222,121,231,244,105,252,20,142,31,186,94,211,244,122,83,83,183,110,141,141,5,83,94,244,4,17,162,142,29,87,174,132,226,240,230,193,233,68,186,222,182,237,129,3,53,107,2,143,203,86,112,128,190,
178,101,23,47,150,93,251,225,7,230,130,163,63,32,43,107,236,216,228,100,169,30,144,67,90,84,149,104,248,240,249,243,163,162,208,252,18,62,248,65,186,244,7,30,88,191,94,10,59,224,226,33,60,97,44,53,117,
238,220,230,205,1,57,49,78,3,130,79,211,36,234,210,229,220,185,87,94,25,54,172,90,53,4,31,140,152,102,172,114,229,172,44,203,178,172,80,232,250,245,174,93,165,18,9,64,55,37,101,218,180,6,13,164,52,92,
134,62,93,103,172,118,237,57,115,144,158,255,38,197,32,236,105,211,124,241,197,97,195,110,238,84,65,35,232,123,239,161,19,63,172,203,235,223,31,227,218,49,70,105,223,190,248,120,9,147,170,86,221,190,93,
222,254,229,203,209,21,39,15,123,243,122,161,28,152,57,83,182,81,22,205,29,20,229,147,79,250,245,147,178,144,31,75,206,178,178,186,119,71,196,246,249,176,239,60,30,162,226,197,159,125,22,51,3,228,249,
33,97,3,64,35,183,76,204,114,114,30,120,192,231,51,77,41,61,193,158,245,122,151,47,31,49,66,86,255,17,211,161,74,50,77,198,76,243,135,31,58,117,10,203,201,100,35,156,97,16,77,156,248,207,127,134,143,185,
9,167,198,221,186,229,229,65,4,231,56,175,189,134,206,71,34,206,171,86,197,80,90,252,119,237,90,167,78,178,176,174,40,138,18,23,55,105,82,143,30,225,118,113,84,92,209,152,62,111,94,197,138,191,161,7,0,
39,246,241,199,29,59,222,236,1,56,87,213,196,196,41,83,90,181,146,121,52,78,197,61,125,90,222,94,215,13,6,243,243,135,12,129,155,52,205,149,43,195,29,244,66,124,245,85,84,20,166,100,201,214,46,162,213,
171,31,124,16,217,121,209,93,78,84,163,198,162,69,21,43,34,231,254,113,70,60,111,222,148,41,68,224,5,228,108,64,162,90,181,208,198,137,89,194,82,66,34,13,0,55,27,147,254,224,29,102,206,196,81,114,242,
29,60,30,162,180,180,204,204,118,237,228,208,43,57,117,4,185,133,170,246,237,251,241,199,242,153,69,199,231,221,115,207,199,31,199,196,200,41,197,50,227,104,217,18,13,164,152,47,38,196,195,15,75,173,223,
167,159,98,219,56,14,68,164,71,143,202,230,84,244,88,191,244,210,115,207,33,11,145,165,56,217,126,243,221,119,141,26,253,108,125,231,79,7,129,216,159,105,105,25,25,104,81,136,36,35,57,143,141,141,142,
70,247,139,101,225,178,202,149,43,93,26,35,214,240,5,12,163,94,61,152,70,227,198,173,90,89,22,78,233,68,113,169,97,67,20,129,176,24,197,138,149,42,85,173,218,188,121,96,31,35,63,73,8,206,91,180,200,204,
60,127,222,182,53,45,20,138,228,197,25,179,237,135,30,106,212,104,232,80,198,80,179,55,77,236,162,182,109,191,251,174,117,107,12,121,199,188,240,162,156,121,184,169,2,48,142,232,145,71,102,207,174,81,
35,16,192,137,166,68,142,227,245,158,56,49,114,228,59,239,120,189,144,149,131,205,3,116,13,4,132,88,187,54,57,185,74,21,206,67,33,85,149,144,206,178,52,77,81,54,108,168,84,41,53,53,41,73,118,52,134,66,
138,226,241,220,113,71,98,98,48,136,26,3,231,68,175,188,98,24,182,237,186,201,201,37,75,18,185,46,208,76,40,100,219,21,42,200,51,75,112,200,212,233,211,241,241,168,190,194,112,1,207,133,32,186,114,69,
14,199,252,13,138,65,66,216,54,145,215,155,154,154,153,25,137,228,17,161,44,203,227,17,226,252,121,233,27,44,139,49,195,64,95,16,48,42,99,56,24,222,113,132,232,208,65,226,118,52,119,36,37,165,164,0,27,
51,118,207,61,11,22,124,253,245,194,133,166,217,188,57,92,117,100,73,150,40,46,174,65,131,77,155,242,242,60,158,64,64,85,35,121,113,215,245,120,70,140,120,228,145,252,124,32,116,198,112,132,108,135,14,
211,166,165,164,4,131,186,142,78,161,162,175,10,51,237,40,42,1,133,19,181,104,241,193,7,181,107,219,182,235,50,166,105,161,80,32,192,216,7,31,28,60,56,108,88,40,196,152,109,67,47,96,89,8,10,66,100,102,
158,61,219,172,153,227,224,216,89,128,52,12,137,169,91,183,92,185,79,62,89,184,240,187,239,122,246,116,93,228,56,209,209,216,12,142,131,212,212,178,42,84,144,99,106,101,255,34,145,109,171,106,32,192,88,
97,33,6,199,131,76,190,114,37,38,38,62,30,149,88,252,84,30,215,155,149,85,165,202,207,173,6,170,63,117,249,21,197,113,44,139,200,52,243,243,81,105,139,188,245,186,158,144,144,152,120,237,26,90,173,80,
142,221,185,83,81,108,91,81,66,33,77,35,178,44,215,221,180,137,200,117,13,99,199,14,20,80,24,131,165,3,21,51,230,56,15,60,48,105,82,108,172,162,16,89,214,236,217,67,135,126,246,25,142,79,10,23,69,99,98,
226,226,214,173,99,12,203,175,235,72,13,145,22,245,237,187,101,203,186,117,112,250,72,230,44,171,106,213,49,99,82,83,133,208,245,80,72,215,195,59,238,230,74,27,22,31,39,29,11,65,148,151,215,164,201,208,
161,125,251,230,231,187,174,101,169,42,20,17,47,188,240,237,183,83,166,92,184,96,154,129,128,16,200,74,66,33,77,115,156,235,215,119,236,72,75,243,249,44,171,160,0,207,118,93,34,195,232,214,109,210,36,
143,7,227,241,155,55,247,122,223,127,159,115,199,9,133,206,158,149,6,128,58,162,101,225,58,178,179,207,157,147,91,3,106,169,236,236,172,44,4,96,108,133,203,151,29,199,231,187,122,85,30,156,5,255,26,12,
18,101,101,149,46,141,50,82,248,158,252,191,12,226,39,87,3,97,109,45,90,128,139,46,122,251,52,45,20,50,140,156,156,188,60,219,22,66,215,81,201,82,148,17,35,100,116,114,93,93,191,120,241,139,47,224,124,
119,239,14,19,163,140,49,118,226,196,190,125,68,174,235,247,143,31,159,144,0,137,134,166,165,164,12,28,88,174,28,231,156,131,59,71,41,186,102,77,93,63,117,10,39,109,33,188,184,174,227,24,134,227,36,36,
116,233,242,238,187,56,20,2,251,210,182,147,146,94,127,253,182,219,208,41,168,105,142,35,159,15,166,94,102,3,156,227,157,16,216,128,37,76,211,113,186,119,239,211,71,30,225,140,190,189,99,199,190,251,110,
192,0,34,20,119,145,68,130,187,32,58,124,184,66,133,216,88,152,180,109,163,66,24,19,51,116,168,223,175,40,192,31,94,239,160,65,85,171,114,174,40,185,185,71,142,200,131,31,192,26,172,95,15,105,11,209,236,
217,57,57,114,158,2,99,140,61,255,60,188,2,170,135,140,229,229,69,71,27,6,142,230,6,54,112,93,120,146,140,140,216,88,100,83,66,56,142,105,22,245,157,255,145,1,8,161,235,104,96,204,201,249,191,29,20,103,
154,53,106,92,187,134,219,22,12,26,134,16,126,127,40,244,209,71,95,124,145,151,7,165,255,201,147,221,186,157,62,13,197,79,70,198,228,201,82,202,64,228,186,11,22,236,220,169,40,150,85,167,78,201,146,66,
128,114,21,194,117,107,215,174,82,197,117,133,192,146,216,182,166,17,213,169,179,105,19,17,170,248,186,14,28,193,121,97,33,81,203,150,167,79,31,63,142,223,201,125,220,174,221,93,119,225,54,135,57,62,80,
198,32,108,112,13,8,80,50,146,2,228,193,33,15,29,90,177,162,109,35,133,35,10,4,116,125,238,220,250,245,19,19,45,75,215,101,49,92,26,206,246,237,49,49,165,74,97,140,173,162,120,60,133,133,30,79,205,154,
85,171,202,93,202,88,48,88,165,74,233,210,72,57,215,173,131,6,18,52,154,101,61,247,156,101,57,14,99,30,207,194,133,163,70,157,61,91,80,96,89,182,125,249,242,191,254,53,99,134,97,96,247,163,20,158,147,
163,170,49,49,56,83,156,8,90,2,248,155,107,215,74,150,4,184,102,140,49,156,97,242,43,133,0,198,44,203,117,85,53,57,57,35,227,255,70,38,89,150,235,94,184,128,91,132,200,157,159,207,121,86,86,183,110,93,
186,188,252,242,246,237,71,143,126,254,249,233,211,82,97,227,56,227,199,251,253,173,91,39,38,186,238,185,115,43,87,190,241,134,109,171,42,81,177,98,80,219,56,142,162,184,174,227,32,9,196,217,122,208,248,
8,113,251,237,35,71,98,103,96,137,209,121,28,12,250,124,77,154,108,218,148,157,173,170,142,163,105,56,172,38,46,110,226,68,219,118,93,93,223,179,231,204,25,28,246,226,186,49,49,62,95,181,106,94,175,227,
48,102,219,170,106,89,240,75,96,221,34,207,12,116,221,184,184,49,99,186,118,13,6,25,43,44,212,117,162,96,240,232,209,252,252,70,141,22,47,190,89,126,165,40,121,121,217,217,105,105,219,183,227,218,108,
91,81,130,193,18,37,194,210,53,16,67,37,74,248,124,133,133,66,108,220,248,242,203,3,6,164,165,165,164,88,214,161,67,31,124,112,240,160,162,56,14,99,133,133,68,147,39,47,93,122,255,253,141,27,23,43,246,
207,127,110,217,2,6,20,10,7,33,16,130,225,125,20,197,113,240,42,248,187,83,167,48,203,20,65,192,117,21,229,255,237,3,126,50,6,96,76,85,109,187,100,201,43,87,34,169,94,60,28,71,215,83,82,50,50,136,188,
222,64,64,215,3,1,77,195,79,133,88,188,184,121,243,47,191,220,176,129,8,17,56,20,210,245,80,232,194,133,39,159,124,228,145,65,131,198,141,59,117,106,253,122,206,17,3,207,157,147,196,178,156,220,95,80,
0,60,13,113,135,109,123,189,101,203,238,216,17,142,113,97,116,144,148,148,146,242,249,231,146,28,37,82,85,203,122,233,165,216,88,152,214,228,201,115,231,6,2,182,109,24,193,96,169,82,137,137,173,90,245,
232,113,219,109,240,22,200,36,194,242,22,168,152,0,82,109,187,99,199,58,117,54,110,244,120,44,203,178,84,213,178,114,115,215,175,111,212,104,241,226,155,239,129,235,18,253,240,67,249,242,170,26,10,169,
170,162,88,150,174,59,206,201,147,242,64,76,192,104,77,203,201,9,6,1,219,230,207,223,178,165,122,245,214,173,239,185,167,125,251,11,23,84,213,182,117,221,117,85,85,85,109,59,35,99,220,184,78,157,238,188,
115,203,22,77,179,109,77,195,249,75,248,204,27,55,144,108,170,170,244,98,80,95,42,202,197,139,169,169,88,41,152,192,79,1,132,234,207,169,4,8,17,23,119,224,0,110,219,205,56,218,227,57,123,22,139,17,12,
66,42,166,170,193,32,231,241,241,49,49,56,75,36,24,4,87,102,219,66,48,22,10,157,57,179,113,227,156,57,56,78,9,240,235,196,137,67,135,170,86,5,247,175,40,156,111,222,156,145,1,174,27,169,165,227,84,171,
22,10,21,20,96,119,50,166,170,142,3,38,220,117,83,83,77,243,200,17,69,193,109,68,88,122,236,49,240,242,156,123,60,9,9,143,63,158,144,96,219,154,118,241,226,162,69,211,166,29,59,54,126,124,133,10,134,17,
12,154,38,48,131,244,78,18,141,187,46,208,248,171,175,182,109,27,12,194,207,153,102,32,112,228,200,125,247,21,43,118,233,210,205,121,132,16,135,15,15,26,4,179,33,194,238,59,112,96,243,230,198,141,67,33,
206,53,173,176,208,227,57,112,224,192,1,34,206,109,91,85,57,191,120,241,252,249,147,39,239,186,235,194,5,69,129,223,210,52,200,69,160,116,244,251,189,222,130,130,152,152,220,92,89,202,6,196,43,44,196,
115,81,183,144,167,140,226,188,2,156,98,138,112,129,32,241,171,105,2,25,35,42,91,246,252,121,48,224,55,103,210,134,225,186,170,26,8,168,170,166,217,182,170,10,17,10,233,58,99,49,49,129,192,165,75,186,
30,10,185,174,105,106,90,40,228,56,49,49,193,32,145,97,228,230,50,102,154,142,3,126,208,117,207,159,127,249,229,188,60,24,4,99,182,189,96,193,177,99,66,152,38,150,209,113,136,234,215,223,183,15,41,155,
60,251,87,38,113,53,107,102,101,221,184,129,165,135,207,104,223,62,58,90,2,45,215,117,156,246,237,159,124,242,137,39,30,126,248,153,103,150,44,185,227,142,21,43,190,252,178,160,128,49,93,71,106,38,119,
63,188,15,204,0,231,144,181,108,89,162,4,18,45,36,91,103,206,24,70,177,98,55,167,146,138,66,116,252,120,181,106,146,204,130,38,40,24,124,251,237,64,0,248,201,227,9,133,222,122,235,204,25,195,8,133,252,
126,57,78,63,231,255,35,239,189,227,171,170,186,173,225,181,235,217,167,164,87,32,9,4,66,39,161,73,19,1,5,165,139,40,40,22,4,68,193,7,80,64,4,69,5,84,80,233,136,29,177,0,42,85,8,160,244,34,189,55,41,161,
133,18,18,8,45,36,164,158,178,203,122,255,24,223,252,118,18,158,123,175,250,136,122,223,55,191,159,207,189,154,147,115,246,217,123,173,185,230,28,115,204,49,110,162,201,45,138,166,233,112,248,253,68,39,
181,172,130,130,146,18,151,75,146,188,94,28,79,196,42,100,76,20,235,213,115,185,64,134,199,171,145,3,48,38,8,21,43,114,142,202,232,79,197,1,56,71,215,45,42,202,235,69,73,87,54,4,186,221,85,170,92,191,
142,11,50,77,198,2,1,65,112,56,64,37,247,249,32,139,224,116,150,148,248,253,178,172,170,88,209,245,235,123,189,154,230,243,201,50,112,47,198,84,117,217,178,199,30,219,188,217,52,77,115,243,230,167,158,
154,52,73,85,5,193,235,69,90,7,249,134,227,199,113,32,32,42,137,34,62,43,40,168,122,245,19,39,168,227,6,5,141,23,95,164,219,3,24,11,45,92,73,82,213,208,208,73,147,98,99,183,108,201,205,197,17,96,154,215,
174,109,216,48,101,202,244,233,155,55,231,228,48,118,249,242,193,131,25,25,140,33,199,55,205,206,157,193,48,20,4,93,23,197,43,87,156,78,151,171,60,64,101,24,178,156,149,165,170,84,106,162,83,81,82,178,
100,201,179,207,158,60,233,247,23,23,31,59,214,169,211,183,223,154,102,81,145,203,85,84,4,215,19,89,230,188,168,40,49,209,48,100,217,178,188,94,69,129,203,50,106,9,192,104,129,128,170,98,169,75,146,36,
5,2,140,157,58,85,80,128,67,18,93,12,36,125,150,197,88,118,118,181,106,168,175,44,139,177,242,128,215,127,116,4,144,68,75,32,64,252,27,198,16,154,195,194,26,55,126,252,241,184,184,250,245,175,93,187,122,
149,30,11,231,186,78,169,20,118,52,112,59,65,8,4,100,185,102,205,7,31,236,209,227,236,217,170,85,179,178,110,223,198,10,231,220,239,151,164,141,27,55,110,188,118,13,117,179,36,225,209,115,110,24,209,209,
29,58,180,108,217,178,229,153,51,247,220,115,226,132,105,138,34,125,14,184,253,17,17,231,207,227,92,84,20,203,210,117,198,106,215,198,142,197,171,80,2,162,182,22,132,224,224,102,205,118,237,42,40,136,
142,230,252,218,181,185,115,103,205,10,4,130,131,25,203,203,115,56,198,142,213,245,119,222,121,239,189,23,95,68,41,199,249,99,143,125,253,53,14,23,195,144,229,188,188,194,194,232,232,59,195,107,72,72,
219,182,30,207,23,95,100,103,255,244,211,161,67,62,31,17,98,151,46,93,186,52,60,252,248,241,250,245,193,159,150,36,175,87,20,57,215,52,191,63,58,186,85,43,151,107,204,152,37,75,14,28,192,144,155,40,74,
146,223,47,203,166,105,24,225,225,170,10,248,10,81,206,48,220,110,73,170,87,175,94,189,238,221,99,99,127,254,249,220,57,28,171,140,137,34,150,205,133,11,162,8,212,66,81,2,129,223,148,5,252,214,102,16,
154,180,155,54,181,104,65,38,80,176,126,106,218,116,203,22,66,213,143,31,239,208,161,60,239,175,78,157,217,179,97,35,103,255,102,192,128,91,183,144,211,114,190,100,73,120,56,112,114,10,158,193,193,153,
153,152,58,180,73,37,213,171,239,222,77,114,78,37,37,35,71,58,28,52,114,134,82,42,44,108,249,242,6,13,74,163,104,181,107,95,189,74,112,41,231,67,134,196,197,93,188,104,154,37,37,24,235,186,113,163,111,
223,144,144,99,199,44,235,230,205,30,61,162,163,219,182,253,224,131,159,127,94,189,122,252,248,22,45,34,34,218,181,75,72,248,234,43,152,59,251,253,156,255,250,43,81,77,129,242,77,154,244,210,75,229,101,
241,43,86,220,176,193,238,47,188,249,38,84,203,112,160,8,2,38,4,200,74,139,154,218,237,219,103,100,208,95,172,89,19,23,71,67,173,192,0,238,185,103,238,220,90,181,240,14,104,73,9,130,36,77,156,72,218,137,
156,191,255,190,211,73,162,17,40,94,23,45,234,210,133,230,138,202,119,81,254,227,102,144,44,51,182,121,179,219,77,157,119,81,20,197,240,240,101,203,56,71,47,205,231,179,172,83,167,60,158,178,108,193,251,
238,91,186,20,22,39,164,183,213,162,133,105,194,178,9,162,41,31,127,76,220,91,44,178,196,196,189,123,75,139,78,136,162,166,125,248,33,231,166,233,245,250,124,134,193,121,113,113,203,150,196,16,68,27,53,
60,124,239,222,10,21,16,22,193,79,234,220,249,214,173,210,11,32,33,225,236,89,206,253,126,56,133,165,167,167,164,52,111,126,254,60,231,67,135,134,135,247,237,11,213,48,206,57,223,181,235,254,251,99,99,
147,146,190,252,18,163,93,48,144,134,45,38,61,184,17,35,222,122,171,44,249,85,211,62,248,0,176,144,223,111,24,156,23,20,144,56,164,36,129,207,11,7,81,136,98,131,250,89,163,70,90,26,20,130,48,252,182,120,
49,232,173,36,151,91,173,218,140,25,181,107,83,27,8,143,180,71,15,206,3,1,175,215,178,2,1,175,215,52,135,12,33,38,19,45,128,7,30,64,67,154,116,91,255,164,102,16,66,39,99,140,1,105,103,76,215,93,46,203,
122,224,129,14,29,74,27,165,214,170,213,170,85,89,70,187,44,231,231,231,231,83,150,107,154,140,13,25,162,235,128,64,69,145,49,93,111,215,46,42,74,16,44,75,20,41,159,181,77,89,177,154,163,163,59,116,0,
226,136,19,219,229,106,220,216,229,194,223,224,172,147,229,184,56,28,62,178,140,186,91,150,203,38,170,192,50,17,89,50,51,71,140,200,204,124,240,193,184,184,99,199,126,250,41,49,241,181,215,106,212,48,
77,140,110,221,123,239,184,113,49,49,133,133,0,167,129,211,139,98,76,12,14,19,20,149,183,111,135,133,185,92,165,223,221,225,232,213,11,243,13,168,86,130,130,186,116,113,56,252,126,143,7,201,42,99,126,
63,114,39,76,35,154,38,99,29,59,86,172,136,135,165,170,162,104,89,143,63,142,89,71,98,55,97,150,17,138,128,156,35,183,24,61,90,215,101,89,85,189,94,176,8,219,182,117,187,203,158,243,154,134,12,4,100,188,
255,57,7,248,157,50,113,8,230,150,101,154,154,86,84,196,88,100,164,219,141,11,166,180,176,69,139,242,19,133,121,121,37,37,52,58,2,211,100,226,246,98,20,51,60,188,126,125,206,81,210,16,180,92,246,61,100,
185,118,109,192,182,178,140,243,189,65,3,81,84,85,154,203,179,44,36,81,200,85,8,32,42,143,86,202,114,65,193,199,31,63,253,116,143,30,173,91,31,61,90,191,254,99,143,169,234,218,181,126,127,155,54,36,51,
205,185,36,25,198,3,15,84,169,18,30,174,235,120,56,120,24,156,163,176,211,52,159,143,177,236,108,202,186,237,101,94,181,170,97,160,103,143,223,37,37,121,60,162,88,82,66,91,195,225,72,72,224,156,102,155,
225,32,22,26,42,138,37,37,146,4,165,81,65,104,212,136,198,206,32,147,173,235,144,186,19,4,203,10,4,68,145,177,70,141,68,209,235,21,69,167,19,93,202,154,53,171,86,45,125,37,166,153,146,226,118,99,123,5,
2,191,165,26,248,205,189,0,195,64,143,31,151,168,170,48,96,190,126,221,239,71,10,34,73,232,141,149,71,200,32,154,104,154,170,138,118,7,99,146,84,82,66,146,18,130,192,88,81,81,113,49,13,64,226,21,180,0,
72,241,15,143,6,248,32,184,52,57,57,166,233,247,51,166,170,184,97,138,226,247,187,92,130,128,58,222,214,253,40,125,29,146,20,18,18,26,122,240,224,206,157,161,161,117,234,76,155,214,176,33,99,199,142,57,
157,45,90,32,81,5,19,80,150,25,235,209,227,246,109,76,7,10,2,22,29,110,50,246,50,8,99,101,111,174,105,22,22,2,149,0,8,197,216,209,163,133,133,192,67,104,202,167,168,8,169,177,32,48,86,92,76,119,138,140,
174,101,153,49,232,12,66,27,17,42,34,146,132,158,131,36,225,191,249,124,129,128,203,101,24,88,176,166,73,253,3,251,57,229,228,20,23,35,98,43,138,166,253,105,17,128,154,164,167,78,197,198,162,203,134,194,
44,51,51,35,3,55,73,16,128,153,175,89,83,246,47,13,195,229,114,185,240,53,208,166,153,53,203,237,6,121,20,15,55,39,231,232,81,84,239,160,150,89,150,223,79,83,183,64,231,242,242,86,175,6,18,137,221,194,
216,182,109,94,175,170,90,22,198,175,76,83,215,47,95,46,41,1,154,7,254,45,141,80,18,18,207,121,97,33,99,143,60,210,178,165,40,182,104,177,118,237,61,247,248,124,100,112,111,79,239,3,67,176,44,69,9,4,240,
183,192,219,65,37,149,101,244,35,42,85,66,115,200,254,9,4,214,173,179,203,101,65,96,236,244,105,198,124,190,160,32,42,97,125,190,220,92,73,226,92,211,0,146,49,182,121,115,110,174,97,0,211,7,53,100,223,
62,210,38,167,6,21,96,48,52,197,21,69,16,22,46,116,58,129,6,200,178,101,73,210,190,125,192,69,8,21,21,197,204,76,155,67,225,243,253,137,17,0,181,119,97,97,66,2,231,216,39,166,169,40,105,105,75,150,224,
130,240,165,102,206,60,112,160,116,121,36,8,94,175,219,237,114,161,75,128,194,100,250,244,125,251,52,141,218,53,121,121,211,167,151,148,144,64,179,105,50,102,154,177,177,68,17,3,128,124,251,246,7,31,156,
59,103,155,171,205,155,119,224,0,190,52,241,226,56,207,203,243,120,36,201,178,100,25,123,236,210,37,114,243,181,167,237,25,11,9,25,49,34,50,114,203,150,189,123,113,186,6,5,153,38,50,14,28,98,0,85,247,
237,67,106,69,149,74,32,112,245,42,10,66,252,62,56,248,236,217,178,25,134,207,55,117,106,78,14,254,6,164,245,29,59,116,93,81,16,23,200,87,93,150,81,174,201,178,97,136,226,166,77,171,87,131,33,105,89,178,
108,89,227,199,95,188,8,100,191,244,174,23,197,64,0,9,30,231,162,56,99,198,201,147,72,239,24,147,164,115,231,62,249,4,119,158,230,10,113,85,116,24,254,22,147,249,223,65,8,17,69,198,60,158,146,18,192,140,
166,233,114,89,150,174,79,156,56,116,232,222,189,197,197,140,157,60,249,206,59,99,198,32,89,177,127,74,74,110,220,128,1,26,40,215,146,84,88,248,194,11,83,167,222,188,41,203,133,133,235,215,15,30,188,116,
41,194,24,226,4,99,89,89,9,9,64,196,128,203,139,34,99,123,246,12,28,248,197,23,231,206,221,190,125,236,216,232,209,227,198,221,184,225,112,208,3,50,12,198,116,253,246,237,248,120,220,6,220,138,147,39,
17,30,1,204,10,2,170,99,93,79,78,126,234,41,175,119,218,180,162,34,65,96,172,77,155,220,92,12,164,33,135,17,4,89,190,122,245,228,73,191,223,233,4,36,203,152,101,1,209,151,36,66,245,99,99,139,138,202,111,
144,99,199,122,245,250,252,115,175,55,51,115,251,246,55,223,28,53,42,43,11,7,22,181,177,17,149,176,215,81,237,151,148,188,246,218,180,105,71,142,136,162,101,237,221,59,116,232,148,41,192,40,40,168,135,
133,133,135,115,110,89,154,6,233,89,93,119,185,78,158,124,230,153,21,43,174,93,99,172,184,248,199,31,251,246,77,75,163,109,131,196,18,113,9,61,198,59,123,54,255,225,112,168,162,48,182,115,103,245,234,
54,63,141,40,146,149,43,55,110,188,109,91,243,230,110,55,102,112,74,151,129,181,106,77,159,158,148,132,10,26,29,110,135,67,16,220,238,184,184,89,179,94,123,45,46,14,180,74,8,178,33,118,36,38,222,188,249,
222,123,24,204,4,169,19,130,47,225,225,213,171,127,246,25,124,187,33,162,228,241,144,178,87,112,240,196,137,125,251,146,148,34,118,204,230,205,208,241,48,12,206,135,12,169,82,229,220,57,120,248,248,124,
15,60,80,185,242,23,95,112,110,89,133,133,173,91,87,172,56,109,26,231,5,5,228,65,48,100,72,66,66,149,42,164,39,238,247,91,214,176,97,192,1,168,74,95,186,180,93,187,242,119,14,115,83,151,46,213,172,153,
144,32,203,112,34,34,53,176,214,173,71,142,204,200,128,233,29,249,3,129,39,161,105,53,107,110,220,216,181,107,68,4,248,133,165,239,92,171,86,179,102,65,187,8,101,55,221,163,160,160,105,211,222,126,59,
37,37,52,148,236,238,169,44,103,236,231,159,187,118,165,145,220,223,102,51,255,155,115,0,64,188,134,17,22,70,196,41,203,114,56,208,195,186,116,41,51,179,160,192,227,41,46,134,88,68,217,189,225,118,43,
10,99,8,100,78,167,32,248,253,170,170,235,151,47,239,223,31,23,119,251,182,170,194,63,64,146,20,197,52,35,34,230,204,57,115,38,44,236,181,215,118,236,88,185,50,38,198,231,83,20,211,52,12,135,67,20,111,
223,78,79,47,44,172,92,25,157,117,198,4,193,231,67,64,197,132,124,131,6,136,9,8,159,140,125,247,29,193,170,224,246,82,72,116,56,62,249,164,168,104,193,130,227,199,25,243,120,94,123,205,229,250,228,147,
183,223,198,187,20,23,15,27,182,102,141,174,51,22,26,138,164,84,20,5,97,229,74,180,95,1,104,199,196,152,102,78,78,217,35,0,141,151,176,176,224,224,11,23,50,51,21,69,81,168,207,16,28,252,195,15,191,252,
50,113,98,124,252,230,205,107,215,38,36,24,6,82,90,140,128,248,124,185,185,53,106,108,218,84,84,132,166,78,217,59,231,247,7,2,148,110,130,79,104,154,178,92,88,232,247,123,189,105,105,62,159,207,7,228,
4,105,170,40,50,86,175,222,237,219,52,212,254,219,212,2,126,103,25,232,245,214,170,133,58,64,215,25,243,251,77,83,85,189,94,65,40,44,60,119,78,20,101,217,178,202,30,1,130,160,235,46,87,72,8,70,38,116,
29,201,35,200,144,87,174,48,22,8,88,150,203,37,73,216,105,193,193,19,38,244,235,71,230,106,221,186,141,29,171,170,148,157,75,146,101,41,202,250,245,181,107,211,160,167,211,137,79,243,251,25,187,125,251,
212,169,152,24,89,230,28,227,91,156,139,226,210,165,129,128,170,250,124,146,196,88,110,174,215,139,83,156,177,162,162,90,181,134,12,73,75,251,241,199,146,18,203,234,210,229,243,207,67,67,103,207,174,81,
163,71,143,246,237,147,147,151,44,169,93,251,249,231,37,233,214,45,16,66,101,249,192,129,140,12,82,11,100,204,48,170,85,203,207,207,201,33,211,122,250,158,178,28,8,84,169,178,119,175,36,105,154,215,11,
209,184,64,192,227,153,56,241,169,167,124,62,81,52,205,160,160,142,29,39,79,14,11,67,179,70,81,116,221,48,84,85,215,117,221,231,67,45,85,254,200,37,44,2,154,37,156,155,102,80,144,223,207,88,82,210,129,
3,68,86,165,89,35,84,21,14,199,153,51,36,85,131,138,229,79,148,136,17,69,198,142,31,135,110,135,195,193,185,170,130,117,75,26,0,110,55,24,128,118,1,7,166,106,94,30,99,132,102,3,44,65,73,104,24,137,137,
17,17,134,81,82,98,154,224,217,70,70,14,26,132,98,11,88,192,147,79,54,106,4,149,13,244,22,117,61,43,171,110,93,128,42,162,88,92,12,212,28,233,220,165,75,134,81,179,38,69,42,80,82,230,205,163,206,90,179,
102,109,218,96,175,152,166,219,45,8,47,188,112,255,253,151,47,223,186,37,8,166,249,208,67,223,125,247,228,147,13,26,220,188,41,138,77,155,14,30,252,253,247,15,60,208,160,1,16,15,65,96,108,202,20,34,117,
16,203,240,214,173,155,55,33,145,99,63,46,203,98,44,37,229,234,85,200,203,248,124,56,241,19,18,158,127,30,199,1,78,229,71,31,173,94,157,180,65,176,156,238,185,167,160,0,71,49,109,28,170,143,194,195,93,
174,64,128,114,122,191,95,146,4,193,231,3,45,133,49,135,3,169,162,170,18,164,134,159,252,124,48,28,112,0,253,105,124,0,250,41,42,138,140,68,112,2,41,27,65,86,20,57,207,201,129,114,184,105,162,133,131,
142,156,97,120,189,209,209,149,42,33,123,198,82,1,162,208,172,89,215,174,41,41,83,166,28,62,188,99,199,193,131,200,124,235,213,67,26,3,70,143,105,70,68,16,197,73,146,64,137,200,206,190,117,171,70,13,8,
53,226,115,116,29,244,235,236,236,226,226,134,13,79,158,68,95,14,55,96,226,196,94,189,66,66,44,75,16,6,13,26,52,8,140,100,72,44,197,199,47,91,102,223,236,148,148,15,63,44,42,66,43,219,237,182,172,182,
109,219,182,165,92,122,239,222,53,107,168,247,8,93,224,148,148,95,127,197,119,47,43,212,100,89,201,201,23,46,200,114,113,49,210,69,191,95,85,83,82,232,97,131,166,225,112,84,169,114,228,136,44,235,186,
101,5,7,119,232,208,160,65,227,198,33,33,189,123,111,218,116,237,26,52,131,48,31,201,152,219,29,17,81,88,136,82,213,239,151,101,124,47,16,106,128,0,152,166,170,194,109,129,176,191,144,144,146,18,112,40,
237,67,224,79,98,4,225,116,101,44,63,191,118,109,188,173,97,128,234,72,212,200,156,156,136,8,59,120,1,208,180,172,86,173,94,122,169,93,187,228,228,129,3,55,111,158,50,5,13,85,73,146,164,118,237,102,207,
174,90,149,243,222,189,123,247,62,126,124,236,216,85,171,72,102,5,172,125,156,229,208,228,66,30,77,3,35,199,143,183,110,125,246,44,30,63,150,13,246,86,81,209,217,179,29,58,172,90,85,88,136,84,147,115,
65,200,200,152,52,105,226,68,251,111,65,52,51,12,76,230,217,77,19,120,129,96,66,25,240,12,253,77,73,201,184,113,94,47,226,17,174,44,62,190,94,189,233,211,17,13,202,67,77,141,26,189,247,30,138,91,206,253,
126,85,229,28,248,1,69,63,203,18,69,183,27,160,83,80,208,107,175,13,27,134,207,156,51,231,199,31,71,142,188,118,13,247,210,48,194,195,255,245,175,135,30,138,139,115,56,2,129,111,190,57,126,28,187,25,212,
86,198,66,67,13,163,176,144,206,120,60,9,65,16,4,93,15,10,186,112,1,177,136,192,167,63,177,27,168,40,14,7,99,15,61,180,114,37,154,26,101,71,195,100,249,185,231,102,207,38,52,192,229,194,124,80,183,110,
183,110,25,6,6,50,188,94,184,11,59,157,140,133,135,159,58,69,83,121,129,0,231,191,252,18,23,167,170,140,213,170,69,78,64,224,188,231,229,53,111,14,89,100,114,218,22,132,129,3,191,255,158,198,44,81,50,
81,241,84,187,246,145,35,117,235,194,206,14,214,18,140,69,69,237,218,133,57,27,203,130,159,56,156,8,203,14,135,221,57,39,4,59,120,206,167,78,133,122,0,198,98,28,14,65,24,50,100,214,172,210,126,163,182,
118,72,141,26,107,215,38,38,162,233,69,2,210,41,41,228,30,74,202,129,205,155,131,208,210,165,139,223,15,9,25,92,203,208,161,192,57,24,11,15,95,181,170,184,24,119,198,52,207,158,173,84,137,196,120,201,
126,254,219,111,107,215,198,148,0,98,42,61,230,182,109,183,108,177,157,215,254,212,201,32,80,48,53,237,246,237,122,245,238,20,42,179,44,195,200,202,10,11,35,42,98,73,137,97,24,6,99,239,188,19,30,46,138,
138,226,247,115,110,24,189,122,13,24,128,148,173,69,139,90,181,252,126,64,195,178,236,247,55,108,88,167,78,32,32,73,217,217,75,150,148,6,114,87,173,58,127,222,239,7,230,133,0,204,249,254,253,21,42,192,
64,5,251,18,153,49,231,162,120,234,212,225,195,221,187,43,74,73,9,224,20,206,85,53,39,103,212,168,203,151,177,88,168,57,75,179,4,255,117,181,227,245,74,82,65,129,32,108,218,244,209,71,134,193,185,97,32,
118,248,253,110,247,240,225,95,125,165,170,104,138,149,253,219,58,117,78,157,50,12,211,132,245,11,200,102,23,46,44,94,44,203,32,196,8,2,99,246,234,86,71,0,0,32,0,73,68,65,84,75,151,158,58,229,241,88,150,
162,180,109,171,170,224,87,4,2,156,51,246,226,139,170,170,235,14,7,99,125,250,52,109,234,116,26,134,40,250,124,140,85,175,62,105,18,233,7,97,207,123,60,112,83,198,161,84,122,100,36,56,248,224,193,178,
8,229,159,200,8,146,101,93,247,249,78,159,38,55,251,178,37,134,162,20,21,201,114,88,152,173,197,43,8,21,43,54,108,232,247,11,2,232,145,30,143,199,115,223,125,248,10,73,73,166,233,112,208,48,132,170,134,
134,70,70,50,38,73,5,5,111,191,189,110,93,65,129,174,155,166,223,191,126,253,155,111,222,188,233,241,128,87,68,212,208,235,215,243,242,154,55,7,189,195,52,109,31,48,73,98,108,218,180,65,131,92,46,135,
195,52,129,234,5,2,156,239,222,61,118,236,237,219,224,233,146,176,228,127,157,28,161,68,115,58,3,129,224,224,244,244,241,227,47,95,134,253,43,174,147,177,119,223,189,122,245,208,33,195,8,10,42,123,0,8,
130,44,55,107,118,253,250,213,171,140,249,253,128,175,56,87,148,162,162,119,223,93,189,90,85,253,126,211,44,42,58,120,112,202,148,194,194,162,34,135,195,237,174,92,153,122,30,224,24,212,169,131,121,2,
81,236,208,33,42,10,152,163,166,89,150,101,245,238,141,161,50,98,78,70,69,233,58,106,27,16,226,36,9,21,2,99,73,73,191,247,241,255,174,28,0,117,64,81,81,66,66,86,86,121,161,50,89,46,40,240,122,35,34,242,
242,80,178,152,166,105,70,71,91,150,195,129,186,28,175,119,187,25,115,56,124,190,43,87,144,10,98,111,7,2,24,228,230,92,81,78,159,238,209,163,83,167,122,245,194,195,159,126,186,75,23,211,116,58,49,135,
4,36,206,48,100,185,176,240,248,241,22,45,182,109,211,117,65,48,12,244,254,73,38,225,212,169,212,212,239,191,239,218,85,211,2,1,81,212,117,77,211,117,203,154,59,215,237,126,247,221,240,112,140,90,253,
207,39,35,106,146,147,39,7,15,222,177,3,229,157,195,17,8,72,146,223,159,156,220,167,15,40,47,37,37,101,211,43,206,227,227,107,213,250,232,35,195,0,204,139,46,69,97,161,44,159,57,243,196,19,155,55,31,58,
84,88,184,107,215,238,221,185,185,138,130,158,130,97,48,230,243,41,138,170,2,252,53,77,203,146,36,65,136,138,18,4,211,244,249,220,110,69,49,12,196,178,42,85,50,51,101,153,196,54,194,194,138,139,11,11,
65,147,151,36,192,85,32,188,199,196,156,60,249,187,149,2,127,251,120,56,148,120,54,108,184,239,190,59,125,130,68,49,49,113,222,188,54,109,108,137,118,198,170,85,163,9,96,191,31,83,192,80,22,80,148,248,
120,156,125,166,137,0,152,150,86,175,30,202,57,91,8,246,194,133,148,20,236,44,123,60,29,25,70,251,246,63,254,24,31,79,82,44,116,37,248,55,69,185,114,165,79,31,219,31,152,230,247,123,245,66,229,96,24,165,
21,186,232,100,46,173,20,128,127,223,180,233,158,123,240,233,48,161,64,27,247,208,33,40,157,145,54,120,233,59,244,240,195,75,150,184,221,182,129,6,186,252,46,151,32,220,115,207,198,141,65,65,68,221,34,
66,221,139,47,130,207,23,8,192,68,98,254,124,18,226,95,181,10,150,25,129,0,36,169,11,10,92,46,178,189,149,101,73,122,229,149,247,223,71,22,132,172,8,57,144,40,50,182,108,89,167,78,119,105,58,24,205,90,
65,80,148,139,23,43,87,46,95,94,112,46,138,5,5,94,111,116,52,114,94,204,171,95,188,184,99,7,86,38,178,248,194,194,5,11,176,207,179,178,104,184,3,137,207,156,57,32,116,114,94,82,130,17,106,89,94,183,174,
91,55,162,96,144,222,39,62,119,255,126,143,39,57,25,55,218,158,3,0,29,68,215,159,121,102,220,184,228,100,195,224,220,233,4,181,210,178,20,101,241,226,94,189,190,249,198,231,3,89,27,201,35,154,188,68,120,
231,28,157,69,65,40,40,152,48,161,79,159,131,7,85,85,150,177,147,13,67,16,12,99,234,212,27,55,230,204,161,54,17,106,29,18,151,144,229,46,93,246,238,45,46,38,73,23,176,255,160,130,120,223,125,39,78,0,184,
178,165,243,37,105,245,106,52,180,0,122,93,189,250,249,231,160,203,51,182,122,53,161,153,136,157,203,151,151,148,160,230,119,56,12,67,81,60,158,140,12,20,169,212,193,128,74,171,166,133,132,92,190,124,
151,34,128,237,23,62,106,84,121,13,59,210,245,155,49,227,249,231,177,15,5,1,70,204,181,106,93,191,142,145,102,211,228,28,217,51,132,21,92,174,1,3,46,94,132,233,66,207,158,30,15,250,226,240,231,132,26,
86,219,182,187,119,147,197,3,237,113,154,219,123,235,173,69,139,32,143,78,72,56,94,1,203,135,126,253,14,30,132,23,41,8,99,120,71,89,118,187,31,121,100,255,126,148,152,176,106,68,125,64,83,250,48,147,157,
59,183,81,35,135,3,72,61,121,160,170,42,99,61,122,156,59,151,156,140,8,70,140,35,152,182,56,157,140,213,175,127,234,84,133,10,182,43,17,9,218,56,28,178,252,249,231,207,62,11,138,27,121,125,184,92,130,
32,73,17,17,147,39,35,242,172,92,89,191,62,218,216,192,23,87,172,128,86,170,105,114,190,121,115,213,170,164,51,200,152,162,68,70,126,248,33,166,171,233,123,19,207,48,46,110,233,210,187,38,16,65,194,40,
162,216,189,251,162,69,229,143,0,148,65,67,134,188,247,158,166,41,74,80,16,30,191,36,49,86,171,214,15,63,228,229,25,6,231,15,61,4,229,45,168,98,65,244,77,16,162,163,193,107,69,158,78,26,89,178,44,138,
49,49,251,247,99,132,26,37,29,169,97,9,2,99,149,42,93,184,208,188,57,190,246,157,106,101,65,65,51,103,46,89,66,243,124,152,11,212,52,77,67,178,213,186,245,234,213,40,177,116,29,198,177,126,191,215,107,
154,156,95,186,244,201,39,13,26,144,197,61,41,122,193,146,170,81,163,163,71,219,183,71,87,19,11,146,74,83,135,67,16,24,91,180,104,246,108,252,119,152,192,136,34,76,159,24,171,91,247,167,159,234,215,199,
235,96,77,77,182,112,140,13,28,56,111,30,62,7,230,243,100,66,37,73,239,190,203,57,231,57,57,147,38,133,133,33,119,34,231,245,132,132,229,203,83,82,74,111,92,28,147,162,216,180,233,172,89,21,43,222,197,
5,128,61,214,184,241,166,77,229,45,74,177,87,58,119,254,250,235,168,40,236,95,156,214,116,242,49,6,23,113,186,13,14,7,72,81,140,49,118,240,96,187,118,196,124,35,131,25,198,68,49,56,248,221,119,223,123,
143,70,46,72,6,138,168,100,163,71,255,252,51,162,69,217,235,160,249,187,205,155,63,252,48,42,10,58,30,78,39,9,73,145,116,13,99,93,186,76,152,176,96,193,150,45,231,207,167,167,175,95,63,119,238,107,175,
181,104,65,181,129,44,67,40,18,175,134,38,201,249,243,67,134,48,134,71,68,126,63,232,229,11,130,36,165,164,20,23,71,71,67,227,144,228,222,136,175,220,167,207,119,223,57,157,144,153,193,99,135,59,161,40,
50,182,122,117,175,94,244,237,32,181,75,6,88,13,26,156,58,101,155,77,3,119,113,56,24,83,213,122,245,182,108,9,10,42,221,231,163,24,215,171,215,71,31,133,133,221,197,5,0,13,191,164,164,21,43,96,179,88,
94,38,50,37,37,53,21,190,90,208,230,34,191,16,85,101,108,199,142,110,221,64,231,32,187,35,82,17,27,59,118,230,76,26,221,128,236,137,195,1,90,116,215,174,43,86,196,198,226,245,224,235,128,34,14,164,239,
226,197,39,159,252,119,210,147,14,135,44,203,114,205,154,7,14,76,159,30,20,4,109,29,72,201,98,71,83,138,250,111,107,98,17,233,29,150,1,245,2,154,52,57,115,230,237,183,9,134,33,75,71,8,180,224,85,191,254,
58,114,36,228,98,169,4,70,223,211,225,8,14,158,63,255,185,231,108,53,35,196,44,44,126,151,235,232,209,10,21,40,78,65,65,8,87,207,216,244,233,83,166,208,178,39,3,27,84,251,143,63,190,120,113,89,161,72,
242,54,30,54,108,220,184,178,205,248,63,217,48,2,41,88,97,225,205,155,53,107,222,249,123,85,61,118,44,40,40,54,22,172,88,20,83,120,84,186,206,216,226,197,207,62,11,74,134,101,129,134,5,2,3,99,75,151,62,
249,100,191,126,253,250,197,199,3,171,231,28,186,30,138,114,232,80,32,144,156,28,8,32,212,83,115,147,115,65,80,20,206,95,127,125,194,132,106,213,74,215,189,152,245,245,251,37,201,178,206,156,233,219,183,
82,165,79,63,173,90,213,52,21,69,81,136,84,9,20,0,60,102,91,122,174,180,128,53,146,73,208,220,56,231,188,95,191,79,62,153,55,239,189,247,40,123,167,102,19,250,147,156,51,54,124,184,97,76,155,70,84,78,
135,195,30,219,54,205,132,132,154,53,183,110,37,162,6,244,14,5,193,231,235,220,185,127,255,15,62,72,79,191,122,149,0,105,93,87,85,73,10,4,112,21,15,61,180,102,13,241,160,225,22,108,89,178,172,40,150,213,
184,241,193,131,229,121,128,166,201,152,166,69,70,94,184,240,219,70,194,255,80,25,136,66,80,20,61,158,79,62,121,238,57,210,182,36,71,48,100,228,159,125,54,108,24,118,136,45,237,134,21,93,173,90,73,9,217,
177,0,172,196,62,108,218,116,239,94,206,243,243,139,138,206,158,29,58,148,220,252,168,58,24,51,102,230,204,10,21,160,144,131,176,137,235,0,49,99,209,162,159,126,42,157,12,209,49,69,159,233,118,79,156,
120,246,108,207,158,68,96,41,157,183,216,254,194,164,67,136,252,29,68,85,74,0,221,238,79,63,189,120,177,83,39,154,62,40,45,202,70,34,216,181,107,103,100,212,170,69,191,165,96,78,119,119,202,148,233,211,
225,69,132,81,78,168,121,173,95,159,157,93,92,172,235,249,249,31,127,76,34,180,165,93,22,163,162,144,227,35,207,64,249,139,43,117,185,54,110,124,232,161,178,145,15,247,44,58,250,243,207,31,124,240,46,
74,197,146,54,22,99,47,190,56,115,166,45,81,38,203,120,160,140,49,246,244,211,139,22,225,6,146,193,42,37,47,140,165,167,147,77,11,254,81,20,73,114,187,65,176,54,77,195,240,251,253,254,1,3,144,102,225,
176,96,172,115,231,11,23,110,221,186,117,235,210,165,9,19,156,78,18,68,36,3,229,184,184,221,187,7,13,194,43,67,66,104,236,4,20,108,188,86,81,122,244,56,119,238,155,111,144,67,227,56,178,5,97,203,219,97,
144,29,35,229,25,77,154,28,59,246,227,143,117,234,208,195,38,124,31,203,29,186,194,30,207,234,213,239,189,135,178,23,255,224,148,31,59,54,35,227,242,229,107,215,174,92,233,217,147,18,69,60,80,167,19,2,
121,68,240,248,242,75,108,12,66,52,161,174,56,127,190,189,197,108,108,213,225,8,9,185,126,189,172,65,44,93,89,114,242,119,223,165,164,220,181,5,32,138,80,197,23,69,198,186,119,159,59,55,58,154,118,0,97,
236,14,135,36,85,173,186,111,95,72,136,173,136,107,239,72,198,38,78,68,179,8,170,151,200,119,167,78,197,68,17,10,30,206,51,50,176,204,144,134,213,173,123,246,172,109,9,151,154,26,21,5,187,118,20,91,14,
7,99,157,58,29,61,90,175,30,50,7,76,36,225,125,73,154,61,52,148,177,132,132,245,235,47,93,122,228,17,212,0,212,212,210,52,183,251,95,255,186,114,133,115,195,216,181,171,89,51,252,134,126,39,138,21,43,
126,250,233,149,43,67,135,194,99,0,2,211,200,109,220,110,69,113,56,52,77,81,28,14,89,126,249,229,245,235,35,35,177,123,105,6,200,227,153,51,7,109,158,219,183,57,63,126,188,89,51,198,52,13,100,57,198,158,
127,30,14,9,134,1,185,186,236,236,90,181,112,132,210,214,97,108,219,54,114,10,46,29,177,220,110,65,120,244,209,117,235,254,157,93,183,36,181,106,181,124,185,166,221,69,223,64,180,81,208,245,250,246,219,
26,53,236,160,12,17,89,252,238,208,161,38,77,176,150,73,100,145,30,119,189,122,231,207,83,183,16,169,32,99,191,252,98,154,64,185,117,221,239,183,172,130,2,88,70,194,218,233,163,143,80,153,227,31,206,59,
117,130,44,2,36,82,145,225,191,255,254,214,173,168,237,51,51,95,126,57,40,72,20,61,30,194,237,16,15,20,133,177,39,158,200,200,216,177,163,95,191,132,132,144,16,198,24,11,10,114,187,103,205,226,220,239,
135,245,219,173,91,164,59,174,40,209,209,13,27,78,156,152,158,254,205,55,104,110,193,197,15,33,26,215,93,183,238,55,223,192,205,108,197,138,125,251,218,183,183,221,137,17,9,187,117,67,38,67,222,39,243,
231,163,233,139,157,250,205,55,134,1,128,136,188,132,159,122,10,113,15,134,117,140,37,37,93,189,10,47,149,178,241,87,85,25,219,176,97,208,160,178,11,128,20,141,94,122,105,230,204,63,98,24,241,59,196,162,
105,120,226,218,181,232,232,170,85,207,158,5,119,30,41,8,245,209,215,173,123,252,113,32,92,132,222,129,52,34,203,103,207,94,189,218,190,253,134,13,24,13,241,251,101,217,48,224,239,11,150,44,200,95,216,
113,134,97,89,49,49,29,58,48,22,8,104,154,101,57,157,62,159,166,117,237,186,99,7,58,104,162,168,235,46,151,215,43,138,87,174,180,106,5,109,190,248,248,143,63,78,76,124,247,221,252,124,40,1,10,130,174,
43,10,82,171,37,75,150,44,121,236,177,94,189,158,121,230,224,193,179,103,47,92,200,206,174,92,185,79,31,136,52,203,50,99,225,225,175,190,122,233,146,166,85,174,92,173,90,147,38,209,209,199,143,183,107,
103,243,235,189,94,232,4,160,231,94,185,242,130,5,41,41,160,95,61,242,72,90,218,165,75,166,233,112,4,2,208,44,64,213,0,182,0,137,55,221,123,111,141,26,105,105,129,0,24,14,152,223,119,56,76,19,220,96,176,
154,69,49,16,80,85,203,10,4,24,235,222,125,219,54,244,251,75,247,97,4,33,16,80,213,22,45,250,245,43,203,246,5,33,76,150,147,147,201,147,249,174,185,134,81,112,45,40,72,79,175,93,27,81,193,150,34,3,176,
59,123,246,179,207,162,113,3,143,29,82,223,178,172,64,96,197,10,114,208,67,138,195,216,209,163,56,13,137,209,86,82,178,105,19,248,48,146,228,247,147,59,54,154,38,140,197,197,1,188,197,156,97,32,160,170,
241,241,47,190,72,202,220,134,193,216,176,97,141,26,217,61,61,68,2,106,150,166,166,246,234,245,242,203,233,233,181,106,245,238,61,110,220,219,111,59,157,156,195,254,201,178,12,227,222,123,39,79,30,56,
176,107,87,143,103,233,210,30,61,6,13,186,122,21,42,128,182,116,28,190,163,211,57,104,80,74,138,105,114,142,191,172,91,247,153,103,100,217,178,144,173,35,138,196,197,129,250,65,227,100,161,161,208,243,
194,67,91,177,34,16,0,28,13,66,167,97,28,60,8,104,25,13,34,81,236,208,97,238,92,77,43,91,223,224,223,186,118,205,200,200,206,46,175,252,195,185,44,75,82,253,250,251,246,253,86,89,152,63,168,19,72,51,47,
140,237,218,213,189,187,170,250,253,164,191,143,193,75,206,101,249,210,37,159,175,77,155,109,219,236,66,133,38,219,69,113,227,198,174,93,43,84,184,126,29,90,24,156,51,54,125,122,199,142,21,42,96,158,142,
49,81,156,59,87,215,209,217,214,117,148,76,162,168,235,170,138,157,152,159,79,94,132,146,132,194,42,44,44,37,197,235,149,101,155,129,95,163,198,254,253,94,47,6,60,76,19,18,74,140,129,187,28,8,156,62,125,
250,180,170,86,168,224,241,76,152,64,189,65,242,240,157,55,111,207,158,226,226,156,28,176,236,208,155,195,231,160,155,1,97,70,81,236,216,17,193,158,30,113,195,134,193,193,5,5,208,26,3,212,117,249,50,237,
75,108,142,171,87,3,1,130,200,77,115,217,178,145,35,147,146,2,1,116,1,5,97,237,218,139,23,73,6,135,115,81,108,222,92,215,143,29,187,147,208,105,24,140,61,243,204,220,185,244,222,165,31,191,105,38,39,203,
242,249,243,224,104,253,190,37,240,187,8,33,36,164,182,125,123,173,90,65,65,104,68,160,175,71,181,58,99,95,126,73,22,134,148,239,131,55,168,40,23,47,158,63,223,161,3,13,146,6,2,178,156,150,214,179,103,
97,33,114,114,81,92,186,244,173,183,80,65,235,186,166,229,231,175,92,73,208,47,50,135,111,191,53,12,211,84,20,204,4,219,38,54,120,5,136,145,113,113,80,232,35,162,57,118,33,200,170,200,82,76,243,210,165,
179,103,41,149,194,67,144,229,220,220,125,251,178,178,242,243,105,184,147,42,14,27,131,180,44,183,27,159,77,99,108,228,162,4,122,38,238,129,105,50,182,124,185,109,254,46,8,140,29,62,124,246,172,97,96,
16,92,150,115,114,250,247,191,126,157,132,238,83,83,159,126,90,20,29,14,203,10,4,208,30,111,219,246,215,95,11,11,253,126,91,129,4,81,8,126,199,243,230,225,110,218,191,195,225,244,200,35,112,51,40,93,130,
254,201,56,64,233,196,131,177,109,219,58,117,34,31,91,178,104,66,50,18,25,89,92,140,228,15,41,24,169,238,72,146,170,62,251,236,236,217,30,15,13,137,144,127,120,223,190,159,124,50,118,108,106,234,244,233,
72,186,8,40,174,81,227,200,17,187,97,51,111,30,153,168,216,18,208,245,234,229,228,80,25,9,147,183,158,61,97,98,75,246,78,100,1,99,95,63,254,191,90,181,32,179,80,84,100,89,186,206,249,236,217,193,193,40,
0,75,59,158,217,126,201,68,50,115,58,119,237,66,3,7,44,31,206,103,205,114,187,81,165,195,138,138,49,143,103,250,116,206,125,62,8,188,236,221,155,148,68,134,84,168,243,53,45,63,191,127,255,73,147,198,140,
105,208,0,201,29,112,6,81,116,56,34,35,151,45,235,214,13,75,158,180,131,200,117,165,87,175,159,126,194,55,7,134,81,218,175,249,194,133,22,45,236,230,249,93,114,15,47,13,61,12,31,62,103,14,1,184,84,11,
144,47,207,47,191,116,239,78,102,46,84,205,226,17,164,164,172,90,213,180,41,74,45,44,15,84,237,140,49,22,19,115,243,102,197,138,120,8,4,196,84,175,254,197,23,7,15,158,59,119,224,192,170,85,27,54,196,199,
67,116,157,10,80,143,39,56,248,235,175,65,136,0,149,220,235,109,218,148,250,116,244,191,146,4,77,128,178,133,147,219,253,214,91,185,185,84,101,28,62,220,170,21,174,208,246,237,38,105,10,234,34,208,153,
61,125,58,231,134,1,165,81,191,223,231,235,211,7,32,146,219,141,107,118,185,34,35,55,110,92,179,102,211,166,51,103,142,29,155,63,191,106,85,192,190,40,52,85,149,177,47,190,248,250,235,210,211,252,196,
234,115,185,24,123,248,225,117,235,194,195,169,137,69,22,20,88,208,27,54,244,235,71,5,163,44,67,35,133,54,2,16,197,63,226,29,252,7,23,64,133,10,57,57,80,192,32,80,213,190,208,231,158,251,249,103,0,43,
246,122,164,137,189,47,191,28,61,26,45,15,26,179,162,131,130,177,105,211,150,46,85,213,136,8,176,139,73,222,201,229,170,92,153,49,77,155,63,255,253,247,137,112,6,95,47,85,101,172,97,195,125,251,136,206,
113,250,244,47,191,172,92,217,169,19,129,33,216,111,170,10,115,167,242,221,75,73,234,217,115,238,220,212,212,13,27,222,123,47,37,5,203,16,77,160,178,3,90,0,124,176,152,93,174,17,35,142,28,89,183,206,231,
195,39,250,124,51,102,4,5,81,239,144,164,238,199,143,95,179,70,81,24,139,136,136,142,182,123,28,140,105,90,84,84,112,112,221,186,215,174,197,197,225,26,209,159,128,247,128,32,8,130,219,253,201,39,163,
70,149,214,4,65,231,84,150,25,171,90,117,255,254,184,56,34,128,192,11,133,202,220,153,51,65,181,41,125,199,239,234,2,64,6,223,174,29,5,114,26,201,150,36,85,149,229,202,149,79,156,72,74,2,136,73,48,49,
173,213,214,173,247,236,129,24,52,90,162,246,4,27,99,154,198,249,242,229,107,214,172,93,59,103,78,141,26,216,29,52,250,196,88,181,106,59,118,12,31,142,126,31,110,2,142,153,90,181,94,127,125,217,178,229,
203,199,142,109,214,44,54,118,212,168,195,135,39,77,114,187,201,133,4,203,224,206,125,129,189,200,88,100,36,150,27,218,188,4,215,150,181,109,135,195,7,99,77,154,108,222,188,110,93,203,150,17,17,207,60,
243,225,135,91,183,126,241,69,159,62,65,65,132,116,40,10,226,217,168,81,39,78,84,172,72,86,244,192,52,4,129,177,225,195,83,83,55,110,92,177,34,35,99,204,24,198,156,78,135,67,85,201,190,138,42,150,248,
248,179,103,227,227,113,127,17,79,145,161,40,10,99,175,190,58,99,134,195,65,223,135,250,22,216,70,183,111,55,108,72,7,242,95,178,0,32,194,246,203,47,100,158,134,84,8,7,128,36,105,218,156,57,111,188,129,
7,72,156,29,58,79,25,91,179,102,212,40,18,114,130,16,44,33,140,239,188,67,59,139,243,140,140,38,77,232,241,171,42,72,230,205,155,103,101,245,236,137,207,36,224,21,248,92,88,88,68,4,200,100,162,88,167,
206,79,63,165,165,181,106,69,208,139,32,40,74,89,10,55,13,79,210,162,165,253,77,129,186,108,15,20,178,19,138,50,102,204,185,115,175,188,18,30,142,135,227,114,197,196,184,92,196,239,9,15,39,82,214,211,
79,251,124,213,171,151,182,185,195,113,246,241,199,240,6,225,156,243,236,236,196,68,73,114,58,241,240,0,91,35,98,126,248,225,231,159,211,248,44,121,156,226,42,195,194,86,172,232,222,29,241,132,76,121,
40,55,104,221,58,51,19,223,132,122,10,127,65,4,16,132,176,176,140,140,170,85,201,232,21,192,40,173,217,238,221,87,173,130,208,27,0,78,236,71,96,89,157,58,221,188,25,23,215,160,65,66,2,210,25,90,26,205,
155,151,148,96,66,208,231,51,77,206,247,236,65,82,137,28,3,123,190,91,183,64,160,73,19,60,36,236,111,187,14,64,70,129,191,233,217,51,59,251,135,31,130,130,232,102,150,181,184,161,166,50,117,251,129,100,
162,95,224,241,220,105,134,35,73,15,61,116,236,216,246,237,213,171,227,145,66,187,7,59,92,81,68,49,60,156,90,197,41,41,23,47,182,111,79,110,67,88,184,178,204,88,135,14,185,185,156,235,122,32,192,121,32,
96,24,217,217,244,157,104,242,217,227,169,88,49,50,178,160,32,44,12,203,22,209,129,38,137,25,235,212,105,209,162,184,56,120,31,17,18,8,147,41,198,126,252,113,232,80,226,77,252,101,71,128,162,48,246,227,
143,175,190,74,9,32,117,210,112,115,227,226,86,174,108,223,30,76,22,92,36,61,102,81,140,138,186,113,3,59,97,255,254,134,13,105,100,156,177,185,115,77,19,35,27,128,102,242,243,31,122,136,218,52,232,174,
11,2,99,125,251,102,101,221,115,15,118,151,219,173,105,56,70,232,221,201,67,139,177,136,136,101,203,178,179,71,140,8,9,113,56,64,164,176,91,190,116,149,138,18,27,27,22,22,30,30,30,78,157,66,68,0,187,73,
44,203,154,86,167,206,130,5,5,5,207,62,75,36,110,120,23,18,25,132,49,151,75,211,60,30,151,139,177,250,245,211,211,135,12,161,197,105,191,19,99,169,169,152,128,38,66,106,73,9,60,205,0,160,119,233,114,226,
4,238,200,182,109,154,70,150,84,116,5,178,44,8,97,97,111,188,49,110,28,81,93,113,180,144,79,178,203,149,153,25,27,75,21,213,95,22,1,36,137,177,142,29,15,28,192,206,43,139,89,139,34,99,163,71,79,158,12,
13,59,186,32,252,77,181,106,103,206,80,39,140,243,252,252,42,85,136,205,247,213,87,129,0,164,214,177,0,114,114,158,124,210,54,138,166,185,32,77,251,224,131,67,135,154,52,25,58,244,187,239,190,255,126,
220,184,251,239,15,10,194,110,164,240,103,243,7,27,55,94,177,34,35,99,226,196,251,239,175,84,137,74,94,10,251,138,18,27,59,101,10,29,55,125,250,192,81,20,189,6,202,207,171,85,123,230,153,159,126,74,79,
127,247,221,210,203,187,52,127,64,85,155,55,31,63,126,225,194,5,11,134,12,105,213,106,199,142,137,19,17,89,200,205,135,178,249,117,235,128,244,233,186,174,115,30,8,20,23,163,73,45,203,130,112,255,253,
96,41,226,158,172,95,31,26,74,188,98,114,81,102,44,33,97,243,230,86,173,208,10,195,225,167,170,146,4,157,198,254,253,231,205,11,11,179,249,13,127,81,14,32,8,154,230,112,236,216,209,161,195,157,13,8,81,
148,229,26,53,182,110,173,94,189,188,171,23,99,152,157,67,209,102,154,156,255,240,3,201,57,204,158,237,245,66,68,141,115,195,240,122,243,243,81,154,129,71,135,106,65,211,4,193,237,254,232,35,178,148,230,
60,16,24,54,204,225,176,61,249,202,246,201,25,107,214,108,218,180,141,27,87,173,26,63,190,103,207,218,181,109,244,35,34,34,53,21,178,112,208,44,28,48,128,38,12,24,11,14,190,239,190,129,3,191,248,34,53,
117,201,146,65,131,162,162,136,124,90,158,7,41,73,195,135,219,162,141,185,185,32,118,227,213,52,176,130,255,50,127,190,101,145,79,186,97,20,20,152,102,213,170,148,221,103,100,216,36,85,203,242,251,135,
12,193,242,35,78,132,170,50,214,187,247,170,85,200,252,169,214,71,167,83,85,101,121,241,226,103,158,1,7,147,132,39,238,82,51,232,206,57,33,77,91,186,180,87,175,245,235,203,83,196,37,201,52,207,158,205,
206,238,209,99,234,84,232,100,209,111,98,98,238,185,199,30,242,98,204,48,158,120,162,119,111,180,54,214,172,25,48,128,115,81,132,207,167,166,165,167,239,222,173,40,24,37,19,4,152,195,4,2,240,225,81,20,
191,223,225,8,4,100,89,81,198,141,219,185,243,208,33,82,252,47,125,29,78,167,215,187,111,223,190,125,177,177,247,222,155,146,210,177,227,208,161,156,255,250,235,145,35,103,207,102,101,213,168,241,232,
163,112,228,1,213,250,249,231,247,236,185,125,187,101,203,196,196,164,164,196,196,162,162,43,87,126,253,245,216,177,163,71,75,74,84,21,226,215,229,237,87,44,171,122,245,41,83,240,59,195,16,132,176,48,
203,10,15,191,117,203,233,132,26,128,40,66,53,140,49,198,86,175,238,222,221,233,196,72,26,231,65,65,191,254,154,153,9,86,84,108,108,229,202,64,87,177,96,85,181,73,19,135,67,215,49,125,12,47,22,151,235,
149,87,94,125,149,49,198,252,126,224,170,150,37,203,69,69,170,26,8,164,164,132,134,238,223,79,74,72,191,77,21,232,15,210,194,239,60,2,20,165,126,253,109,219,170,85,43,159,120,224,116,106,208,32,59,155,
156,59,41,106,84,173,186,115,39,237,24,88,201,65,84,13,201,214,59,239,0,152,1,232,12,87,109,98,223,17,101,82,20,227,227,207,157,227,156,242,133,64,128,243,129,3,193,154,185,147,169,140,130,81,150,25,115,
58,227,227,171,85,187,255,254,215,95,159,53,107,221,186,179,103,115,114,56,135,78,169,101,249,124,62,159,207,151,155,187,105,211,79,63,189,253,246,11,47,52,109,26,31,31,20,4,20,19,240,241,191,171,177,
25,123,243,77,128,80,52,224,121,229,74,203,150,196,254,163,132,88,81,96,32,185,115,39,152,200,118,133,131,184,87,175,30,221,11,210,52,93,185,50,34,130,196,35,17,71,6,13,218,185,19,71,19,98,130,109,25,
47,138,163,70,77,158,236,114,161,124,37,222,211,95,148,3,168,42,99,49,49,11,22,12,27,246,239,62,84,81,24,91,177,98,202,148,178,71,128,195,241,221,119,68,134,64,23,1,254,35,68,3,121,250,233,3,7,56,55,205,
149,43,127,248,97,227,70,60,2,50,147,39,7,157,228,100,204,238,98,118,214,178,56,95,176,0,101,83,89,210,23,150,40,137,81,18,120,34,203,170,234,114,5,7,47,92,72,211,186,224,229,112,222,188,185,36,5,7,19,
93,19,217,54,2,127,112,48,30,106,217,163,142,177,201,147,137,187,95,84,196,185,105,230,230,162,81,100,147,66,41,38,181,104,113,243,230,155,111,110,223,238,245,230,229,125,245,85,74,10,246,58,142,7,218,
10,52,253,7,38,180,205,33,14,11,131,199,184,77,38,37,51,13,73,170,88,113,253,250,71,30,177,61,4,105,74,226,47,201,1,224,155,249,244,211,43,86,192,251,215,198,218,137,152,85,173,218,181,107,21,42,80,209,
130,135,220,187,119,110,46,178,97,236,134,97,195,168,196,43,239,232,189,99,199,132,9,178,236,118,7,5,133,133,185,92,128,90,100,89,20,177,0,48,178,137,5,48,99,6,160,40,251,6,32,33,130,235,47,18,39,85,165,
162,9,152,219,11,47,112,110,24,16,146,211,117,203,202,200,72,72,176,75,44,60,54,48,124,128,242,185,221,180,231,236,124,230,131,15,236,145,18,203,178,172,235,215,91,181,34,87,96,124,114,165,74,97,97,162,
88,183,238,201,147,253,251,151,37,208,170,42,33,40,223,126,139,158,1,162,64,86,86,231,206,36,69,137,229,51,118,236,202,149,182,7,186,32,184,92,128,207,24,115,185,186,119,95,183,14,99,181,100,73,249,151,
45,0,148,95,130,144,152,184,103,207,131,15,18,68,75,121,43,118,14,99,95,125,245,217,103,192,192,73,9,92,81,62,250,40,39,7,15,95,215,79,158,180,105,204,20,224,68,209,233,20,69,81,140,140,220,191,127,202,
148,137,19,119,236,88,181,234,211,79,91,180,192,45,99,44,38,38,53,21,75,128,72,85,189,123,3,108,1,248,66,16,42,209,198,168,27,0,30,18,161,0,149,43,159,59,199,57,18,51,232,110,59,28,154,102,151,119,154,
6,103,80,58,132,0,72,97,233,211,236,223,136,17,120,240,120,128,156,175,95,95,177,34,254,94,20,43,84,232,219,119,225,194,211,167,151,45,27,50,36,53,245,195,15,69,209,225,32,77,3,112,37,113,104,169,170,
162,144,129,44,231,153,153,175,188,66,14,134,216,255,193,193,151,47,39,39,3,15,129,69,172,170,218,5,228,183,223,142,25,67,180,209,63,18,254,255,163,5,64,8,254,59,239,204,155,71,46,214,104,237,216,68,197,
216,216,51,103,154,53,3,152,106,47,130,39,159,156,61,123,225,194,217,179,95,122,233,240,225,230,205,209,109,43,93,161,83,33,55,116,168,61,182,153,155,11,107,85,135,67,20,219,181,187,114,197,254,205,158,
61,219,183,15,27,102,159,188,212,44,66,153,70,55,219,94,162,244,57,221,187,95,184,64,239,177,96,65,181,106,0,120,240,144,176,72,176,12,232,120,193,2,36,240,201,225,120,249,229,109,219,182,111,199,9,110,
154,156,223,186,5,148,82,85,69,49,34,98,225,66,251,10,175,94,173,87,143,228,225,232,174,41,10,122,20,140,117,239,126,224,192,176,97,115,231,206,159,63,117,106,135,14,136,15,84,244,50,246,209,71,159,127,
110,163,24,118,169,39,203,178,92,191,254,249,243,225,225,180,32,203,22,168,127,9,14,0,52,61,62,62,51,179,110,93,216,194,19,125,28,193,75,150,101,249,249,231,55,109,34,64,20,176,13,206,252,208,80,151,139,
177,225,195,211,210,60,30,32,102,101,121,110,138,18,17,113,224,128,29,236,57,63,127,190,102,77,36,85,46,215,131,15,46,90,148,158,158,149,149,150,246,234,171,85,170,180,110,189,124,249,190,125,109,218,
32,108,83,249,68,193,150,210,178,178,16,175,32,40,74,74,202,224,193,99,198,140,31,223,165,75,165,74,120,21,138,41,91,216,90,150,75,139,221,161,17,45,8,140,181,111,191,126,125,106,106,147,38,137,137,175,
190,186,119,111,118,246,153,51,91,183,118,233,130,199,235,116,42,202,191,254,69,199,28,142,186,81,163,208,82,166,59,160,105,88,146,140,197,198,222,190,221,186,53,99,193,193,96,43,146,90,32,14,209,198,
141,247,237,171,93,27,49,168,244,221,193,55,156,63,127,230,204,223,230,9,112,87,122,1,56,27,85,149,177,15,63,252,249,103,198,156,78,85,165,102,10,78,78,167,147,177,216,216,173,91,31,123,12,164,44,244,
175,104,17,0,223,255,241,71,234,28,150,183,129,111,217,146,124,8,232,70,62,245,20,118,134,40,50,22,18,18,27,91,169,82,133,10,200,55,66,66,158,121,230,236,217,239,190,11,14,166,253,211,184,241,59,239,44,
94,60,114,164,219,141,96,89,126,138,16,33,88,211,100,25,252,4,135,3,48,16,146,86,69,161,217,198,58,117,6,15,94,176,96,250,244,22,45,176,184,24,139,141,157,51,231,242,229,1,3,194,195,21,133,49,183,59,50,
50,54,54,49,49,58,26,223,203,229,98,204,227,89,184,16,87,76,89,202,166,77,17,17,176,212,166,233,31,170,47,142,29,155,48,1,247,14,78,233,130,128,102,151,166,49,230,118,207,155,247,198,27,14,7,98,90,217,
12,140,177,38,77,242,242,0,95,253,45,11,192,14,100,130,16,30,30,8,52,110,76,89,51,190,28,18,21,73,146,229,167,158,218,176,33,38,6,237,14,85,85,85,160,227,170,138,230,145,166,101,101,97,26,160,236,3,82,
213,199,30,35,6,18,105,236,188,249,166,166,97,143,186,92,140,185,221,14,135,32,184,92,8,204,138,226,241,124,242,201,141,27,19,38,8,66,72,200,199,31,19,243,254,234,85,219,184,161,252,152,11,181,113,64,
65,161,142,37,118,40,226,215,163,143,102,101,113,238,243,113,110,24,83,167,58,157,178,252,220,115,69,69,139,22,69,69,81,147,87,16,52,141,90,218,4,206,198,196,224,112,161,84,215,178,46,94,140,142,86,85,
204,63,226,112,1,116,251,233,167,75,151,18,246,232,116,2,58,162,54,184,44,183,106,245,203,47,245,234,65,160,247,206,17,184,95,127,29,63,190,52,209,229,47,93,0,248,170,152,102,19,4,198,38,76,56,124,152,
26,63,54,102,134,210,46,58,122,195,134,129,3,41,107,192,151,164,17,112,81,148,229,186,117,51,51,177,191,74,7,57,85,189,247,94,32,117,64,14,253,126,206,159,125,214,227,97,204,237,70,250,73,49,198,233,164,
238,57,99,173,90,237,218,117,225,194,135,31,34,59,199,241,113,238,92,189,122,119,74,58,129,192,66,102,15,36,48,139,111,0,150,131,32,52,106,116,241,34,150,32,186,148,115,230,164,165,237,219,215,180,41,
99,78,39,37,172,212,178,150,101,69,193,183,138,140,116,185,150,47,167,204,0,226,179,39,78,68,70,2,190,85,20,240,134,52,141,177,167,159,190,116,41,36,36,40,8,236,8,28,12,184,67,78,39,99,145,145,169,169,
195,134,217,199,88,217,18,180,113,227,27,55,80,74,150,39,187,252,69,11,128,38,231,177,4,130,130,142,28,233,218,21,25,55,49,252,168,209,202,88,187,118,91,182,84,175,142,211,141,202,25,74,24,21,69,16,6,
13,218,182,45,49,177,116,50,131,211,241,234,85,48,101,81,31,223,188,153,156,140,229,38,203,8,125,148,75,219,140,3,198,24,107,218,148,115,175,23,153,57,230,9,222,122,11,231,100,233,20,80,20,37,41,46,174,
101,203,46,93,218,181,139,139,195,251,160,250,64,201,167,105,130,48,96,0,178,124,203,2,224,196,249,195,15,83,198,230,64,229,0,0,32,0,73,68,65,84,115,10,72,8,113,123,75,147,199,24,115,58,199,141,179,53,
208,76,147,243,137,19,157,78,123,78,2,157,190,38,77,246,239,239,222,93,211,74,171,34,160,153,14,191,212,1,3,118,238,140,136,16,4,36,216,246,166,66,254,178,118,237,192,129,68,200,253,91,142,0,154,215,165,
153,181,71,31,61,112,128,200,11,184,36,26,255,146,101,198,190,252,114,222,60,180,50,36,9,98,7,120,13,202,55,183,251,243,207,231,205,211,52,164,58,104,177,138,162,36,245,239,111,247,208,139,138,78,157,
26,59,182,180,174,31,21,126,248,95,240,118,4,65,16,106,212,32,177,55,93,7,216,52,107,22,144,68,202,193,177,104,90,180,216,184,241,214,45,206,111,222,220,190,189,91,55,4,101,10,205,96,37,130,252,5,180,
143,108,238,105,78,186,244,60,34,193,184,212,146,141,142,94,189,250,234,85,187,10,216,182,173,70,13,156,249,184,70,81,20,69,143,103,229,202,87,94,177,151,19,241,5,177,60,24,75,76,60,119,174,121,115,146,
213,3,2,0,180,67,81,24,123,246,217,93,187,194,195,49,74,94,62,63,248,203,144,192,210,221,63,135,195,227,217,184,113,208,32,251,180,45,189,215,24,139,140,188,124,185,95,63,180,82,41,153,66,227,22,136,87,
84,212,134,13,83,167,98,69,211,248,168,166,105,90,187,118,179,102,157,57,115,254,252,220,185,143,61,214,166,205,150,45,115,231,42,74,104,232,204,153,107,214,172,88,241,250,235,225,225,229,11,36,85,21,
4,183,27,189,53,96,133,134,17,8,156,61,251,226,139,21,43,150,150,188,21,197,170,85,179,178,108,133,160,107,215,238,189,215,158,239,97,140,177,154,53,159,122,234,244,105,164,161,228,38,196,121,133,10,165,
191,61,120,16,140,105,90,215,174,159,127,190,113,227,138,21,221,186,49,118,207,61,39,79,78,156,152,156,60,118,236,254,253,89,89,155,54,141,26,149,152,136,99,6,224,25,234,167,41,83,230,205,11,13,37,206,
177,253,174,84,38,238,220,137,161,82,59,190,217,106,229,49,49,171,87,247,238,141,237,247,71,26,192,127,74,4,184,19,23,236,220,121,231,206,196,196,242,167,21,93,122,189,122,129,64,66,2,96,30,74,121,104,
144,82,16,24,171,83,39,61,189,79,31,26,252,4,74,166,105,200,246,163,162,194,194,24,147,164,224,224,221,187,15,31,222,185,211,239,55,77,195,240,249,46,94,108,217,178,252,4,157,170,50,118,252,56,206,94,
203,42,40,224,60,16,88,187,118,201,146,236,236,220,220,229,203,71,140,232,220,57,46,142,49,198,102,205,2,53,131,82,181,25,51,24,99,44,54,182,93,187,15,62,88,178,228,250,245,243,231,231,207,95,180,200,
52,45,171,176,144,138,185,163,71,195,195,239,220,4,140,77,159,158,147,131,158,98,81,209,214,173,121,121,255,250,23,16,196,168,168,216,216,144,16,151,11,57,3,99,46,23,169,150,76,157,186,119,111,80,16,99,
46,87,217,109,69,163,48,147,38,237,217,99,207,44,99,97,224,29,24,83,148,231,159,255,241,199,176,48,69,129,176,206,239,239,255,221,149,5,160,170,30,207,143,63,190,244,82,217,138,181,52,247,102,202,148,
163,71,145,208,96,146,151,6,162,37,73,150,157,78,198,90,182,44,44,236,213,139,82,51,16,188,168,112,164,225,74,198,114,114,56,55,140,146,18,93,247,249,56,63,121,18,64,104,233,242,78,85,159,121,166,180,
254,215,206,157,241,241,140,49,86,165,202,83,79,77,159,190,113,99,126,190,223,127,230,12,0,105,208,52,56,231,252,250,245,19,39,2,1,191,127,221,186,207,62,235,211,167,122,117,65,16,197,248,248,29,59,112,
152,152,166,215,203,121,207,158,229,191,181,40,50,246,242,203,197,197,156,123,189,84,173,140,31,79,140,104,196,19,64,208,130,128,249,64,69,97,236,243,207,115,115,227,226,168,123,81,182,248,149,36,65,104,
215,46,63,63,34,130,230,10,196,255,255,7,73,100,124,252,150,45,221,187,147,162,202,223,116,4,220,137,10,168,42,99,109,219,238,218,85,189,122,89,254,45,214,176,32,68,69,49,182,117,235,212,169,118,171,8,
184,0,13,100,59,157,140,181,109,155,159,223,173,27,165,134,32,131,225,181,228,167,215,160,1,2,59,101,230,37,37,176,114,176,203,35,220,196,55,222,184,120,177,168,200,239,191,121,243,232,209,182,109,81,
70,217,225,93,150,235,213,203,204,228,220,239,215,117,195,192,18,56,127,190,71,15,170,10,108,113,155,123,239,221,191,63,47,207,231,187,117,235,202,149,55,222,40,175,190,193,152,162,132,132,172,90,197,
121,113,49,178,13,206,117,125,199,14,234,244,83,93,32,203,162,232,116,58,28,146,228,116,50,54,124,248,137,19,49,49,0,166,203,23,191,146,164,170,21,42,28,62,220,183,47,29,142,118,103,2,117,142,44,191,249,
230,186,117,8,252,160,182,252,35,142,0,90,239,223,126,251,245,215,101,131,50,18,27,224,234,73,73,71,143,246,232,129,100,6,92,56,136,31,137,34,28,67,24,123,240,193,35,71,218,183,39,165,31,34,58,210,78,
97,108,240,96,210,204,164,36,239,155,111,202,202,37,97,136,157,177,170,85,95,122,105,194,132,135,31,166,220,220,134,167,113,51,23,44,64,75,89,215,145,232,205,155,231,118,19,218,143,34,23,205,174,160,160,
94,189,222,122,235,165,151,18,19,201,119,168,236,126,13,15,95,179,134,174,135,232,94,88,0,68,104,181,59,244,78,39,99,3,6,236,221,91,177,162,203,37,203,154,86,158,195,139,185,129,47,190,248,228,19,167,
211,6,120,72,15,25,139,161,70,141,11,23,72,171,204,238,253,253,229,101,224,157,69,33,110,123,104,104,70,6,233,87,216,255,160,58,144,101,81,236,221,123,223,190,26,53,168,117,73,93,115,42,15,101,153,177,
46,93,54,109,122,240,65,198,60,158,182,109,219,182,133,26,22,53,113,24,123,226,9,18,124,198,92,142,97,124,240,1,33,8,165,199,216,108,40,152,68,33,108,181,96,92,243,125,247,149,148,32,69,52,12,206,125,
190,238,221,209,110,197,130,37,61,36,68,20,18,113,41,45,42,65,172,221,224,224,159,127,134,116,59,186,121,186,126,253,58,5,110,194,73,234,215,111,211,230,193,7,29,14,198,6,14,92,179,38,37,5,56,36,117,39,
202,118,65,6,12,216,188,57,33,129,168,182,165,197,241,100,89,20,53,109,243,230,177,99,169,156,68,209,253,183,0,65,119,230,0,104,6,49,246,240,195,57,57,193,193,200,3,236,18,199,230,10,206,156,137,241,38,
64,70,180,16,168,67,160,170,162,248,200,35,235,214,125,254,249,129,3,87,174,100,101,157,63,191,116,105,76,12,110,168,166,49,22,17,1,106,165,101,65,121,148,243,133,11,137,49,88,183,238,204,153,203,150,
77,155,214,184,49,245,253,48,114,133,202,4,71,13,226,148,170,74,146,195,49,96,0,209,185,44,107,216,48,167,19,153,12,138,88,74,68,75,247,4,240,183,131,7,79,155,246,241,199,3,6,80,132,170,83,231,196,9,130,
124,193,248,251,242,75,34,133,129,49,177,120,113,70,70,86,214,229,203,123,247,78,159,126,244,40,58,22,128,209,236,190,3,21,211,41,41,23,46,60,240,0,45,98,90,128,0,183,101,153,177,9,19,182,111,71,193,72,
75,226,143,50,1,255,228,8,96,159,245,170,250,209,71,171,87,227,171,81,227,178,172,208,201,246,237,95,125,5,247,32,210,233,167,242,15,125,114,198,166,79,135,235,47,192,151,197,139,9,169,115,58,25,27,51,
134,110,183,101,113,190,103,79,106,234,137,19,79,62,201,216,144,33,134,225,243,233,186,207,87,84,52,122,180,45,214,0,86,0,229,16,100,53,131,223,86,174,220,175,223,199,31,15,29,26,19,67,48,16,134,61,49,
224,69,122,96,152,110,0,236,124,240,96,73,137,223,239,247,235,250,222,189,205,155,67,65,232,171,175,242,242,144,0,22,23,115,126,225,66,147,38,96,231,225,241,67,14,6,233,232,141,27,111,189,69,154,96,80,
77,6,148,78,243,75,161,161,153,153,47,191,108,183,173,33,74,135,108,68,211,24,235,212,41,59,59,42,202,233,164,37,80,118,222,241,111,94,0,96,169,0,93,191,112,161,87,47,123,48,179,252,185,25,22,118,233,
18,136,143,130,160,170,224,225,106,26,2,38,99,138,82,173,26,134,189,144,232,5,2,156,183,109,139,148,17,35,26,227,198,21,21,233,122,32,96,154,99,198,72,18,99,93,187,94,185,114,246,44,231,37,37,96,220,26,
70,97,33,252,195,144,121,227,112,82,85,65,64,191,45,60,28,241,138,24,187,246,8,7,205,29,218,139,145,70,94,112,152,108,216,128,170,1,116,180,11,23,110,221,218,186,53,38,134,177,42,85,126,253,53,16,40,41,
209,245,131,7,155,53,3,120,3,70,240,251,239,3,143,36,52,115,229,74,210,68,149,36,167,19,197,34,109,19,198,142,28,153,58,149,192,36,234,97,98,96,13,109,166,221,187,71,140,96,44,56,24,215,47,253,73,63,127,
210,17,64,55,78,150,25,107,215,238,252,121,140,68,150,31,181,68,164,168,82,229,218,53,72,178,132,133,5,7,19,1,4,200,30,99,157,58,221,184,1,119,108,132,122,206,63,249,196,86,204,2,231,255,209,71,251,247,
143,138,162,158,185,40,30,63,78,232,63,228,158,55,111,198,13,4,246,167,105,110,55,226,13,1,183,138,130,133,135,48,141,135,128,79,160,86,172,166,85,172,136,142,32,62,83,16,58,118,204,206,182,44,206,139,
138,176,8,56,167,211,88,20,25,107,209,162,127,255,230,205,145,212,186,221,68,250,216,186,21,215,99,89,94,175,97,24,198,175,191,214,172,137,119,164,193,47,135,35,34,34,36,68,146,60,158,5,11,214,173,67,
212,193,61,163,81,59,26,143,127,231,157,239,191,87,20,164,170,255,105,216,255,143,89,193,119,170,7,144,84,179,36,201,242,182,109,75,151,78,158,252,252,243,69,69,94,175,166,65,245,207,150,116,55,140,203,
151,31,121,100,225,194,200,200,136,136,38,77,124,190,99,199,214,174,77,75,115,56,56,15,4,32,205,166,40,154,134,25,120,104,127,96,210,206,239,39,7,242,188,188,229,203,201,91,71,20,69,81,215,147,146,96,
74,71,246,49,225,225,49,49,215,175,11,130,44,123,189,173,91,183,105,19,18,34,73,23,47,110,222,156,150,6,145,250,64,64,215,109,71,96,93,167,219,13,251,69,77,107,217,178,75,151,164,164,75,151,210,210,126,
254,249,198,13,168,10,84,172,24,28,108,89,56,28,160,26,18,8,200,178,174,99,137,237,217,179,103,15,245,67,139,139,201,57,13,106,40,150,37,8,154,230,245,58,157,14,71,100,100,122,58,228,109,56,119,58,91,
182,236,216,177,82,37,175,119,219,182,86,173,226,226,30,124,16,178,22,240,96,98,76,85,161,117,96,154,162,216,161,67,151,46,47,188,96,24,186,238,118,151,148,252,54,59,168,187,200,10,254,247,192,48,84,46,
21,69,16,226,227,55,110,28,50,196,229,66,176,43,251,58,36,47,211,166,217,88,249,161,67,176,97,4,239,189,85,43,48,229,209,79,51,12,206,135,15,183,219,197,56,167,73,203,147,52,6,252,126,202,194,161,37,112,
233,210,253,247,227,219,61,251,44,32,95,206,57,63,120,176,75,23,16,168,144,86,37,36,244,239,255,233,167,239,189,215,161,131,219,109,207,214,57,157,99,198,20,20,208,223,236,218,21,27,139,204,96,234,84,
159,207,48,64,67,67,100,26,57,210,110,34,17,37,21,101,40,210,73,198,62,254,24,25,11,108,99,44,235,216,177,164,36,198,130,130,36,73,81,130,130,222,125,215,158,42,40,42,170,87,207,30,165,135,194,41,201,
202,9,66,197,138,91,182,12,27,134,227,172,116,86,245,15,57,2,72,96,149,30,141,162,8,66,203,150,199,142,181,104,81,30,171,39,248,87,211,46,95,166,121,24,211,228,124,205,154,232,104,234,109,185,221,203,
150,209,109,1,15,0,48,173,93,87,0,18,65,134,12,188,204,254,11,84,228,233,233,91,182,236,223,63,113,98,207,158,249,249,156,251,253,40,211,56,223,188,185,66,5,42,18,219,180,217,191,255,230,77,206,13,227,
250,245,217,179,195,194,144,233,51,246,232,163,5,5,156,91,22,208,127,206,199,143,127,254,249,133,11,207,158,221,190,189,160,128,196,225,1,71,213,173,139,83,26,25,4,13,162,99,228,27,11,245,231,159,105,
1,152,166,223,143,111,2,193,108,198,158,120,194,231,35,235,91,203,226,252,205,55,105,188,182,244,3,118,185,36,73,85,191,250,234,167,159,32,123,65,21,137,36,253,163,22,64,89,220,31,193,116,228,200,35,71,
64,183,64,153,72,68,8,73,146,164,142,29,105,6,144,70,196,186,117,179,187,105,137,137,135,14,81,26,152,147,243,226,139,71,143,254,244,19,164,166,81,251,226,221,128,23,98,49,52,106,116,235,22,30,138,215,
203,121,110,110,219,182,138,210,180,233,132,9,23,46,128,81,160,235,248,156,140,140,246,237,113,24,37,36,128,20,74,83,74,147,39,35,95,113,58,167,78,37,158,31,30,181,105,46,95,62,124,120,82,18,99,243,230,
97,73,96,200,51,53,149,166,145,108,68,158,232,92,138,194,88,98,226,153,51,219,182,13,27,6,29,1,206,57,95,190,28,221,16,72,97,207,153,131,207,167,49,185,220,92,143,135,44,95,113,215,136,56,254,214,91,23,
47,218,246,24,229,133,186,255,17,73,96,217,229,224,114,161,200,251,225,135,173,91,73,7,128,52,62,145,225,190,243,14,231,62,159,97,88,86,73,9,118,65,223,190,40,127,80,177,139,226,115,207,173,89,243,243,
207,115,230,212,172,201,88,80,208,119,223,101,102,62,248,160,219,141,154,158,38,248,136,142,225,112,48,214,183,239,169,83,62,95,97,161,223,127,244,40,137,44,50,246,198,27,196,41,66,81,89,84,244,218,107,
149,42,133,134,134,132,60,254,56,102,245,2,1,196,134,221,187,83,82,130,130,130,130,170,87,223,180,9,211,2,246,168,134,173,36,250,253,247,121,121,126,191,207,231,245,46,92,136,153,68,196,45,192,49,84,221,
51,230,116,62,241,68,78,14,24,254,45,90,204,155,183,121,115,106,106,231,206,182,110,161,44,199,196,172,89,195,185,223,79,227,176,186,206,185,199,35,73,30,15,193,217,224,75,49,214,173,91,97,97,84,212,159,
153,247,223,229,5,128,74,27,5,212,193,131,48,137,96,12,106,253,152,242,161,25,32,12,131,99,87,61,241,132,77,205,66,81,68,183,29,75,166,119,239,147,39,39,78,76,74,194,254,193,131,71,101,47,138,120,111,
73,122,236,177,254,253,59,118,68,199,12,69,229,152,49,40,12,65,43,49,140,146,146,139,23,211,210,178,178,86,172,72,79,167,60,163,176,16,215,176,122,245,185,115,233,233,167,78,101,103,211,81,66,49,128,164,
105,29,14,198,26,54,236,211,167,87,175,58,117,24,35,30,15,174,144,52,73,24,147,164,6,13,102,204,56,114,164,83,39,44,87,27,149,36,193,87,77,19,197,168,168,5,11,200,156,14,49,200,239,119,185,240,106,80,
100,177,200,235,213,203,204,236,213,235,207,13,250,119,61,2,128,21,232,116,50,22,17,113,236,24,160,13,219,8,66,150,5,33,62,30,22,45,156,23,23,147,103,16,85,190,116,83,73,224,133,232,147,85,171,46,94,188,
118,237,224,193,30,15,202,57,26,11,199,146,162,219,76,179,191,224,216,212,169,131,1,210,226,98,56,7,30,62,92,165,10,99,146,84,185,50,2,176,101,249,253,136,2,156,183,109,155,144,192,24,99,253,251,195,76,
194,48,144,159,172,93,75,98,207,165,27,74,182,180,13,38,1,200,167,48,46,238,141,55,126,249,229,227,143,43,86,4,120,99,247,67,109,146,12,30,243,11,47,112,30,8,4,2,150,133,142,196,215,95,99,228,163,180,
67,96,98,226,222,189,144,140,249,253,50,240,127,227,2,128,181,59,214,113,211,166,199,142,245,236,9,244,13,131,23,0,104,95,127,29,9,30,0,221,115,231,122,244,32,133,97,4,84,249,255,251,129,65,58,65,186,
93,187,174,91,183,106,85,219,182,4,204,130,81,68,250,3,164,156,69,142,4,130,192,216,140,25,54,115,223,48,158,123,142,234,253,199,30,195,233,139,155,207,249,190,125,149,42,1,237,143,138,74,77,181,231,248,
114,115,27,55,70,214,1,46,31,206,104,224,242,196,7,130,58,10,99,146,212,175,223,142,29,115,230,180,110,77,115,132,244,216,75,207,26,32,15,210,180,111,190,41,44,36,83,45,206,143,30,173,95,159,120,137,212,
42,139,140,92,184,112,210,164,176,48,162,215,253,47,58,2,104,221,51,38,73,15,63,252,235,175,201,201,165,29,174,220,110,198,156,206,62,125,246,239,231,220,52,211,210,30,121,228,129,7,14,28,24,48,128,148,
131,16,244,73,82,6,168,29,78,89,65,136,137,233,217,243,224,193,141,27,171,84,65,248,7,47,207,30,199,34,216,148,186,111,30,207,83,79,29,57,130,130,174,99,71,188,218,225,144,229,10,21,118,238,164,169,3,
206,77,243,229,151,129,71,98,210,225,253,247,139,138,56,47,40,248,254,251,22,45,72,57,12,125,125,106,25,83,155,23,209,134,49,81,172,95,127,215,174,13,27,30,126,216,237,198,82,198,103,17,40,132,88,134,
12,192,225,96,108,233,210,173,91,27,55,30,63,30,159,63,127,126,253,250,228,151,66,164,250,224,224,79,63,77,77,141,137,193,247,248,95,21,1,176,87,104,7,48,246,210,75,87,175,210,228,29,200,160,140,121,60,
146,20,20,164,105,30,15,110,111,243,230,121,121,67,134,96,239,146,210,133,44,3,10,165,210,7,231,163,32,68,70,78,156,120,243,230,196,137,52,19,15,49,136,183,223,126,243,205,38,77,192,59,36,217,101,8,210,
57,157,110,183,203,133,78,31,178,118,65,16,197,170,85,183,108,33,141,129,183,222,194,95,145,49,157,211,169,105,154,22,20,68,25,8,216,119,184,130,224,224,78,157,70,142,124,245,213,106,213,104,192,132,177,
106,213,230,205,43,40,120,233,37,140,145,226,234,97,13,69,74,169,56,164,80,184,134,134,30,61,186,113,35,42,25,77,11,13,213,52,204,61,146,88,22,122,17,131,7,159,56,17,17,65,164,179,242,144,250,63,58,2,
148,173,251,101,153,177,25,51,142,29,3,131,15,187,198,158,210,163,146,134,177,6,13,206,159,159,51,39,36,164,180,163,0,177,226,74,191,47,34,67,82,210,15,63,100,103,143,29,27,22,38,73,161,161,246,208,249,
247,223,187,221,148,157,19,77,20,227,229,54,131,145,150,166,32,52,105,242,202,43,207,61,23,25,73,138,61,216,181,184,62,28,49,232,36,216,146,82,200,222,241,179,98,69,84,148,211,153,144,240,241,199,94,239,
196,137,228,234,69,162,153,100,46,5,33,56,32,23,130,32,73,117,235,102,101,77,155,70,13,97,226,83,225,59,130,140,42,8,162,56,112,224,237,219,201,201,36,7,243,159,54,124,254,226,5,80,158,42,162,170,140,
125,244,209,250,245,137,137,84,78,81,3,180,236,193,225,118,47,89,242,203,47,13,27,202,50,240,116,74,3,239,148,110,67,144,111,208,96,254,252,99,199,94,125,117,215,46,206,253,126,178,129,251,225,7,2,97,
41,138,80,255,190,236,85,161,96,43,107,231,136,99,133,172,97,72,153,132,248,196,170,170,170,123,246,128,170,142,196,241,167,159,38,78,60,113,226,211,79,161,90,136,37,100,59,172,209,149,3,250,194,12,195,
115,207,157,62,61,96,128,141,191,10,2,10,63,90,216,224,0,119,239,158,149,85,183,46,185,16,253,145,161,239,127,204,2,160,83,141,177,201,147,15,31,6,175,6,128,230,191,91,2,140,189,245,214,161,67,47,190,
72,10,90,180,131,202,51,140,168,217,194,88,66,194,218,181,32,118,20,21,129,35,224,247,167,164,32,9,179,73,216,119,130,167,56,195,137,109,68,173,44,138,26,165,101,216,96,202,4,100,175,103,79,160,7,40,18,
253,254,64,224,179,207,42,86,36,222,79,233,79,132,146,167,109,156,33,138,140,85,170,244,197,23,91,182,220,119,31,178,122,240,164,168,5,69,10,6,146,36,8,3,7,110,223,14,42,12,78,126,8,195,220,181,45,202,
238,234,15,28,135,77,211,233,124,227,141,101,203,22,47,78,74,226,220,52,33,61,93,86,243,26,59,104,202,148,49,99,122,245,250,254,123,135,195,52,33,132,12,73,153,242,63,129,128,101,41,138,44,103,102,174,
94,13,18,150,166,153,166,44,235,186,170,98,76,13,82,42,104,172,192,103,188,236,85,57,157,40,244,12,3,202,224,156,195,212,10,97,23,69,34,164,108,12,67,215,113,170,199,198,218,130,236,162,168,40,5,5,135,
15,103,103,171,106,32,128,135,135,198,15,34,136,97,64,111,28,73,173,101,221,127,255,178,101,166,249,220,115,59,119,138,34,231,186,46,8,126,63,116,206,101,153,115,93,23,69,89,54,12,203,26,48,224,145,71,
70,141,58,126,156,36,244,45,75,215,101,153,220,83,255,252,159,187,188,0,40,13,10,4,156,206,25,51,214,174,253,250,235,186,117,25,131,97,130,173,121,205,152,32,248,124,30,143,105,50,182,105,211,147,79,234,
122,122,122,251,246,134,161,40,14,135,97,148,254,234,130,192,185,105,42,138,170,90,150,174,27,6,99,178,108,89,164,10,106,89,146,4,1,119,195,128,24,60,196,226,225,232,93,246,170,188,222,218,181,167,77,
59,118,236,216,177,177,99,131,131,33,74,15,232,199,48,76,83,85,53,77,20,13,67,215,69,209,233,148,101,211,52,205,200,200,123,239,133,8,60,188,16,4,193,237,142,140,100,204,52,233,225,115,142,93,107,89,186,
46,138,80,41,71,199,99,252,248,37,75,166,78,125,229,149,140,12,69,145,101,24,222,59,28,152,58,32,15,66,195,80,148,110,221,250,244,25,59,118,223,62,167,147,115,203,18,69,69,193,255,253,175,13,239,255,1,
221,192,255,185,44,68,238,47,8,146,52,126,124,122,122,108,44,48,175,178,240,38,209,48,177,195,186,119,47,40,248,232,35,242,17,44,59,26,141,88,161,105,224,238,12,28,120,243,38,77,16,155,38,231,94,239,161,
67,55,111,110,219,54,106,84,213,170,246,188,111,249,233,96,73,234,214,237,252,121,194,226,210,210,218,180,177,205,107,65,199,64,218,6,122,122,147,38,147,39,31,57,82,88,152,150,102,27,76,91,150,223,127,
237,26,228,114,137,231,131,208,79,218,4,52,56,146,152,120,224,192,47,191,132,133,17,158,1,250,25,213,23,118,225,231,118,63,253,244,133,11,245,235,131,37,5,134,18,190,105,217,225,208,255,101,73,160,45,
38,11,52,112,250,244,204,204,164,36,66,187,75,51,98,1,169,80,211,55,44,108,213,170,189,123,27,55,38,249,214,210,166,108,132,17,32,188,238,222,13,228,14,60,225,149,43,25,83,148,71,31,253,250,235,27,55,
46,93,90,189,250,205,55,239,191,63,33,33,54,54,44,44,56,152,230,115,24,139,137,217,189,27,77,154,162,34,206,57,95,182,44,52,20,203,79,211,156,206,224,224,240,240,168,168,58,117,30,125,244,173,183,54,108,
200,205,77,75,155,62,253,254,251,101,153,177,77,155,176,104,188,94,206,13,131,20,211,137,221,140,224,15,12,4,112,117,112,240,179,207,94,188,8,65,77,98,29,147,53,94,217,209,178,160,160,193,131,243,243,
147,147,81,164,82,254,131,20,242,238,61,126,73,250,47,93,52,255,188,44,0,33,23,230,50,156,115,62,105,82,231,206,3,7,238,223,111,159,199,176,84,41,237,132,3,145,180,87,95,237,221,123,233,210,101,203,78,
156,144,36,72,211,33,176,146,154,120,32,32,73,134,145,146,242,193,7,13,27,6,7,139,98,73,201,250,245,47,190,232,243,169,170,215,203,24,99,149,43,183,106,213,176,97,189,122,97,97,249,249,23,46,20,23,103,
103,23,22,230,228,232,250,173,91,53,107,126,243,13,231,150,5,35,9,203,18,197,126,253,206,157,139,140,148,164,74,149,92,174,232,232,224,224,152,152,42,85,46,95,62,116,232,192,129,157,59,115,115,233,186,
170,85,155,62,189,121,243,200,72,93,191,113,99,215,174,65,131,242,243,37,9,196,20,178,137,129,239,183,105,154,166,203,213,168,209,240,225,49,49,35,71,238,219,7,43,9,184,125,128,252,130,211,95,215,225,
50,30,30,254,230,155,157,58,61,249,228,241,227,200,24,200,251,131,124,209,239,218,1,192,238,250,2,40,155,122,73,146,101,25,70,175,94,35,71,206,158,253,213,87,178,140,108,128,12,83,108,69,65,69,97,140,
243,64,160,73,147,17,35,66,67,183,111,255,242,203,220,92,180,91,188,94,198,100,89,215,225,236,105,154,138,162,235,46,87,235,214,149,42,25,70,94,222,234,213,176,129,66,132,208,117,44,41,143,167,74,149,
10,21,162,162,42,85,170,80,65,85,131,131,189,222,234,213,31,120,192,178,4,65,215,113,250,51,182,96,65,110,174,203,85,82,226,247,103,101,229,229,101,103,159,59,119,253,58,150,17,205,12,226,44,14,14,110,
217,178,86,173,146,146,180,180,157,59,25,115,56,2,1,135,3,126,157,200,65,96,164,197,121,131,6,35,71,198,199,47,89,50,127,254,237,219,120,200,52,226,129,180,148,115,184,140,4,2,140,85,169,50,109,154,166,
61,247,92,78,14,99,138,98,24,88,228,162,248,151,60,22,233,47,252,33,105,41,198,58,118,220,181,235,157,119,136,148,137,208,95,86,164,153,172,214,53,173,93,187,5,11,246,239,239,211,7,143,2,146,72,40,188,
168,111,96,215,244,224,246,56,28,160,164,218,38,147,165,127,194,194,34,35,255,245,47,64,192,186,238,247,131,250,113,223,125,49,49,165,177,1,106,44,209,145,100,79,238,219,19,70,80,49,133,122,48,192,38,
183,27,196,211,47,190,56,116,104,244,104,80,70,108,76,129,178,29,18,160,247,120,96,249,184,99,199,204,153,145,145,212,16,7,112,116,55,195,254,95,142,3,216,143,31,36,7,184,92,108,221,58,103,14,169,252,
150,71,5,232,193,225,12,140,136,104,223,126,239,222,195,135,219,181,35,80,7,163,27,148,122,97,182,200,30,49,33,3,27,135,3,0,48,77,30,161,246,214,52,198,146,147,243,242,208,38,6,199,247,244,105,192,84,
212,177,195,216,58,53,166,237,171,1,238,79,221,58,187,233,68,10,190,140,49,54,126,252,197,139,159,125,86,183,46,121,1,224,161,146,146,58,17,189,101,25,210,115,237,218,93,188,56,118,44,196,109,104,176,
222,198,0,254,175,90,0,182,128,19,212,125,99,98,214,173,219,189,59,40,168,188,68,148,205,51,198,163,19,69,81,12,10,146,164,167,159,190,114,101,243,230,198,141,9,68,66,60,192,67,182,237,104,49,113,140,
229,129,164,140,166,234,108,218,154,44,59,28,83,166,216,99,102,186,62,100,136,44,59,28,110,55,0,33,0,50,182,101,20,246,47,150,3,233,136,209,72,11,252,148,21,69,150,85,85,81,134,14,189,125,251,224,193,
214,173,161,227,13,154,88,249,25,63,219,73,65,85,95,126,185,164,164,103,79,198,4,33,40,8,109,96,92,53,181,146,255,47,91,0,248,106,36,236,206,24,99,223,126,123,251,246,67,15,145,8,99,105,41,52,66,199,36,
9,36,110,178,72,207,204,92,180,168,107,215,176,48,151,11,187,145,142,17,132,104,154,64,194,81,3,196,17,96,46,73,83,65,237,95,146,84,245,131,15,50,51,111,223,206,205,61,125,122,244,232,160,32,144,48,104,
66,95,211,108,241,105,123,136,11,3,171,52,232,70,29,4,196,150,196,196,65,131,142,30,61,113,226,177,199,236,166,151,211,73,15,191,180,160,62,64,101,69,137,141,253,250,235,140,12,56,177,131,11,69,244,120,
85,245,120,238,38,252,251,151,86,1,101,211,64,81,132,241,27,232,206,130,96,24,189,122,77,152,144,154,58,99,198,141,27,146,68,132,107,252,222,48,68,81,81,2,1,206,21,197,52,201,28,210,237,30,54,172,123,
247,235,215,87,173,218,177,35,61,93,215,101,25,206,161,160,104,35,187,134,243,32,231,160,126,3,139,132,209,27,72,94,48,126,231,188,110,221,26,53,124,190,29,59,138,138,104,249,152,166,44,91,22,93,1,50,
113,32,150,64,230,100,217,48,112,253,112,63,244,251,25,11,11,75,78,238,208,161,77,27,175,119,206,156,5,11,240,248,129,74,114,238,112,224,138,24,195,103,75,146,97,56,157,94,175,44,183,110,61,118,108,65,
65,255,254,183,110,225,27,192,134,19,218,201,186,254,251,13,32,255,151,84,1,165,75,27,132,195,64,32,57,121,252,120,143,103,204,152,125,251,72,231,7,182,175,120,104,64,12,237,66,210,178,24,11,15,239,210,
165,125,251,200,200,75,151,182,111,255,249,231,194,66,155,131,47,138,228,85,10,77,115,195,80,20,195,96,140,248,245,112,30,181,44,176,238,237,130,210,52,241,216,76,19,19,14,156,227,243,80,198,162,40,197,
127,23,69,195,144,101,93,135,37,101,141,26,221,187,183,105,35,138,231,207,175,88,177,117,43,212,192,101,25,142,138,116,205,132,96,194,93,144,115,198,220,238,17,35,58,117,90,179,102,242,100,93,7,212,77,
37,112,233,191,249,191,110,1,220,185,28,128,251,233,122,104,232,224,193,125,250,44,90,244,206,59,8,226,216,135,166,137,154,24,177,194,254,43,69,241,251,57,247,120,106,212,184,247,222,135,30,74,72,216,
185,115,238,220,67,135,112,19,101,25,54,150,48,119,181,255,90,20,209,85,128,241,35,231,240,32,6,204,44,138,170,10,22,48,162,0,150,17,30,185,101,193,206,209,48,128,59,56,157,126,63,153,186,62,254,248,179,
207,38,37,109,223,190,105,211,177,99,23,47,2,177,247,251,57,135,44,124,233,239,137,18,80,81,96,85,155,152,184,100,201,149,43,99,199,166,165,97,41,254,205,63,210,223,244,131,154,0,208,168,195,193,216,61,
247,156,58,181,126,125,114,50,121,143,161,83,118,167,81,3,206,82,77,67,98,23,20,212,168,209,248,241,167,79,167,167,143,31,159,148,68,229,25,140,26,9,94,38,221,29,188,43,78,231,210,252,62,198,36,9,20,16,
219,168,141,38,155,109,74,136,109,142,169,170,15,61,180,120,113,73,201,138,21,125,251,38,36,32,167,183,223,175,244,16,186,205,98,192,216,43,92,197,110,220,24,61,26,195,36,127,93,177,247,15,73,2,203,247,
8,72,148,17,115,176,140,125,246,153,207,55,96,0,169,144,226,65,150,165,67,17,13,148,228,220,169,45,220,172,217,55,223,220,186,117,254,252,164,73,77,154,184,92,138,18,20,68,189,121,100,223,120,232,36,78,
5,37,128,135,31,222,179,135,243,226,226,47,191,172,87,143,60,204,108,155,58,26,120,199,164,160,166,105,154,195,81,177,226,35,143,44,92,152,159,127,250,244,235,175,67,207,7,204,2,77,35,39,33,44,187,242,
206,37,64,39,100,185,86,173,109,219,246,236,73,76,44,237,131,240,119,255,252,141,71,0,194,48,166,235,76,83,81,56,15,4,26,53,154,51,231,198,141,215,94,75,79,47,41,145,36,73,130,161,114,217,198,49,90,189,
78,167,97,144,243,175,223,143,14,93,171,86,157,59,119,237,170,105,123,247,30,58,148,150,150,145,81,82,226,245,22,20,224,164,199,100,33,96,86,195,144,164,17,35,38,77,42,41,209,52,195,80,213,243,231,159,
121,230,192,1,156,238,48,193,134,111,137,40,106,154,203,229,118,123,60,85,170,220,123,111,211,166,181,107,159,56,177,110,93,106,106,102,38,99,170,170,235,72,90,69,17,48,47,58,130,148,49,216,135,150,36,
233,186,32,84,168,208,182,237,184,113,169,169,163,71,99,17,234,122,105,30,227,223,247,243,183,45,0,60,10,178,153,70,110,110,154,140,185,92,163,71,183,109,123,224,192,15,63,28,58,196,24,210,51,58,147,237,
36,73,150,117,221,178,84,213,48,236,108,92,150,113,83,163,162,218,182,109,217,178,78,157,219,183,125,190,162,162,75,151,114,114,110,220,200,203,43,40,184,118,173,164,164,160,0,159,221,172,217,206,157,
146,36,8,62,159,166,25,134,44,127,247,221,144,33,69,69,120,140,33,33,145,145,170,26,31,31,28,92,177,162,203,21,17,17,23,23,18,146,147,115,224,192,209,163,91,183,34,85,83,20,178,103,161,60,65,81,12,3,57,
11,217,61,219,201,174,101,133,133,117,233,210,171,151,199,243,246,219,219,183,139,162,101,41,138,174,163,230,249,187,31,255,223,158,4,218,183,0,183,5,75,33,57,121,240,224,218,181,15,30,156,57,243,242,
101,73,146,36,195,0,53,132,48,114,203,178,44,69,193,109,22,4,211,132,133,58,249,21,81,75,169,66,133,74,149,106,213,170,88,49,58,218,233,116,56,44,75,81,28,14,85,45,46,14,4,206,159,79,78,126,250,105,93,
7,230,102,154,130,80,88,248,229,151,183,110,165,164,48,134,73,157,226,98,203,42,42,50,140,43,87,46,95,62,127,62,35,3,75,11,175,71,54,143,20,19,139,211,178,56,151,101,88,205,227,127,169,202,9,4,24,235,
220,249,249,231,67,66,190,252,114,213,42,159,143,115,73,162,165,142,154,228,255,225,8,80,186,252,177,123,94,156,51,102,89,46,87,237,218,47,188,208,177,227,87,95,125,240,1,90,46,104,168,32,211,215,117,
135,3,36,143,210,37,98,217,101,133,247,65,130,230,241,68,68,136,98,88,152,40,122,60,46,87,213,170,126,127,255,254,77,155,50,230,245,58,157,129,0,210,177,201,147,79,159,22,132,139,23,5,225,246,109,175,
215,231,243,249,138,138,16,19,128,218,149,238,204,209,63,150,5,198,19,5,122,80,61,20,197,235,133,109,148,101,221,123,239,232,209,17,17,95,125,181,126,125,110,174,223,79,200,66,249,197,255,255,232,2,248,
239,126,76,51,34,34,63,191,121,243,15,63,84,213,25,51,230,205,195,126,67,134,141,27,77,167,239,127,221,51,163,199,131,24,129,192,109,24,156,59,157,162,56,100,200,228,201,62,159,162,120,189,30,15,231,130,
144,151,215,174,93,90,154,174,171,170,223,143,253,139,232,242,223,181,98,177,188,0,217,88,150,32,168,170,223,175,40,129,0,122,158,150,229,241,76,159,254,228,147,35,70,172,92,153,159,175,235,130,160,40,
212,54,254,39,60,248,191,136,18,246,71,99,131,211,121,235,150,101,237,218,213,164,201,235,175,15,31,126,246,108,183,110,16,98,54,77,211,212,52,198,56,215,52,89,70,234,248,223,201,86,224,60,70,45,161,235,
134,33,8,138,162,235,94,239,186,117,156,107,154,101,121,60,248,237,174,93,151,46,89,150,170,154,102,105,233,248,255,121,115,224,19,176,20,2,1,32,122,178,108,89,149,43,143,31,159,157,205,88,92,220,220,
185,57,57,208,4,50,12,89,70,20,251,39,221,107,73,252,7,46,1,65,8,4,128,238,75,255,167,189,171,9,137,170,11,195,231,158,115,127,102,134,236,170,224,248,51,142,21,82,150,24,184,136,74,180,85,49,132,10,5,
5,17,98,127,139,130,22,110,218,10,45,34,40,90,182,169,141,16,217,162,69,27,33,18,20,50,17,178,133,164,45,202,102,74,103,148,196,210,65,156,193,25,239,255,183,120,56,92,157,50,190,62,136,207,169,243,46,
212,25,117,102,184,247,57,239,121,223,247,26,97,140,112,0,0,5,144,73,68,65,84,121,222,247,176,120,252,225,195,116,186,183,183,171,139,210,108,54,147,193,169,121,140,25,6,130,174,159,57,82,95,255,203,152,
235,162,26,224,121,142,35,203,153,140,231,181,180,32,205,243,188,84,170,183,55,145,128,224,196,52,145,81,192,115,108,189,71,123,30,103,247,176,53,32,160,85,85,93,63,116,168,167,231,214,173,245,245,139,
23,251,250,44,11,254,192,48,120,101,179,240,124,67,177,5,252,240,226,162,6,200,139,178,142,67,233,233,211,231,207,151,151,79,78,142,142,142,141,165,211,148,50,134,202,252,214,23,147,3,4,53,65,104,140,
37,137,82,215,133,6,225,210,165,19,39,234,235,115,185,120,252,209,163,145,17,215,37,164,164,4,101,101,126,144,35,210,204,159,5,177,216,8,24,147,36,203,34,164,161,161,173,173,163,99,231,206,209,209,254,
254,153,25,69,177,44,77,195,240,26,140,174,145,101,112,16,2,0,255,34,69,228,161,23,148,56,160,95,142,30,141,197,154,155,67,161,241,241,199,143,19,9,84,221,54,6,101,133,2,52,172,123,212,239,61,79,211,12,
3,108,3,110,172,227,148,150,214,214,202,242,212,20,74,200,92,108,182,185,50,191,241,53,125,167,191,49,144,197,163,147,39,187,187,171,171,19,137,241,241,225,225,249,121,78,9,81,234,147,71,156,132,218,94,
91,192,54,5,192,198,27,233,175,56,199,97,172,178,178,177,177,189,253,212,169,175,95,239,221,123,254,28,98,44,78,191,128,241,51,77,74,85,213,52,193,0,0,26,142,195,57,55,199,81,20,199,97,204,178,80,61,224,
238,219,182,33,199,130,110,207,39,161,16,72,98,157,227,149,144,10,98,252,19,33,132,236,222,125,227,70,123,251,204,204,224,224,240,240,236,108,54,203,139,68,133,148,210,255,67,246,20,233,22,224,175,230,
205,105,34,162,121,85,13,4,98,177,171,87,155,154,134,134,238,223,127,243,198,182,53,13,183,206,182,41,13,4,114,57,66,84,21,98,113,84,233,209,138,193,24,228,154,132,16,130,249,101,80,21,98,88,68,73,73,
54,139,179,128,209,14,194,87,44,99,148,242,230,17,199,81,85,66,44,75,81,76,147,16,93,239,234,186,126,189,178,242,233,211,7,15,146,201,181,53,74,21,101,125,29,209,135,239,49,54,238,250,219,45,2,216,182,
30,224,231,148,50,86,40,33,245,245,103,207,118,117,149,151,15,12,244,245,197,227,142,131,83,2,64,39,97,117,67,128,233,186,168,37,128,219,247,60,69,81,148,124,94,150,131,65,69,241,188,92,14,100,112,46,
167,105,182,205,24,230,130,104,26,122,123,16,57,248,154,95,219,86,85,69,137,68,142,31,63,115,166,185,249,253,251,155,55,71,70,192,224,171,42,165,40,245,224,113,113,92,209,34,4,128,36,73,18,214,41,78,22,
111,110,238,236,236,236,12,6,223,189,123,253,58,145,88,88,88,94,94,89,49,12,172,188,64,0,148,47,98,112,127,199,118,221,112,184,187,251,194,133,64,192,182,167,167,239,222,157,156,52,77,85,69,53,145,11,
206,29,135,167,109,248,31,93,47,43,11,135,247,238,221,191,255,240,225,138,138,143,31,251,251,135,134,144,173,184,174,44,195,75,112,70,160,120,174,106,145,1,0,89,183,166,153,166,231,5,2,235,235,104,169,
34,132,144,72,164,173,237,216,177,154,26,73,202,100,210,233,249,249,84,106,113,49,153,92,88,216,156,179,163,145,204,182,117,253,206,157,107,215,248,111,22,23,175,92,121,241,66,211,28,71,146,92,23,91,4,
55,93,143,70,171,170,118,237,138,70,171,171,61,175,180,212,52,167,166,94,189,154,152,224,201,159,231,57,14,180,70,96,253,241,252,118,203,246,255,40,15,128,250,31,92,59,86,54,228,35,132,16,18,12,214,213,
69,163,209,104,77,77,36,18,10,133,66,225,240,242,242,231,207,211,211,153,76,60,158,78,167,211,216,24,8,105,109,29,27,195,92,80,69,177,44,69,121,246,236,220,57,126,227,117,189,162,162,161,65,211,26,26,
106,106,234,234,66,161,76,102,121,57,151,75,38,83,169,185,185,84,42,157,198,95,5,2,134,161,170,174,139,30,68,203,2,103,233,235,127,4,0,126,99,12,128,145,179,208,240,121,158,44,67,66,134,161,175,16,93,
49,166,235,59,118,48,22,14,151,149,237,219,23,137,84,86,214,214,170,234,193,131,185,28,99,227,227,134,209,212,212,216,104,219,24,55,43,203,146,180,180,244,246,237,183,111,7,14,84,85,49,70,233,244,180,
109,79,76,88,214,151,47,31,62,172,172,172,174,174,173,25,6,120,68,78,243,240,205,8,149,5,84,27,20,197,117,109,27,21,12,74,139,229,138,22,221,22,224,103,7,133,121,127,97,202,229,23,132,113,219,144,254,
69,163,145,72,48,216,211,19,139,249,42,61,89,38,228,242,229,116,122,117,117,97,97,126,222,39,146,208,193,179,113,77,111,110,215,42,124,167,205,159,173,56,76,38,69,103,220,205,250,95,127,252,156,15,24,
84,19,9,113,93,195,72,36,62,125,114,221,214,214,88,44,159,87,85,72,64,92,119,118,118,100,36,153,212,52,48,140,223,191,219,198,215,46,252,105,171,207,86,28,70,201,95,99,188,104,235,121,132,60,121,178,180,
20,10,49,134,76,130,210,193,193,213,85,69,129,67,255,93,163,24,182,167,49,250,151,64,0,20,15,39,113,178,217,108,246,200,145,80,8,61,69,67,67,183,111,207,205,97,148,83,113,57,240,191,50,6,248,175,145,3,
20,4,28,6,170,218,210,210,209,177,103,15,33,47,95,14,12,204,205,65,34,153,207,243,22,46,1,128,63,236,246,163,227,222,159,225,35,73,166,169,235,140,73,210,202,10,33,193,32,206,41,46,174,42,158,0,192,47,
24,230,242,112,213,30,58,6,93,215,182,85,213,113,40,181,44,69,113,93,85,205,231,11,131,64,1,128,63,196,3,124,79,202,240,244,110,243,247,237,198,214,9,0,8,19,105,160,48,1,0,97,2,0,194,4,0,132,9,0,8,19,
0,16,38,0,32,76,0,64,152,0,128,48,1,0,97,2,0,194,4,0,132,9,0,8,19,0,16,38,0,32,236,87,237,31,192,194,107,94,38,158,81,203,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* Radium_Compressor::radium_256x256x32_transparent_png = (const char*) resource_Radium_Compressor_radium_256x256x32_transparent_png;
const int Radium_Compressor::radium_256x256x32_transparent_pngSize = 42555;



//[EndFile] You can add extra defines here...
//[/EndFile]
